<?php
/*
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */

class File extends PersistentObject {
	public function __construct($ID){
		$this->storage = "File";
		parent::__construct($ID);
	}
	
	public function newAttributes(){
		$A = new stdClass();
		$A->FileDir = "";
		$A->FileName = "";
		$A->FileSize = 0;
		$A->FileMimetype = "";
		$A->FileIsDir = "";
		$A->FileIsWritable = false;
		$A->FileIsReadable = false;
		
		return $A;
	}
	
	function getRelPath(){
		$Path = $this->A->FileDir."/".$this->A->FileName;
		$pAF = str_replace("interface","",dirname($_SERVER["PHP_SELF"]));
		return str_replace($pAF,"./",substr($Path, strpos($Path,$pAF)));
	}
	
	public function download(){
		$this->loadMe();
		if(strpos($this->ID, "specifics") === false) return;
		
		if(strpos(strtolower($this->ID), ".pdf") !== false) 
			header("Content-Type: application/pdf");
		header("Content-Disposition: attachment; filename=\"".basename($this->ID)."\"");
		
		readfile($this->ID);
	}
}
?>