<?php
/*
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class IMAPStorage {
	protected $instance;
	protected $connection;
	private $parsers;
	protected $affectedRowsOnly = false;
	private $encodings = array('7bit', '8bit', 'binary', 'base64', 'quoted-printable', 'other');
	
	private $first = 0;
	private $second = 0;
	
	function __construct(){
		if(!function_exists("imap_open")) return;
		#$this->connection = imap_open("{mail.furtmeier.lan:143}", "hsrechnungen", "vembDLC8");
		$cs = "{mail.furtmeier.lan:143/novalidate-cert}";
		$this->connection = imap_open($cs, "Rainer@Furtmeier.de", "") or die(imap_last_error());
		
		#$list = imap_getmailboxes($this->connection, $cs, "*");
		#echo "<pre style=\"font-size:8px;\">";
		#print_r($list);
		#echo "</pre>";
		#print_r(imap_errors());
		#echo "<br />";
	}
	
	public function setGetAffectedRowsOnly($bool){
		$this->affectedRowsOnly = $bool;
	}
	
	public static function getSI() {
		throw new Exception();
	}
	
	public function renewConnection(){
		throw new Exception();
	}
	
	public static function newSI(){
        $_SESSION["messages"]->addMessage("Updating database connection...");
		$DB = IMAPStorage::getSI();
		$DB->renewConnection();
	}
	
	public function setParser($p){
		$this->parsers = $p;
	}
	
	static function checkForTable($name){
		return false;
	}
	
	function checkMyTable(CIAttributes $CIA){
		throw new Exception();
	}
	
	public function alterTable(CIAttributes $CIA){
		throw new Exception();
	}
	
	private function dropTable($name){
		throw new Exception();
	}
	
	private function decodeBody($body, $encoding) {
		switch ($encoding) {
			case "quoted-printable":
				return imap_qprint($body);
			break;
			
			case "base64":
				return imap_base64($body);
			break;
			
			default:
				return $body;
		}
    }
	
	function loadSingle2($table, $id) {
		$info = imap_fetchstructure($this->connection, $id);
		$A = new stdClass();
		
		$i2 = $this->getMailObj($info);
		#echo "<pre>";
		#print_r($i2);
		#print_r($info);
		#echo "</pre>";
		#echo $this->first."<br />";
		#echo $this->second."<br />";
		#die();
		/*if(isset($info->parts)){
			$t->addRow(array("Diese E-Mail besteht aus mehreren Teilen:"));
			$t->addRow(array($this->parseParts($info->parts)));
		}*/
		/*switch($info->subtype){
			case "PLAIN":
			case "REPORT":
				$body = imap_fetchbody($this->connection, $id, "1");
				$A->body = htmlentities($this->repairEncoding(quoted_printable_decode($body), $info));
			break;
			
			case "HTML":
				$body = imap_fetchbody($this->connection, $id, "1");
				$A->body = utf8_encode(quoted_printable_decode($body));
			break;
			
			case "ALTERNATIVE":
				$body = imap_fetchbody($this->connection, $id, "1");
				$A->body = htmlentities(imap_utf8(quoted_printable_decode($body)));
			break;
			
			default:
				$body = imap_fetchbody($this->connection, $id, "1");
				$A->body = htmlentities(imap_utf8(quoted_printable_decode($body)));
			break;
		}*/
		/*switch($info->subtype){
			case "PLAIN":
			case "REPORT":
			case "MIXED":*/
				$select = ($this->first > 0 ? $this->first."." : "").(($this->second != 0) ? "".$this->second : "");
		
				$body = imap_fetchbody($this->connection, $id,$select);
				$A->body =  $this->decodeBody($body, $this->encodings[$i2->encoding]);
				
				if(strtolower($i2->parameters[0]->attribute) == "charset" AND strtolower($i2->parameters[0]->value) != "utf-8")
					$A->body = $this->fixEuro(utf8_encode($A->body));
					
				if($i2->subtype == "PLAIN") $A->body = "<pre>".wordwrap($A->body,80)."</pre>";
				#if($info->subtype == "MIXED" AND $info->parts[0]->parameters[0]->attribute == "charset" AND strtolower($info->parts[0]->parameters[0]->value) != "utf-8")
				#	$A->body = utf8_encode($A->body);
			/*break;
			case "ALTERNATIVE":
				$body = imap_fetchbody($this->connection, $id, "2");
				$A->body = $this->decodeBody($body, $this->encodings[$info->parts[1]->encoding]);#htmlentities(utf8_encode(quoted_printable_decode($body)));
			
				if($info->parts[1]->parameters[0]->attribute == "charset" AND strtolower($info->parts[1]->parameters[0]->value) != "utf-8")
					$A->body = utf8_encode($A->body);
			break;
		}*/
	
		return $A;
	}

	private function fixEuro($text){
		$text = str_replace("","€", $text);
		return $text;
	}
	
	private function getMailObj($info){
		if($info->subtype == "ALTERNATIVE"){
			$this->first = 0;
			$this->second = 2;
			
			return $info->parts[1];
		}
		
		if($info->subtype == "SIGNED"){
			$this->first = 0;
			$this->second = 1;
			
			return $info->parts[0];
		}
		
		if($info->subtype == "PLAIN" OR $info->subtype == "HTML"){
			$this->first = 0;
			$this->second = 1;
			
			return $info;
		}
		
		if($info->subtype == "MIXED"){
			if($info->parts[0]->subtype == "ALTERNATIVE"){
				$this->first = 1;
				$this->second = 2;
				return $info->parts[0]->parts[1];
			} else {
				$this->first = 0;
				$this->second = 1;
				return $info->parts[0];
			}
		}
			
	}
	
	/*private static function repairEncoding($body, $info){
		
		foreach($info->parameters as $val)
			if($val->attribute == "CHARSET" AND strtolower($val->value) != "utf-8")
				return utf8_encode($body);
		
		return $body;
	}*/
	
	static function createTable(CIAttributes $CIA){
		throw new Exception();
	}

	function saveSingle($table,$keyName,$id,$fields,Attributes $A) {
		throw new Exception();
	}

	function saveSingle2($table, $id, $A) {
		throw new Exception();
	}

	function getTableColumns($forWhat){
		throw new Exception();
	}
	
	function loadMultipleV4(SelectStatement $statement){
		$collector = array();
		$dates = array();
		$resort = false;
		#echo "<pre>";
		#print_r($statement);
		#echo "</pre>";
		if(count($statement->whereFields) > 0){
			$searchString = "";
			foreach($statement->whereFields as $k => $v){
				$searchString .= $statement->whereFields[$k].' "'.$statement->whereValues[$k].'" ';
			}
			$headers = imap_search($this->connection, $searchString);
			$resort = true;
		} else $headers = imap_sort($this->connection, SORTARRIVAL, true);
		
		if($this->affectedRowsOnly) {
			$this->affectedRowsOnly = false;
			return count($headers);
		}
		
		$lower = 0;
		$upper = count($headers);
		if(count($statement->limit) > 0) {
			list($lower, $upper) = split(",", $statement->limit[0]);
			$upper += $lower;
		}
		
		$start = 0;
		$stop = count($headers);
		if(!$resort){
			$start = $lower;
			$stop = $upper;
		}
		if ($headers == false) {
			echo "<pre style=\"font-size:8px;\">";
			print_r(imap_last_error());
			echo "</pre>";
		} else {
		    for ($i = $start; $i < $stop;$i++) {
		    	if(!isset($headers[$i])) continue;
		    	$message = imap_headerinfo($this->connection, $headers[$i]);
		    	
		    	$c = new Mail($headers[$i]);
		    	$A = new stdClass();
		    	
		    	$A->ID = $headers[$i];
		    	$A->subject = isset($message->subject) ? imap_utf8($message->subject) : "(kein Betreff)";
		    	$A->from = imap_utf8($message->fromaddress);
		    	#$A->time = $message->udate;
		    	$A->time = strtotime($message->date);
		    	
		    	$A->deleted = $message->Deleted == "D";
		    	#echo "<pre style=\"font-size:8px;\">";
		    	#print_r($message);
		    	#echo "</pre>";
		        $c->setA($A);
				$collector[] = $c;
		        $dates[] = $message->udate;
		        #$i++;
		    }
		}

		if($resort){
			arsort($dates);
			
			$returnCollector = array();
			$i = 0;
			foreach($dates AS $k => $v){
				if($i < $lower){
					$i++;
					continue;
				}
				if($i >= $upper) break;
				
				$returnCollector[] = $collector[$k];
				$i++;
			}
			
			$collector = $returnCollector;
		}
		
		#echo "<pre style=\"font-size:8px;\">";
		#print_r($dates);
		#echo "</pre>";
		return $collector;
		
	}
	
	function makeNewLine2($table, $A) {
		throw new Exception();
	}
	
	function deleteSingle($table,$keyName,$id){
		throw new Exception();
	}
}

?>
