<?php
/*
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class PersistentObject extends PersistentClass {
	
	protected $customizer;
	
	public function setEchoIDOnNew($bool){
		$this->echoIDOnNew = $bool;
	}
	
	public function customize(){
		try {
			$active = mUserdata::getGlobalSettingValue("activeCustomizer");

			if($active == null) return;

			$this->customizer = new $active();
			$this->customizer->customizeClass($this);
		} catch (ClassNotFoundException $e){

		} catch (TableDoesNotExistException $e){

		} catch (TableDoesNotExistException $e){

		}
	}
	
	public function loadMe(){
	    $this->loadAdapter();
		if($this->A == null) {
			$this->A = $this->Adapter->loadSingle2($this->getClearClass(get_class($this)));
			$n = $this->getClearClass()."ID";
			if(isset($this->A->$n)) $this->ID = $this->A->$n;
			unset($this->A->$n);
		}
	}
	
	function loadMeOrEmpty(){
	    $this->loadAdapter();
		//if($this->A == null) {
			if($this->ID != -1) $this->loadMe();
			if($this->A == null) $this->A = $this->newAttributes();
			$n = $this->getClearClass(get_class($this))."ID";
			unset($this->A->$n);
		//}
	}
	
	function loadMeOrEmptyT(){
	    $this->loadAdapter();
	    
		if($this->ID != -1) $this->loadMeT();
		if($this->A == null) $this->A = $this->newAttributes();
		$n = $this->getClearClass(get_class($this))."ID";
		unset($this->A->$n);
	}
	
	public function setA($A){
		if($this->A == null) {
			$this->A = $A;
			if($this->ID == null) {
				$n = $this->getClearClass(get_class($this))."ID";
				$this->ID = $A->$n;
				unset($A->$n);
			}
			return true;
		} else return false;
	}
	
	function newAttributes(){
		$this->loadAdapter();
		$A = $this->Adapter->getTableColumns($this->getClearClass(get_class($this)));
		$n = $this->getClearClass(get_class($this))."ID";
		$A->$n = -1;
		
		if($this->customizer != null)
			$this->customizer->customizeNewAttributes($this->getClearClass(get_class($this)), $A);
		
		return $A;
	}
	
	function newMe($checkUserData = true, $output = false){
		if($checkUserData) mUserdata::checkRestrictionOrDie("cantCreate".str_replace("GUI","",get_class($this)));
		
	    $this->loadAdapter();
	    if($this->A == null) $this->loadMe();

        $this->ID = $this->Adapter->makeNewLine2($this->getClearClass(get_class($this)), $this->A);
        
        if($output OR $this->echoIDOnNew)
	        if($this->echoIDOnNew) echo $this->ID;
	        else echo "message:GlobalMessages.M003";
        
        return $this->ID;
	}
	
	function forceReload(){
	    $this->loadAdapter();
		$this->A = $this->Adapter->loadSingle2($this->getClearClass(get_class($this)));
	}
	
	function saveMe($checkUserData = true, $output = false){
		if($checkUserData) mUserdata::checkRestrictionOrDie("cantEdit".str_replace("GUI","",get_class($this)));

		$this->loadAdapter();
		$this->Adapter->saveSingle2($this->getClearClass(get_class($this)), clone $this->A);
	    if($output) echo "message:GlobalMessages.M002";
	}
}


?>
