<?php
/*
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class Applications {
	private $apps = array();
	private $icons = array();
	private $activeApp = "nil";
	private $versions = array();
	
	public function scanApplications(){
		$_SESSION["messages"]->startMessage("checking for directory ./applications/: ");
		
		if(is_dir("./applications/")){
			$_SESSION["messages"]->endMessage("found");
			$apps = array();
			$fp = opendir("./applications/");
			while(($file = readdir($fp)) !== false) {
				if(strpos($file, "Application") === false) continue;
				
				$apps[] = $file;
			}
			sort($apps);
				
			foreach($apps as $key => $file){
				
				require "./applications/$file";
				
				$f = explode(".",$file);
				if($f[0]{0} == "-") continue;
				
				$_SESSION["messages"]->startMessage("trying to register application $f[0]: ");
				$f = $f[0];
				$c = new $f;
				$this->apps[$c->registerName()] = $c->registerFolder();
				
				if(method_exists($c,"registerIcon"))
					$this->icons[$c->registerName()] = $c->registerIcon();
				
				if(method_exists($c,"registerVersion"))
					$this->versions[$c->registerName()] = $c->registerVersion();
				
				$_SESSION["messages"]->endMessage("loaded");
				unset($c);
			}
		} else $_SESSION["messages"]->endMessage("not found");
	}
	
	public function getApplicationsList(){
		return $this->apps;
	}
	
	public function numAppsLoaded(){
		return count($this->apps);
	}
	
	public function setActiveApplication($appName){
		$this->activeApp = $appName;
	}
	
	public function getActiveApplication(){
		return $this->activeApp;
	}
	
	public function getApplicationIcon($appName){
		if(array_search($appName,$this->apps) !== false) $appName = array_search($appName,$this->apps);
		return isset($this->icons[$appName]) ? $this->icons[$appName] : "";
	}
	
	public function getRunningVersion(){

		$appCheck = $this->activeApp;
		if(array_search($appCheck,$this->apps) !== false) $appCheck = array_search($appCheck,$this->apps);

		return isset($this->versions[$appCheck]) ? $this->versions[$appCheck] : null;
	}
	
	public function getHTMLOptions(){
		$o = "";
		foreach($this->apps as $key => $value)
			$o .= "<option value=\"$value\">$key</option>";
		return $o;
	}
	
	public function getGDL(){
		$o = "";
		foreach($this->apps as $key => $value)
			$o .= "
			<app value=\"$value\">$key</app>";
		return $o;
	}
}
?>