<?php
 /*
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */

class BackupManagerGUI implements iGUIHTML2 {
	public function getHTML($id){
		if($_SESSION["S"]->isUserAdmin() == "0")
			throw new AccessDeniedException();

		$TB = new HTMLTable(4, "Backup wählen");
		$TB->addColStyle(2, "text-align:right;");
		$TB->setColWidth(2, "80px");
		$TB->setColWidth(3, "20px");
		$TB->setColWidth(4, "20px");

		$gesamt = 0;

		foreach($this->getBackupsList() AS $name => $size){
			$RB = new Button("Backup wiederherstellen","./images/i2/okCatch.png");
			$RB->type("icon");
			$RB->onclick("if(confirm('Sind Sie sicher, dass dieses Backup wiederhergestellt werden soll? Es werden dabei alle Daten in der Datenbank überschrieben!')) ");
			$RB->rmePCR("BackupManager", "", "restoreBackup", "$name", "Popup.displayNamed('BackupManagerGUI','Backup-Manager', transport);");

			$RD = new Button("Backup anzeigen","./images/i2/search.png");
			$RD->type("icon");
			$RD->windowRme("BackupManager", "", "displayBackup", "$name");

			$TB->addRow(array($name,Util::formatByte($size, 2),$RD,$RB));
			$gesamt += $size;
		}

		$TB->addRow("");
		$TB->addRowClass("backgroundColor0");

		$TB->addRow(array("<b>Gesamt:</b>","<b>".Util::formatByte($gesamt,2)."</b>"));
		$TB->addCellStyle(1, "text-align:right");

		return $TB;
	}

	public function displayBackup($name){
		if($_SESSION["S"]->isUserAdmin() == "0")
			throw new AccessDeniedException();

		$html = Util::getBasicHTML("", $name);
		$html = str_replace("</html>","", $html);
		$html = str_replace("</body>","", $html);
		echo "$html<pre>";
		readfile(Util::getRootPath()."system/Backup/$name");
		echo "</pre></body></html>";
		

	}

	private function noBackupButton(){

			$GoAway = new HTMLInput("BackupGoAway", "checkbox");
			$GoAway->id("BackupGoAway");
			$GoAway->style("float:left;margin-right:5px;");

			$BSave = new Button("Einstellung\nspeichern","save");
			$BSave->style("float:right;");
			$BSave->onclick("if($('BackupGoAway').checked) ");
			$BSave->rmePCR("BackupManager", "", "GoAway", "", "Popup.close('','BackupManagerGUI'); contentManager.reloadFrame('contentLeft');");

			return $BSave.$GoAway." <label for=\"BackupGoAway\" style=\"float:none;text-align:left;width:auto;\">Diese Meldung nicht mehr anzeigen, ich erstelle meine Backups selbst.</label>";
	}

	public function getWindow(){
		$F = new File(Util::getRootPath()."system/Backup");

		if(!$F->A("FileIsWritable")){
			$B = new Button("Achtung","restrictions");
			$B->type("icon");
			$B->style("float:left;margin-right:10px;");

			$T = new HTMLTable(1);

			$T->addRow($B."Es können keine Backups von Ihrer Datenbank angelegt werden, da das Verzeichnis /system/Backup nicht durch den Webserver beschreibbar ist.");
			$T->addRow("Machen Sie das Verzeichnis mit einem FTP-Programm beschreibbar. Klicken Sie dazu mit der rechten Maustaste auf das Verzeichnis auf dem Server, wählen Sie \"Eigenschaften\", und geben Sie den Modus 777 an, damit es durch den Besitzer, die Gruppe und alle Anderen les- und schreibbar ist.");

			$BRefresh = new Button("Aktualisieren","refresh");
			$BRefresh->rmePCR("BackupManager", "", "getWindow", "", "Popup.displayNamed('BackupManagerGUI','Backup-Manager',transport);");
			$BRefresh->style("float:right;");
			$T->addRow($BRefresh);

			$T->addRow("");
			$T->addRowClass("backgroundColor0");


			$T->addRow($this->noBackupButton());
			die($T);
		}

		$html = "";

		if(!BackupManagerGUI::checkForTodaysBackup()){
			$T = new HTMLTable(1);

			$BOK = $this->makeBackupOfToday();
			$F = new File(BackupManagerGUI::getNewBackupName());
			$F->loadMe();

			if($BOK === basename(BackupManagerGUI::getNewBackupName()) AND $F->A("FileSize") > 100) {
				$B = new Button("Backup abgeschlossen","okCatch");
				$B->type("icon");
				$B->style("float:left;margin-right:10px;");

				$T->addRow($B."Das Backup wurde erfolgreich abgeschlossen!<br />Die Größe des Backups beträgt ".Util::formatByte($F->A("FileSize"), 2));
				$html .= $T;
			} else {
				$B = new Button("Es ist ein Fehler aufgetreten","stop");
				$B->type("icon");
				$B->style("float:left;margin-right:10px;");

				$T->addRow($B."Beim Erstellen des Backups ist ein Fehler aufgetreten: $BOK");
				$html .= $T;
			}
			$html .= "<script type=\"text/javascript\">contentManager.reloadFrame('contentLeft');</script>";
		}


		$gesamt = 0;
		$data = $this->getBackupsList();

		$i = 0;
		$maxD = 5;
		if(count($data) < $maxD) $maxD = count($data);

		$TF = new HTMLTable(2, "Backups ($maxD/".count($data).")");
		$TF->addColStyle(2, "text-align:right;");
		$TF->setColWidth(2, "80px");

		foreach ($data as $name => $size) {
			if($i < 5){
				if($name == basename(BackupManagerGUI::getNewBackupName())) $name = "<span style=\"color:green;\">$name</span>";
				$TF->addRow(array($name, Util::formatByte($size,2)));
			}
			$i++;
			$gesamt += $size;
		}

		$TF->addRow("");
		$TF->addRowClass("backgroundColor0");

		$TF->addRow(array("<b>Gesamt:</b>","<b>".Util::formatByte($gesamt,2)."</b>"));
		$TF->addCellStyle(1, "text-align:right");

		$TF->addRow(array("Diese Backups können als Admin-Benutzer im Installation-Plugin heruntergeladen und wiederhergestellt werden."));
		$TF->addRowColspan(1, 2);

		$TF->addRow("");
		$TF->addRowClass("backgroundColor0");

		$TF->addRow(array($this->noBackupButton()));
		$TF->addRowColspan(1, 2);

		echo $html.$TF;
	}

	public function deleteOldBackups(){
		$Backups = $this->getBackupsList();
		$i = 0;

		foreach($Backups AS $fileName => $size){
			$i++;

			if($i > 27){
				$F = new File(Util::getRootPath()."system/Backup/".$fileName);
				$F->deleteMe();
			}
		}
	}

	public function getBackupsList(){
		$dir = new DirectoryIterator(dirname(BackupManagerGUI::getNewBackupName()));

		$data = array();
		foreach($dir as $value)
			if (!$value->isDot() AND strpos($value->getFilename(), ".") !== 0)
				$data[$value->getFilename()] = $value->getSize();

		krsort($data);

		return $data;
	}
	
	private static function getNewBackupName(){
		return Util::getRootPath()."system/Backup/".$_SESSION["DBData"]["datab"].".".date("Ymd").".sql";
	}

	public function makeBackupOfToday(){
		$this->deleteOldBackups();

		$F = new File(Util::getRootPath()."system/Backup/.htaccess");
		$F->loadMe();

		if($F->getA() == null){
			file_put_contents($F->getID(), "AuthUserFile ".Util::getRootPath()."system/Backup/.htpasswd
AuthGroupFile /dev/null
AuthName \"Restricted\"
AuthType Basic
<Limit GET>
require valid-user
</Limit>");

			file_put_contents(Util::getRootPath()."system/Backup/.htpasswd", "Restricted:kV.RuW/ox2sc2".mt_rand(0, 20000000));
		}

		require Util::getRootPath()."libraries/PMBP.inc.php";

		$CONF = array();
		$CONF['sql_host'] = $_SESSION["DBData"]["host"];
		$CONF['sql_user'] = $_SESSION["DBData"]["user"];
		$CONF['sql_passwd'] = $_SESSION["DBData"]["password"];
		$CONF['date'] = "d.m.Y";
		$CONF['sql_db'] = $_SESSION["DBData"]["datab"];

		define("PMBP_EXPORT_DIR", Util::getRootPath()."system/Backup/");
		define('PMBP_VERSION',"v.2.1");
		define('PMBP_WEBSITE',"http://www.phpMyBackupPro.net");

		$PMBP_SYS_VAR = array();
		$PMBP_SYS_VAR["except_tables"] = "";

		return PMBP_dump($CONF, $PMBP_SYS_VAR, $_SESSION["DBData"]["datab"], true, true, false, false, "");
	}

	public function restoreBackup($name){
		if($_SESSION["S"]->isUserAdmin() == "0")
			throw new AccessDeniedException();

		require Util::getRootPath()."libraries/PMBP.inc.php";

		$DB = new DBStorageU();
		$con = $DB->getConnection();

		$file = fopen(Util::getRootPath()."system/Backup/$name", "r");

		$return = PMBP_exec_sql($file, $con);

		$Tab = new HTMLTable(2);
		$Tab->setColWidth(1, "120px");
		$Tab->addLV("Tabellen", $return["insertQueries"]);
		$Tab->addLV("Datensätze", $return["tableQueries"]);
		$Tab->addLV("Befehle gesamt", $return["totalqueries"]);
		$Tab->addLV("Zeilen", $return["linenumber"]);
		$Tab->addLV("Fehler", $return["error"]);

		echo $Tab;
	}

	public static function checkForTodaysBackup(){
		$BF = BackupManagerGUI::getNewBackupName();
		$F = new File($BF);
		$F->loadMe();
		return $F->getA() != null;
	}

	public function GoAway(){
		$UD = new mUserdata();
		$UD->setUserdata("noBackupManager", 1);
	}
}
?>
