<?php
/*
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class ExtConn {
	protected $absolutePath;
	protected $paths = array();
	
	protected $currentUser;
	
	protected $errors = array();
	
	function __construct($absolutePathToPhpAppFW){
		if(function_exists("mysqli_connect")) define("PHYNX_MAIN_STORAGE","MySQL");
		else define("PHYNX_MAIN_STORAGE","MySQLo");
		
		if($absolutePathToPhpAppFW{strlen($absolutePathToPhpAppFW) - 1} != "/") $absolutePathToPhpAppFW .= "/";
		
		$this->absolutePath = $absolutePathToPhpAppFW;

		$this->paths[] = $this->absolutePath."classes/backend/Collection.class.php";
		$this->paths[] = $this->absolutePath."classes/backend/Adapter.class.php";
		$this->paths[] = $this->absolutePath."classes/backend/SelectStatement.class.php";
		$this->paths[] = $this->absolutePath."classes/backend/DBStorage.class.php";
		$this->paths[] = $this->absolutePath."classes/backend/DBStorageU.class.php";
		$this->paths[] = $this->absolutePath."classes/backend/Attributes.class.php";
		$this->paths[] = $this->absolutePath."classes/backend/PersistentClass.class.php";
		$this->paths[] = $this->absolutePath."classes/backend/PersistentObject.class.php";
		$this->paths[] = $this->absolutePath."classes/backend/User.class.php";
		$this->paths[] = $this->absolutePath."classes/backend/anyC.class.php";
		$this->paths[] = $this->absolutePath."classes/backend/Session.class.php";
		$this->paths[] = $this->absolutePath."classes/backend/BackgroundPluginState.class.php";
		$this->paths[] = $this->absolutePath."classes/backend/UnpersistentClass.class.php";
		
		$this->paths[] = $this->absolutePath."classes/exceptions/o3AException.class.php";
		$this->paths[] = $this->absolutePath."classes/exceptions/StorageException.class.php";
		$this->paths[] = $this->absolutePath."classes/exceptions/NoDBUserDataException.class.php";
		
		$this->paths[] = $this->absolutePath."classes/toolbox/SysMessages.class.php";
		$this->paths[] = $this->absolutePath."classes/toolbox/PMReflector.class.php";
		$this->paths[] = $this->absolutePath."classes/toolbox/Datum.class.php";
		$this->paths[] = $this->absolutePath."classes/toolbox/Util.class.php";

		$this->paths[] = $this->absolutePath."classes/interfaces/iFileBrowser.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iLDAPExport.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iDesktopLink.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/icontextMenu.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iCloneable.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iDeletable.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iDeletable2.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iRepeatable.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iScrollable.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iNewWithValues.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iGUIHTML2.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iGUIHTMLMP2.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iPluginSpecificRestrictions.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iFPDF.class.php";
		$this->paths[] = $this->absolutePath."classes/interfaces/iXMLExport.class.php";
		
		$this->paths[] = $this->absolutePath."classes/frontend/Users.class.php";
		#$this->paths[] = $this->absolutePath."classes/frontend/UserAttributes.class.php";
		$this->paths[] = $this->absolutePath."classes/frontend/AppPlugins.class.php";
		$this->paths[] = $this->absolutePath."classes/frontend/HTMLGUI.class.php";
		$this->paths[] = $this->absolutePath."classes/frontend/HTML_de_DE.class.php";
		$this->paths[] = $this->absolutePath."classes/frontend/HTML_en_US.class.php";
		
		$this->paths[] = $this->absolutePath."plugins/Userdata/mUserdata.class.php";
		$this->paths[] = $this->absolutePath."plugins/Userdata/Userdata.class.php";
		#$this->paths[] = $this->absolutePath."plugins/Userdata/UserdataAttributes.class.php";
		
		$this->setPaths();
		
		if(!isset($_SESSION)) session_start();
	
		if(isset($_SESSION["S"]) AND !is_object($_SESSION["S"]) AND get_class($_SESSION["S"]) != "Session")
			die($this->getErrorMessage("10"));
		
		if(isset($_SESSION["messages"]) AND !is_object($_SESSION["messages"]) AND get_class($_SESSION["messages"]) != "SysMessages")
			die($this->getErrorMessage("11"));
		
		if(isset($_SESSION["BPS"]) AND !is_object($_SESSION["BPS"]) AND get_class($_SESSION["BPS"]) != "BackgroundPluginState")
			die($this->getErrorMessage("12"));
		
		
		$_SESSION["S"] = new Session();
		$_SESSION["messages"]->startLogging();
		$_SESSION["BPS"] = new BackgroundPluginState();

		$_SESSION["viaInterface"] = true;
	}
	
	function setMySQLData($host, $username, $password, $database){

		$_SESSION["DBData"] = array();
		$_SESSION["DBData"]["host"]		= $host;
		$_SESSION["DBData"]["user"]		= $username;
		$_SESSION["DBData"]["password"] = $password;
		$_SESSION["DBData"]["datab"]	= $database;
	}
	
	function setPaths(){
		foreach($this->paths as $k => $v){
			require_once($v);
			unset($this->paths[$k]);
		}
	}
	
	function getErrors(){
		return $this->errors;
	}
	
	function getLastError(){
		return $this->errors[count($this->errors) - 1];
	}
	
	function getErrorMessage($number){
		switch($number){
			case "10":
				return "\$_SESSION[S] is already in use by your program.";
			break;
			case "11":
				return "\$_SESSION[messages] is already in use by your program.";
			break;
			case "12":
				return "\$_SESSION[BPS] is already in use by your program.";
			break;
			
			case "100":
				return "Username/password unknown";
			break;
			case "101":
				return "No user logged in!";
			break;
			
			default:
				return "Error number unknown";
			break;
		}
	}
	
	function login($username, $password, $isSHA = false){
		#$_SESSION["messages"] = new SysMessages();
		$U = new Users();
		$U = $U->getUser($username, $password, $isSHA);

		if(!is_null($U)){
			$this->currentUser = $U;
			$_SESSION["S"]->setLoggedInUser($U);
			return true;
		} else {
			$this->errors[] = "100";
			return false;
		}
	}
	
	public function cleanUp(){
		if(isset($_SESSION["messages"])) unset($_SESSION["messages"]);
		if(isset($_SESSION["DBData"])) unset($_SESSION["DBData"]);
		if(isset($_SESSION["S"])) unset($_SESSION["S"]);
		if(isset($_SESSION["BPS"])) unset($_SESSION["BPS"]);
	}
}
?>
