<?php
/**
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class UnifiedTable implements iUnifiedTable {
	protected $colWidth = array();
	protected $content = array();
	protected $caption = null;
	protected $numCols = 0;
	protected $colClass = array();
	protected $header = null;

	function __construct($numCols = 0, $caption = null){
		$this->caption = $caption;
		$this->numCols = $numCols;
	}

	public function setColWidth($colNumber, $width){
		$this->colWidth[$colNumber] = $width;
	}

	function setColClass($colNumber, $class){
		$this->colClass[$colNumber] = $class;
	}

	function setCaption($caption){
		$this->caption = $caption;
	}

	function addRow($content){
		if(!is_array($content)) $content = array($content);
		$this->content[] = $content;
	}

	function addHeaderRow($content){
		if(!is_array($content)) $content = array($content);
		$this->header = $content;
	}

	function getAs($mode, $filename = null){
		$E = new $mode($this->numCols, $this->caption);

		foreach($this->content AS $k => $v) {
			unset($this->content[$k]);
			$E->addRow($v);
		}

		foreach($this->colWidth AS $k => $v) $E->setColWidth($k, $v);
		foreach($this->colClass AS $k => $v) $E->setColClass($k, $v);
		if($this->header != null) $E->addHeaderRow($this->header);

		switch($mode){
			case "ExcelExport":
				$E->getExport($filename);
			break;

			case "HTMLTable":
				return $E;
			break;
		}
	}
}
?>
