<?php
/*
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class Users extends anyC {
	function __construct(){
		$this->setCollectionOf("User");
	}

	public function getUser($username, $password, $isSHA = false){
		if($password == ";;;-1;;;") return null;
		
		$this->addAssocV3("username","=",$username);
		if(!$isSHA) $this->addAssocV3("SHApassword","=",sha1($password),"AND","1");
		else $this->addAssocV3("SHApassword","=",$password,"AND","1");
		$this->addAssocV3("password","=",$password,"OR","1");

		$user = $this->getNextEntry();

		if($user != null) return $user;

		try {
			if(isset($_SESSION["viaInterface"]) AND $_SESSION["viaInterface"] and !class_exists("mphynxAltLogin"))
				throw new Exception();
			
			$AL = new mphynxAltLogin();
			$AL->addAssocV3("username","=",$username);
			if(!$isSHA) $AL->addAssocV3("SHApassword","=",sha1($password),"AND","1");
			else $AL->addAssocV3("SHApassword","=",$password,"AND","1");

			return $AL->getNextEntry();

		} catch (Exception $e){
			return null;
		}

	}
	
	protected function doLogin($ps){
		if(!is_array($ps)) parse_str($ps, $p);
		else $p = $ps;
		#if($p["loginPassword"] == ";;;-1;;;") return 0;

		$this->doLogout();

		$_SESSION["DBData"] = $_SESSION["S"]->getDBData();

		try {
			$U = $this->getUser($p["loginUsername"], $p["loginSHAPassword"], true);

			if($U == null) return 0;

			if(get_class($U) == "phynxAltLogin") $p["anwendung"] = $U->A("UserApplication");

			$UA = $U->getA();
			
		} catch (Exception $e){
			if($p["loginUsername"] == "Admin" AND $p["loginSHAPassword"] == "4e7afebcfbae000b22c7c85e5560f89a2a0280b4"){#"Admin"){
				$tu = new User(-1);
				$UA = $tu->newAttributes();
				$UA->name = "Installations-Benutzer";
				$UA->username = "Admin";
				$UA->password = "Admin";
				if($p["loginSprache"] != "default") $UA->language = $p["loginSprache"];
				$UA->isAdmin = 1;
				$U = new User(-1);
				$U->setA($UA);
			} else {
				return -2;
			}
		}
		if($p["loginSprache"] != "default") $U->changeA("language", $p["loginSprache"]);
		if(strtolower($U->getA()->username) != strtolower($p["loginUsername"])) return 0;
		
		$_SESSION["S"]->setLoggedInUser($U);
		$_SESSION["S"]->init($p["anwendung"]);

		
		if($_SESSION["S"]->checkIfUserLoggedIn()) die("Beim Einloggen ist ein Fehler aufgetreten.\nBitte drücken Sie F5 (aktualisieren) und melden Sie sich erneut an.");
		
		
		return 1;
	}
	
	protected function doLogout(){
		$_SESSION["applications"]->setActiveApplication("nil");
		$_SESSION["CurrentAppPlugins"] = null;
		$_SESSION["BPS"] = null;
		$_SESSION["S"]->logoutUser();
	}
	
	public function getListOfUsers(){
		$this->lCV3();
		$users = array();
		while(($U = $this->getNextEntry())){
			$UA = $U->getA();
			$users[] = $UA->username;
		}
		
		return $users;
	}

	public function lostPassword($username){
		$ac = new anyC();
		$ac->setCollectionOf("User");
		$ac->addAssocV3("username", "=", $username);
		$ac->lCV3();

		$U = $ac->getNextEntry();

		if($U == null){
			try {
				$AL = new mphynxAltLogin();
				$AL->addAssocV3("username","=",$username);

				$U = $AL->getNextEntry();

			} catch (Exception $e){
				die("0");
			}
		}

		if($U == null) die("0");

		$Admin = new anyC();
		$Admin->setCollectionOf("User");
		$Admin->addAssocV3("isAdmin", "=", "1");

		$Admin = $Admin->getNextEntry();
		if($Admin == null) die("-1");
		if($Admin->A("UserEmail") == "") die("-1");

		$mail = new htmlMimeMail5();
		$mail->setFrom("phynx@".$_SERVER["HTTP_HOST"]);
		$mail->setSubject("[phynx] Password recovery for user $username");
		$mail->setText(wordwrap("Dear ".$Admin->A("name").",

you received this email because the user '$username' of the phynx framework at $_SERVER[HTTP_HOST] has lost his password and is requesting a new one.

Best regards
	phynx", 80));
		if(!$mail->send(array($Admin->A("UserEmail"))))
			die("-1");

		die("1");
	}
}
?>
