<?php
/*
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class Button {
	
	private $image;
	private $label;
	private $style;
	/*private $isMultiSelection;
	private $pluginRight;
	private $pluginLeftID;
	private $calledPlugin;
	private $calledPluginID;
	private $calledPluginFunction;*/
	private $rme;
	private $onclick;
	private $type = "bigButton";
	private $id;
	private $class = "backgroundColor3";
	private $disabled = false;
	private $mouseOverEffect = true;
	
	function __construct($label, $image = ""){
		$this->image = $image;
		$this->label = $label;
	}
	
	function disabled($bool){
		$this->disabled = $bool;
	}
	
	function id($id){
		$this->id = $id;
	}
	
	function type($type){
		switch($type){
			case "save":
				$this->image = "./images/i2/save.gif";
				
			case "bigButton":
			case "LPBig":
				$this->type = $type;
			break;
			
			case "icon":
				$this->type = $type;
				$this->class = "";
			break;
			
			default:
				die("Button-type $type not available");
			break;
		}
	}
	
	function contextMenu($plugin, $identifier, $title){
		$this->onclick = "contextMenu.start(this, '$plugin','$identifier','$title');";
	}
	
	function style($style){
		$this->style = $style;
	}
	
	function className($class){
		$this->class = $class;
	}

	function select($isMultiSelection, $selectPlugin, $callingPlugin, $callingPluginID, $callingPluginFunction){
		#$this->rme = " contentManager.rightSelection(".($isMultiSelection ? "true" : "false").", '$pluginRight','$pluginLeftID','$calledPlugin','$calledPluginID','$calledPluginFunction');";
		#isMultiSelection, selectPlugin, callingPlugin, callingPluginID, callingPluginFunction
		$this->rme = "contentManager.backupFrame('contentRight','selectionOverlay'); contentManager.rightSelection(".($isMultiSelection ? "true" : "false").", '$selectPlugin','$callingPlugin','$callingPluginID','$callingPluginFunction');";

	}

	function leftSelect($isMultiSelection, $selectPlugin, $callingPlugin, $callingPluginID, $callingPluginFunction){
		$this->rme = " contentManager.backupFrame('contentLeft','selectionOverlay'); contentManager.leftSelection(".($isMultiSelection ? "true" : "false").", '$selectPlugin','$callingPlugin','$callingPluginID','$callingPluginFunction');";
	}

	function customSelect($targtFrame, $callingPluginID, $selectPlugin, $selectJSFunction){
		$this->rme = " contentManager.backupFrame('$targtFrame','selectionOverlay'); contentManager.customSelection('$targtFrame', '$callingPluginID', '$selectPlugin', '$selectJSFunction');";
	}
	
	function rme($targetClass, $targetClassId, $targetMethod, $targetMethodParameters = "", $onSuccessFunction = "", $bps = ""){
		if(is_object($targetClass)) $targetClass = str_replace("GUI","",get_class($targetClass));
		$this->rme = "rme('$targetClass', '$targetClassId', '$targetMethod', Array(".(is_array($targetMethodParameters) ? implode(",",$targetMethodParameters) : "'".$targetMethodParameters."'")."), '$onSuccessFunction', '$bps');";
	}
	
	function rmeP($targetClass, $targetClassId, $targetMethod, $targetMethodParameters = "", $onSuccessFunction = "", $bps = ""){
		$this->rme = "rmeP('$targetClass', '$targetClassId', '$targetMethod', Array(".(is_array($targetMethodParameters) ? implode(",",$targetMethodParameters) : "'".$targetMethodParameters."'")."), '$onSuccessFunction', '$bps');";
	}

	function rmePCR($targetClass, $targetClassId, $targetMethod, $targetMethodParameters = "", $onSuccessFunction = "", $bps = ""){
		$this->rmeP($targetClass, $targetClassId, $targetMethod, $targetMethodParameters, $onSuccessFunction != "" ? addslashes("if(checkResponse(transport)) { ".$onSuccessFunction."}") : $onSuccessFunction, $bps);
	}
	
	function onclick($value){
		$this->onclick = $value;
	}
	
	function windowRme($targetClass, $targetClassId, $targetMethod, $targetMethodParameters = "", $bps = ""){
		$this->rme = "windowWithRme('$targetClass', '$targetClassId', '$targetMethod', Array(".(is_array($targetMethodParameters) ? implode(",",$targetMethodParameters) : "'".$targetMethodParameters."'")."), '$bps');";
		
	}

	function hasMouseOverEffect($bool){
		$this->mouseOverEffect = $bool;
	}
	
	function __toString(){


		if($this->image[0] != "." AND strpos($this->image, ":") === false AND $this->image[0] != "/") $this->image = "./images/navi/$this->image.png";# : $this->image );

		$onclick = $this->onclick != null ? $this->onclick : "";
		#if($this->pluginRight != null) $onclick .= ;
		if($this->rme != null) $onclick .= " ".$this->rme;
		if($this->type == "bigButton" OR $this->type == "LPBig") return "<input ".($this->disabled ? "disabled=\"disabled\"" : "")." ".($this->id ? "id=\"$this->id\" " : "")."onclick=\"$onclick\" type=\"button\" class=\"$this->class ".($this->type == "bigButton" ? "bigButton" : "LPBigButton")."\" style=\"{$this->style}background-image:url(".$this->image.");\" ".($this->type == "bigButton" ? "value" : "title")."=\"$this->label\" />";
		
		if($this->type == "icon") return "<img ".($this->id ? "id=\"$this->id\" " : "")." ".($onclick != "" ? "onclick=\"$onclick\"" : "")." class=\"".($this->mouseOverEffect ? "mouseoverFade" : "")." $this->class\" style=\"{$this->style}\" src=\"".$this->image."\" title=\"$this->label\" />";
		
		if($this->type == "save") return "<input ".($this->id ? "id=\"$this->id\" " : "")." onclick=\"$onclick\" type=\"button\" value=\"$this->label\" style=\"{$this->style}background-image:url(".$this->image.");\" />";
	}
}
?>