<?php
/*
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */

class TempFile {
	
	protected $Attributes;
	protected $ID;
	
	function getID(){
		return $this->ID;
	}
	
	function setID($ID){
		$this->ID = $ID;
	}
	
	function setA($A){
		$this->Attributes = $A;
	}
	
	function newAttributes(){
		$A = new stdClass();
		$A->filename = "";
		$A->filetype = "";
		$A->filesize = 0;
		$A->originalFilename = "";
		
		return $A;
	}
	
	function loadMe(){
		$this->Attributes = $this->newAttributes();
	}
	
	function getA(){
		return $this->Attributes;
	}

	function A($attributeName){
		return $this->Attributes->$attributeName;
	}
	
	function saveMe(){
		#echo $this->Attributes->data;
	}
	
	function deleteMe(){
		unlink($this->Attributes->filename);
		$_SESSION["TempFiles"]->remove($this->ID);
	}
	
	function __construct($id = ""){
		if($id != ""){
			$this->Attributes = $_SESSION["TempFiles"]->get($id)->getA();
			$this->ID = $id;
		}
	}
	/*
	public static function getTempFilename(){
		return tempnam("/tmp/","TempFile_".rand()."_");
	}*/
	
	function parse($newLine, $textSep, $sep, $codepage){
		
		#echo "Speicher start 1: ".Util::formatByte(memory_get_usage(true),2)."<br />";
		
		$win = false;
		if($newLine == "Windows") {
			$newLine = "\r\n";
			$win = true;
		}
		if($newLine == "Unix") $newLine = "\n";

		if($codepage != "UTF-8") $makeUTF = true;
		else $makeUTF = false;
		
		$handle = fopen($this->Attributes->filename, "r");
		$bugger = "";

		while (!feof($handle))
		    $bugger .= fgets($handle, 4096);
		    
		fclose ($handle);
		#echo "Speicher start 3: ".Util::formatByte(memory_get_usage(true),2)."<br />";
		
		if(strpos($bugger, $newLine) === false AND $win){
			echo "Keine Windows-Zeilenumbrüche gefunden, verwende Unix!";
			$newLine = "\n";
			$win = false;
		}
		    
		$line = array();
		$line[0] = array();
		$line[0][0] = "";
		$mode = "outside";
		for($i=0;$i < strlen($bugger);$i++){
			#if($i % 10000 == 0) echo "Speicher $i: ".Util::formatByte(memory_get_usage(true),2)."<br />";
			
			if($i < strlen($bugger)-1)
				$winLine = $bugger[$i].$bugger[$i+1];
			else $winLine = "";
			
			if($mode == "outside" AND $bugger[$i] == $textSep){
				$mode = "inside";
				continue;
			}
			if($mode == "outside" AND ($bugger[$i] == $newLine OR $winLine == $newLine)){
				$line[] = array();
				$line[count($line) - 1][0] = "";
				continue;
			}
			if($mode == "outside" AND $bugger[$i] == $sep){
				$line[count($line) - 1][] = "";
				continue;
			}
			if($mode == "inside" AND $bugger[$i] == $textSep AND $bugger[$i-1] != "\\"){
				$mode = "outside";
				continue;
			}
			if($mode == "inside"){
				$current = count($line) - 1;
				$line[$current][count($line[$current]) - 1] .= $makeUTF ? utf8_encode($bugger[$i]) : $bugger[$i];
			}
		}
		#echo "Speicher ende: ".Util::formatByte(memory_get_usage(true),2)."<br />";
		return $line;
	}
}
?>