<?php 
/**
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */

$texts = array();
$texts["de_DE"] = array();
$texts["de_DE"]["username"] = "Benutzername";
$texts["de_DE"]["password"] = "Passwort";
$texts["de_DE"]["application"] = "Anwendung";
$texts["de_DE"]["login"] = "anmelden";
$texts["de_DE"]["save"] = "Zugangsdaten speichern";
$texts["de_DE"]["sprache"] = "Sprache";
$texts["de_DE"]["optionsImage"] = "Optionen anzeigen";
$texts["de_DE"]["lostPassword"] = "Passwort vergessen?";
$texts["de_DE"]["lostPasswordErrorUser"] = "Bitte geben Sie einen gültigen Benutzernamen ein.";
$texts["de_DE"]["lostPasswordErrorAdmin"] = "Der Administrator kann leider nicht benachrichtigt werden.";
$texts["de_DE"]["lostPasswordOK"] = "Der Administrator wurde benachrichtigt.";

$texts["en_US"] = array();
$texts["en_US"]["username"] = "Username";
$texts["en_US"]["password"] = "Password";
$texts["en_US"]["application"] = "Application";
$texts["en_US"]["login"] = "login";
$texts["en_US"]["save"] = "save login data";
$texts["en_US"]["sprache"] = "Language";
$texts["en_US"]["optionsImage"] = "show options";
$texts["en_US"]["lostPassword"] = "Lost password?";
$texts["en_US"]["lostPasswordErrorUser"] = "Please insert a valid username.";
$texts["en_US"]["lostPasswordErrorAdmin"] = "The administrator can unfortunately not be notified.";
$texts["en_US"]["lostPasswordOK"] = "The administrator has been notified.";

$texts["it_IT"] = array();
$texts["it_IT"]["username"] = "Username";
$texts["it_IT"]["password"] = "Password";
$texts["it_IT"]["application"] = "Applicazione";
$texts["it_IT"]["login"] = "accesso";
$texts["it_IT"]["save"] = "memorizzare i dati";
$texts["it_IT"]["sprache"] = "Lingua";
$texts["it_IT"]["optionsImage"] = "Visualizzare le opzioni";
$texts["it_IT"]["lostPassword"] = "Password persa?";
$texts["it_IT"]["lostPasswordErrorUser"] = "Si prega di inserire un username valido.";
$texts["it_IT"]["lostPasswordErrorAdmin"] = "L'amministratore non può purtroppo essere notificati.";
$texts["it_IT"]["lostPasswordOK"] = "L'amministratore è stato notificato.";

require "./system/connect.php";
$browserLang = Util::lang_getfrombrowser(array("de", "en","it"), "de_DE");

$showApplicationsList = true;
$defaultApplication = "";
$showHelpButton = true;
$showLayoutButton = true;
$showCopyright = true;
#$showDesktopButton = true;

$cssColorsDir = (isset($_COOKIE["phynx_color"]) ? $_COOKIE["phynx_color"] : "standard");

$optionsFile = dirname(__FILE__)."/specifics/phynxOptions.xml";
if(file_exists($optionsFile)){
	$optionsFileContent = file_get_contents($optionsFile);
	$xml = new SimpleXMLElement($optionsFileContent);

	if(isset($xml->HTMLGUI)){
		$showApplicationsList = $xml->HTMLGUI->overlay->options->showApplicationsList["value"] == "true";
		$defaultApplication = $xml->HTMLGUI->overlay->options->showApplicationsList["defaultApplicationIfFalse"];

		$showHelpButton = $xml->HTMLGUI->footer->options->showHelpButton["value"] == "true";
		$showLayoutButton = $xml->HTMLGUI->footer->options->showLayoutButton["value"] == "true";
		$showCopyright = $xml->HTMLGUI->footer->options->showCopyright["value"] == "true";

		if($xml->HTMLGUI->css->options->forceDefaultColor["value"] == "true")
			$cssColorsDir = $xml->HTMLGUI->css->options->forceDefaultColor["defaultColorIfTrue"];
	}
}

if($_SESSION["S"]->checkIfUserLoggedIn() == false) $_SESSION["CurrentAppPlugins"]->scanPlugins();
header('Content-type: application/xml; charset="utf-8"',true);
echo '<?xml version="1.0" encoding="UTF-8"?>
<?xml-stylesheet type="text/xsl" href="./styles/layout.xsl" ?>
<phynx>
	<HTMLGUI>
		<overlay>
			<options>
				<label for="username">'.$texts[$browserLang]["username"].'</label>
				<label for="password">'.$texts[$browserLang]["password"].'</label>
				<label for="application">'.$texts[$browserLang]["application"].'</label>
				<label for="login">'.$texts[$browserLang]["login"].'</label>
				<label for="save">'.$texts[$browserLang]["save"].'</label>
				<label for="optionsImage">'.$texts[$browserLang]["optionsImage"].'</label>
				<label for="lostPassword">'.$texts[$browserLang]["lostPassword"].'</label>
				<label for="lostPasswordErrorUser">'.$texts[$browserLang]["lostPasswordErrorUser"].'</label>
				<label for="lostPasswordErrorAdmin">'.$texts[$browserLang]["lostPasswordErrorAdmin"].'</label>
				<label for="lostPasswordOK">'.$texts[$browserLang]["lostPasswordOK"].'</label>
				
				<label for="isDemo">Für den Demo-Zugang verwenden Sie bitte Max//Max oder Admin//Admin</label>
				<label for="extDemo">Dies ist die erweiterte Demoversion. Sie können sich auch als Mitarbeiter//Mitarbeiter einloggen, um eine für Mitarbeiter angepasste Version von <b>open3A</b> zu sehen.</label>
				
				<isDemo value="'.(strstr($_SERVER["SCRIPT_FILENAME"],"demo") ? "true" : "false").'" />
				<isExtendedDemo value="'.(strstr($_SERVER["SCRIPT_FILENAME"],"demo_all") ? "true" : "false").'" />

				<showApplicationsList value="'.($showApplicationsList ? "true" : "false").'"  defaultApplicationIfFalse="'.$defaultApplication.'" />
			</options>
			
			<languages>
				<lang value="default">'.$texts[$browserLang]["sprache"].'</lang>
				<lang value="de_DE">deutsch</lang>
				<lang value="en_US">english</lang>
				<lang value="it_IT">italiano</lang>
			</languages>
		</overlay>
		
		<applications>'.$_SESSION["applications"]->getGDL().'
		</applications>
		
		<options>
			<isDesktop value="'.((isset($_COOKIE["phynx_layout"]) AND $_COOKIE["phynx_layout"] == "desktop") ? "true" : "false").'" />
		</options>
		
		<stylesheets>
			<css>./styles/standard/overlayBox.css</css>
			<css>./styles/standard/frames.css</css>
			<css>./styles/standard/general.css</css>
			<css>./styles/standard/navigation.css</css>
			<css>./styles/standard/autoCompletion.css</css>
			<css>./styles/standard/contextMenu.css</css>
			<css>./styles/standard/TextEditor.css</css>
			<css>./styles/standard/calendar.css</css>
			<css>./styles/'.$cssColorsDir.'/colors.css</css>
			'.((isset($_COOKIE["phynx_layout"]) AND $_COOKIE["phynx_layout"] == "vertical") ? '<css>./styles/standard/vertical.css</css>' : "").'
			'.((isset($_COOKIE["phynx_layout"]) AND $_COOKIE["phynx_layout"] == "desktop") ? '<css>./styles/standard/desktop.css</css>' : "").'
			'.((isset($_COOKIE["phynx_layout"]) AND $_COOKIE["phynx_layout"] == "fixed") ? '<css>./styles/standard/fixed.css</css>' : "").'
		</stylesheets>
		
		<javascripts>
			<js>./libraries/scriptaculous/prototype.js</js>
			<js>./libraries/scriptaculous/effects.js</js>
			<js>./libraries/scriptaculous/dragdrop.js</js>
			<js>./libraries/scriptaculous/slider.js</js>
			<js>./libraries/scriptaculous/builder.js</js>
			
			<js>./javascript/Observer.js</js>
			<js>./javascript/overlayBox.js</js>
			<js>./javascript/menu.js</js>
			<js>./javascript/autoComplete.js</js>
			<js>./javascript/contextMenu.js</js>
			<js>./javascript/userControl.js</js>
			<js>./javascript/Interface.js</js>
			<js>./javascript/Popup.js</js>
			<js>./javascript/contentManager.js</js>
			<js>./javascript/DesktopLink.js</js>
			<js>./javascript/handler.js</js>
			<js>./javascript/Util.js</js>
			
			<js>./libraries/calendar.js</js>
			<js>./libraries/TextEditor.js</js>
			<js>./libraries/webtoolkit.base64.js</js>
			<js>./libraries/webtoolkit.aim.js</js>
			<js>./libraries/webtoolkit.sha1.js</js>
		</javascripts>
		
		<contentLeft>
			<p>Sie haben JavaScript nicht aktiviert.<br />
			Bitte aktivieren Sie JavaScript, damit diese Anwendung funktioniert.</p>
		</contentLeft>
		
		<footer>
			<options>
				<showHelpButton value="'.($showHelpButton ? "true" : "false").'" />
				<showLayoutButton value="'.($showLayoutButton ? "true" : "false").'" />
				<showCopyright value="'.($showCopyright ? "true" : "false").'" />
			</options>

			<iconLayout>./images/navi/office.png</iconLayout>
			<iconLogout>./images/i2/logout.png</iconLogout>
			<iconHelp>./images/navi/hilfe.png</iconHelp>
			
			<copyright>
				Copyright (C) 2007, 2008, 2009 by <a href="http://www.Furtmeier.IT">Furtmeier Hard- und Software</a>. This program comes with ABSOLUTELY NO WARRANTY; this is free software, and you are welcome to redistribute it under certain conditions; see <a href="gpl.txt">gpl.txt</a> for details.<br />Thanks to the authors of the libraries and icons used by this program. <a href="javascript:loadFrameV2(\'contentRight\',\'Credits\');">View credits.</a>
			</copyright>
		</footer>
	</HTMLGUI>
</phynx>';
?>