/*
 *
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */

var Interface = {
	isDesktop: false,
	
	init: function(){
		if($('wrapperHandler')){
			Interface.isDesktop = true;
			Interface.resizeWrapper();
			Event.observe(window, 'resize', function() {
				Interface.resizeWrapper();
			});
		}
	},
	
	startWrapperDrag: function(){
		$('wrapperTable').style.display = 'none';
	},
	
	stopWrapperDrag: function(){
		$('wrapperTable').style.display = '';
	},
	
	resizeWrapper: function() {
		size = overlayBox.getPageSize(true);
		$('wrapper').style.height = (size[1] - 150)+'px';
	},
	
	translateStatusMessage: function(message, writeToFieldID){
		message = message.replace(/message:/,"");
		message = message.replace(/error:/,"");
		message = message.replace(/alert:/,"");

		eval("var mes = "+message+";");
		
		$(writeToFieldID).update(mes);
	},

	lostPassword: function(){
		if($('loginUsername').value == '') {
			alert($('lostPasswordErrorUser').value);
			return;
		}

		rmeP("Users", -1, "lostPassword", $('loginUsername').value, "if(transport.responseText == '0') alert($('lostPasswordErrorUser').value); if(transport.responseText == '-1') alert($('lostPasswordErrorAdmin').value); if(transport.responseText == '1') alert($('lostPasswordOK').value);");
	}

}

function checkVirtualBox(image, targetFieldId, setValue){
	var s = image.src.search(/notok/);
	
	if(typeof setValue == "undefined") setValue = "null";

	if((s != -1 && setValue == "null") || setValue == "true"){
		image.src = image.src.replace(/notok/,"ok");
		$(targetFieldId).value = "1";
		return;
	} 
	if(s == -1 || setValue == "false"){
		image.src = image.src.replace(/ok/,"notok").replace(/notnot/,"not");
		$(targetFieldId).value = "0";
	}
}

function showHideTBody(what, image){

	while(what.tagName != "TABLE") what = what.parentNode;
	what = what.firstChild;
	while(what.tagName != "TBODY") what = what.nextSibling;
	
	if(what.style.display == "none") {
		what.style.display = "";
		//image.src = image.src.replace(/more/,"less");
	}
	else {
		what.style.display = "none";
		//image.src.replace(/less/,"more");
	}
}

function showMessage(message){
	if(!$("messenger")) {
		alert(message);
		return;
	}
	$('messenger').update(message);

	new Effect.Move("messenger",{x:0, y:0, mode: 'absolute', duration: 0.2});
	new Effect.Move("messenger",{x:-210, y:0, mode: 'absolute', delay:2, duration: 0.2});
}

function focusMe(elem){
	elem.className = "hasFocus";
}

function blurMe(elem){
	elem.className = "";
}