<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class AdresseGUI extends Adresse implements iFPDF, iGUIHTML2 {
	
	protected $gui;
	
	public function __construct($ID){
		parent::__construct($ID);

		$this->gui = new HTMLGUI();
	}
	
	function getHTML($id){
		$forReload = "";
		$displayMode = null;
		$AuftragID = -1;
		
		/*$_SESSION["BPS"]->setActualClass("adressenMode");
		$bpsMode = $_SESSION["BPS"]->getAllProperties();

		if($bpsMode != -1 AND isset($bpsMode["adressenMode"]))
			$mode = $bpsMode["adressenMode"];*/
		
		$bps = $this->getMyBPSData();
		if($bps != -1 AND isset($bps["AuftragID"]))
			$AuftragID = $bps["AuftragID"];

		if($bps != -1 AND isset($bps["displayMode"]))
			$displayMode = $bps["displayMode"];

		$_SESSION["BPS"]->unsetACProperty("AuftragID");
		$_SESSION["BPS"]->unsetACProperty("displayMode");
		
		#if($this->A == null AND $id != -1) $this->loadMe();
		$this->loadMeOrEmpty();
		
		if($id == -1) {
			$this->A = $this->newAttributes();
			$this->A->AuftragID = $AuftragID;
			#if($mode != "") $this->A->type = $mode;

			if($_SESSION["S"]->checkForPlugin("mAdressBuch")){
				$_SESSION["BPS"]->setActualClass("AdressenGUI");
				$collectionBPS = $_SESSION["BPS"]->getAllProperties();

				if($collectionBPS != -1 AND isset($collectionBPS["AdressBuch"])) $this->A->type = "AB".$collectionBPS["AdressBuch"];
			}
			
			$id = $this->newMe(true, false);
			$this->forceReload();

			try {
				$K = new Kunden();
				$K->createKundeToAdresse($id,false);
			} catch(ClassNotFoundException $e) {}

			$forReload = "<script type=\"text/javascript\">lastLoadedLeft = $id; lastLoadedLeftPlugin = 'Adresse';</script>";
/*
			if($mode != "adressenK") {
				$id = $this->newMe(true, false);
				$this->forceReload();
				
				try {
					$K = new Kunden();
					$K->createKundeToAdresse($id,false);
				} catch(ClassNotFoundException $e) {}
				
				$forReload = "<script type=\"text/javascript\">lastLoadedLeft = $id; lastLoadedLeftPlugin = 'Adresse';</script>";
			}*/


		}

		$OptTab = new HTMLTable(1);
		$OptTab->setTableStyle("width:160px;margin:0px;margin-right:-170px;float:right;");

		if($_SESSION["applications"]->getActiveApplication() == "open3A"){
			if($displayMode != null)
				$OptTab->setTableStyle("width:160px;margin:0px;margin-left:-170px;float:left;");

			if(($id == -1 OR $forReload != "") AND $_SESSION["S"]->checkForPlugin("mImport")) {
				$OTBV = new Button("Schnell-\nImport","import");
				$OTBV->rmePCR("importAdresse", "", "getFastImportWindow", "", "Popup.display('Adresse importieren:',transport);");
			
				$OptTab->addRow($OTBV);
				$OptTab->addRowClass("backgroundColor0");

			}
			if($id != -1 AND $_SESSION["S"]->checkForPlugin("Kundenpreise") AND $this->A->AuftragID == -1){
				$ButtonKundenpreise = new Button("Kundenpreise\nfestlegen","package");
				$ButtonKundenpreise->onclick("contentManager.loadFrame('contentLeft','Kunde', -1, 0, 'KundeGUI;AdresseID:$this->ID;action:Kundenpreise');");
				$OptTab->addRow($ButtonKundenpreise);
				$OptTab->addRowClass("backgroundColor0");
			}

		}


		$this->loadMeOrEmpty();

		$gui = $this->gui;
		$gui->insertSpaceAbove("tel");
		$gui->insertSpaceAbove("strasse");
		$gui->insertSpaceAbove("KategorieID");
		$gui->setFormID("AdresseForm");

		$fields = array(
			"AdresseSpracheID",
			"firma",
			"anrede",
			"vorname",
			"nachname",
			"strasse",
			"nr",
			"plz",
			"ort",
			"land",
			"tel",
			"fax",
			"email",
			"mobil",
			"homepage",
			"geb",
			"gebRem",
			"gebRemMail",
			"AuftragID",
			"KategorieID",
			"type",
			"bemerkung");
		if($_SESSION["S"]->checkForPlugin("mLDAP"))
			$fields[] = "exportToLDAP";

		$gui->setShowAttributes($fields);
		
		if($_SESSION["S"]->checkForPlugin("mSprache")) {
			$gui->setLabel("AdresseSpracheID","Sprache (Land)");
			$gui->selectWithCollection("AdresseSpracheID",new mSprache(), "SpracheLandSprache");
			$gui->insertSpaceAbove("firma");
		} else $gui->setType("AdresseSpracheID","hidden");
		
		#$gui->setAttributes($this->A);
		$gui->setObject($this);
		$gui->setName("Adresse");
		
		$gui->setOptions("anrede", array("2","1","3","4"), array("Herr","Frau","keine/Firma", "Familie"));
		$gui->setType("anrede","select");

		$gui->setType("geb","hidden");
		$gui->setType("gebRemMail","hidden");
		$gui->setType("gebRem","hidden");
		$gui->setType("exportToLDAP","checkbox");

		$gui->insertSpaceAbove("exportToLDAP");
		$gui->setFieldDescription("exportToLDAP", "Soll die Adresse auf einen LDAP-Server exportiert werden?");
		
		$gui->setType("AuftragID","hidden");
		$gui->setType("type","hidden");

		$gui->setLabel("plz","PLZ");
		$gui->setLabel("strasse","Straße");
		$gui->setLabel("exportToLDAP","LDAP-Export?");
		
		$gui->useAutoCompletion("plz", ($_SESSION["S"]->checkForPlugin("Postleitzahlen") ? "Postleitzahlen" : "Adressen"));

		$kat = new Kategorien();
		$kat->addAssocV3("type","=",($displayMode != "" ? $displayMode : "1" ));
		$keys = $kat->getArrayWithKeys();
		$keys[] = "0";
		
		$values = $kat->getArrayWithValues();
		$values[] = "bitte auswählen";
		
		$gui->setOptions("KategorieID",$keys,$values);
		$gui->setType("bemerkung","textarea");
		
		$gui->setLabel("KategorieID","Kategorie");
		
		if($AuftragID == -1) $gui->setType("KategorieID","select");
		else {
			$gui->setType("KategorieID","hidden");
			$gui->setType("bemerkung","hidden");
			$gui->setType("tel","hidden");
			$gui->setType("fax","hidden");
			$gui->insertSpaceAbove("email");
			#$gui->setType("email","hidden");
			$gui->setType("homepage","hidden");
			$gui->setType("exportToLDAP","hidden");
			$gui->setType("mobil","hidden");
		}

		switch($displayMode){
			case "auftragsAdresse":
				$gui->setJSEvent("onSave","function() {
					contentManager.loadFrame('contentLeft','Auftrag',{$this->A->AuftragID});
					contentManager.loadFrame('contentRight','Auftraege');
				}");
			break;

			case "lieferAdresse":
				$this->A->type = "lieferAdresse";
				$gui->setJSEvent("onSave","function() {
					contentManager.loadFrame('contentRight','Auftraege');
					contentManager.loadFrame('subframe','GRLBM',{$this->A->AuftragID});
				}");
			break;
		}

		#if($AuftragID == -1)
		#	$gui->setStandardSaveButton($this, $displayMode != "" ? $displayMode : "Adressen");
		#else
		$gui->setStandardSaveButton($this, "Adressen");
		
		$gui->customize($this->customizer);
		
		if($_SESSION["S"]->checkForPlugin("Kunden") AND $this->A->AuftragID == -1/* AND $displayMode != "mLieferant"*/){
			$_SESSION["BPS"]->registerClass("KundeGUI");
			$_SESSION["BPS"]->setACProperty("AdresseID",$this->ID);
			$_SESSION["BPS"]->setACProperty("action","Kappendix");
			$_SESSION["BPS"]->setACProperty("mode","short");
			
			$KG = new KundeGUI(-1);
			return $forReload.$OptTab.$gui->getEditHTML()."<div style=\"height:30px;\"></div>".$KG->getHTML("","","","");
		}
		return $forReload.$OptTab.$gui->getEditHTML();
	}

	
	public function saveMe($checkUserData = true, $output = false, $deleteBPS = true){
		if($deleteBPS){
			$_SESSION["BPS"]->setActualClass(get_class($this));
			$_SESSION["BPS"]->unsetACProperty("edit");
		}
			
		parent::saveMe($checkUserData, $output);
	}
	
	public function getFPDF(FPDF $fpdf){
		$fpdf->addAddress($this);
	}
	
	public function getXML(){
		$xml = parent::getXML();
		$lines = explode("\n",$xml);
		foreach($lines as $k => $v)
			$lines[$k] = str_pad(($k + 1),5, " ", STR_PAD_LEFT).": ";
			
		echo Util::getBasicHTML("<pre class=\"backgroundColor2\" style=\"font-size:9px;float:left;\">".implode("\n",$lines)."</pre><pre class=\"backgroundColor0\" style=\"font-size:9px;margin-left:40px;\">".htmlentities(utf8_decode($xml))."</pre>","XML-Export");
	}
}
?>
