<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class Artikel extends PersistentObject implements iCloneable, iDeletable, iNewWithValues, iScrollable {
	
	public function __construct($id){
		parent::__construct($id);
		#$this->setParser("preis","mArtikelGUI::numberParser");
		#$this->setParser("EK1","mArtikelGUI::numberParser");
		#$this->setParser("EK2","mArtikelGUI::numberParser");
		#$this->setParser("mwst","mArtikelGUI::numberParser");
		
		$this->setParser("preis","Util::CLNumberParserZ");
		#$this->setParser("bruttopreis","Util::CLNumberParserZ");
		$this->setParser("EK1","Util::CLNumberParserZ");
		$this->setParser("EK2","Util::CLNumberParserZ");
		#$this->setParser("mwst","Util::CLNumberParser");
		$this->customize();
	}
	
	public function cloneMe(){
		echo $this->newMe();
	}
	
	public function getA(){
		if($this->A == null) $this->loadMe();
		return $this->A;
	}
	
	public function newAttributes(){
		$A = parent::newAttributes();

		if($this->customizer != null)
			$this->customizer->customizeNewAttributes($this->getClearClass(get_class($this)), $A);
			
		if($_SESSION["S"]->checkForPlugin("mBrutto"))
			$A->isBrutto = "1";
		
		return $A;
	}
	
	public function newMe($checkUserData = true, $output = false){
		if($this->A->isBrutto == "1"){
			$this->A->bruttopreis = Util::CLNumberParserZ($this->A->preis,"store");
			$this->setParser("preis","Util::nothingParser");
			$this->A->preis = $this->A->bruttopreis / (1 + $this->A->mwst / 100);
		}
		
		return parent::newMe($checkUserData, $output);
	}
	
	public function saveMe($checkUserData = true, $output = false){
		
		if($this->A->isBrutto == "1"){
			$this->A->bruttopreis = Util::CLNumberParserZ($this->A->preis,"store");
			$this->setParser("preis","Util::nothingParser");
			$this->A->preis = $this->A->bruttopreis / (1 + $this->A->mwst / 100);
		}
		return parent::saveMe($checkUserData, $output);
	}
	
	protected function addFile($id){
		$F = new File($id);
		$F->loadMe();
		
		$D = new Datei(-1);
		$A = $D->newAttributes();
		
		$A->DateiClass = "Artikel";
		$A->DateiClassID = $this->ID;
		$A->DateiPath = $id;
		$A->DateiName = basename($id);
		$A->DateiSize = $F->getA()->FileSize;
		$A->DateiIsDir = $F->getA()->FileIsDir;
		
		$D->setA($A);
		$D->newMe();
	}
}
?>
