<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class ArtikelGUI extends Artikel implements iGUIHTML2 {
	function getHTML($id){
		$gui = new HTMLGUI();
		$gui->translate($this->loadTranslation());
		
		#if($this->A == null AND $id != -1) $this->loadMe();
		$this->loadMeOrEmpty();

		if($this->A->isBrutto == "1")
			$this->A->preis = Util::CLNumberParserZ($this->A->bruttopreis,"load");
			
		$updateJS = "";
		if($_SESSION["S"]->checkForPlugin("mFile") AND $id == -1){
			$this->A = $this->newAttributes();
			$id = $this->newMe(true, false);
			$this->forceReload();
			$updateJS = "<script type=\"text/javascript\">lastLoadedLeftPlugin = 'Artikel'; lastLoadedLeft = '$id';</script>";
		}
			
		if($_SESSION["S"]->checkForPlugin("mBrutto")){
			$gui->setType("isBrutto","checkbox");
			$gui->setLabel("isBrutto","Bruttopreis?");
			$gui->setFieldDescription("isBrutto","Ist der angegebene Preis ein Bruttopreis?");
			$gui->setLabel("preis","Preis");
		} else {
			$gui->hideAttribute("isBrutto");
		}
			
		$gui->hideAttribute("bruttopreis");
		
		if($_SESSION["S"]->checkForPlugin("mLagerbestand")){

			$Lagerbestand = new mLagerbestand();
			$Lagerbestand->addAssocV3("LagerbestandArtikelID","=",$this->ID);
			$Lagerbestand->addGroupV3("LagerbestandArtikelID");
			$Lagerbestand->setFieldsV3(array("SUM(LagerbestandMenge) AS Summe","COUNT(*) AS Anzahl"));
			$Lagerbestand->lCV3();
			$Lagerbestand = $Lagerbestand->getNextEntry();
			
			
			
			$table = new HTMLTable(1);
			$table->addColStyle(1, "width:150px");
			$table->addRow(array("<input
				onclick=\"rme('mLagerbestand','','setFilter','$this->ID','loadFrameV2(\'contentRight\', \'mLagerbestand\',\'mLagerbestandGUI;returnTo:\'+lastLoadedRightPlugin+\';returnPage:\'+(typeof lastLoadedRightPage == \'undefined\' ? 0 : lastLoadedRightPage));');\"
				type=\"button\"
				class=\"bigButton backgroundColor3\"
				value=\"".$this->texts["Lagerbestand anzeigen"]."\"
				style=\"background-image:url(./open3A/WaWi/WaWi.png); float:right\" />
				
				<input
				onclick=\"loadFrameV2('contentLeft', 'Lagerbestand', 'LagerbestandGUI;ArtikelID:$this->ID;create:true');\"
				type=\"button\"
				class=\"bigButton backgroundColor3\"
				value=\"".$this->texts["Lieferant anlegen"]."\"
				style=\"background-image:url(./images/navi/address.png);\" />"));
			$table->addRow($this->texts["Lagerbestand"].": ".($Lagerbestand != null ? $Lagerbestand->getA()->Summe : 0)." ".(($Lagerbestand != null AND $Lagerbestand->getA()->Summe == "1") ? $this->texts["Stück singular"] : $this->texts["Stück plural"])." ".($Lagerbestand == null ? "(".$this->texts["kein Lieferant"].")" : "(".$Lagerbestand->getA()->Anzahl." ".($Lagerbestand->getA()->Anzahl != 1 ? $this->texts["Lieferanten"] : $this->texts["Lieferant"]).")"));

			#$table->addColStyle(2, "vertical-align:top");
			

		}
		
		#if($id == -1) $this->A = $this->newAttributes();
		
		
		$gui->setObject($this);
		$gui->setName($this->languageClass->getSingular());
		
		$gui->setParser("preis","ArtikelGUI::preisInputParser",array($this->texts["Rechner"]));
		$kat = new Kategorien();
		$kat->addAssocV3("type","=","mwst");
		
		$keys = array();
		$values = $kat->getArrayWithValues();
		for($i=0;$i<count($values);$i++){
			$keys[] = Util::parseFloat("de_DE",str_replace("%","",$values[$i]));
			$values[$i] = Util::CLNumberParser(Util::parseFloat("de_DE",str_replace("%","",$values[$i])),"load")."%";;
		}
		
		#$keys[] = "0";
		#$values[] = $this->texts["bitte auswählen"];
		
		$gui->setOptions("mwst",$keys,$values);
		
		$gui->setType("mwst","select");
		$gui->setType("beschreibung","textarea");
		$gui->setType("KategorieID","select");
		#$gui->setType("bild","image");
		$gui->hideAttribute("bild");
		
		$gui->hideAttribute("lieferantID");
		$gui->hideAttribute("ArtikelID");
	
		$gui->insertSpaceAbove("hideInReport");
		$gui->insertSpaceAbove("EK1");
		$gui->insertSpaceAbove("beschreibung");
		$gui->insertSpaceAbove("gebinde");
		
		if($_SESSION["S"]->checkForPlugin("Berichte"))
			$gui->setType("hideInReport","checkbox");
		else $gui->setType("hideInReport","hidden");
		
		if($_SESSION["S"]->checkForPlugin("mMultiLanguage")){
			$gui->activateFeature("addAnotherLanguageButton", $this, "name");
			$gui->activateFeature("addAnotherLanguageButton", $this, "gebinde");
			$gui->activateFeature("addAnotherLanguageButton", $this, "beschreibung");
		}
		
		$kat = new Kategorien();
		$kat->addAssocV3("type","=","2");
		$keys = $kat->getArrayWithKeys();
		$keys[] = "0";
		
		$values = $kat->getArrayWithValues();
		$values[] = $this->texts["bitte auswählen"];
		
		$gui->setOptions("KategorieID",$keys,$values);
			
		if($_SESSION["S"]->checkForPlugin("mFile")){
			$D = new mDateiGUI();
			$D->classID = $this->ID;
			$D->className = "Artikel";
		}
		
		if($_SESSION["S"]->checkForPlugin("mStaffelpreis")){
			$S = new mStaffelpreisGUI();
			$S->classID = $this->ID;
			$S->className = "Artikel";
		}
		
		if($_SESSION["S"]->checkForPlugin("mShop")){
			$gui->setType("beschreibung","HTMLEditor");
			$gui->hideAttribute("EK1");
			$gui->hideAttribute("EK2");
		}
		
		$gui->customize($this->customizer);
		
		#$gui->setSaveButtonValues(get_parent_class($this), $this->ID, $_SESSION["CurrentAppPlugins"]->isCollectionOf(get_parent_class($this)));
		$gui->setStandardSaveButton($this);
		return $updateJS.(isset($table) ? $table->getHTML() : "").$gui->getEditHTML().($_SESSION["S"]->checkForPlugin("mStaffelpreis") ? "<div style=\"margin-top:20px;\">".$S->getHTML(-1)."</div>" : "").($_SESSION["S"]->checkForPlugin("mFile") ? "<div style=\"margin-top:20px;\">".$D->getHTML(-1, 0)."</div>" : "");
	}
	
	public static function preisInputParser($w, $l, $p){
		return "<img src=\"./images/i2/calc.png\" onclick=\"rme('Artikel','-1','calcBruttoPreis',Array($('preis').value, $('mwst').value),'$(\'preis\').value = transport.responseText;');\" style=\"float:right;\" class=\"mouseoverFade\" title=\"".$p."\" /><input type=\"text\" value=\"$w\" id=\"preis\" style=\"width: 85%;\" name=\"preis\" onblur=\"blurMe(this);\" onfocus=\"focusMe(this);\"/>";
	}

	public function calcBruttoPreis($preis, $mwst){
		$p = Util::parseFloat($_SESSION["S"]->getUserLanguage(), $preis);
		$m = Util::parseFloat($_SESSION["S"]->getUserLanguage(), $mwst);

		$netto = $p / (100 + $m) * 100;

		echo Util::formatCurrency($_SESSION["S"]->getUserLanguage(), $netto, false);
	}
	
	public function addFile($id){
		parent::addFile($id);
		echo "message:GlobalMessages.M002";
	}
}
?>