<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class AuftraegeGUI extends Auftraege implements iGUIHTMLMP2, iAutoCompleteHTML, icontextMenu, iSearchFilter {
	function getHTML($id, $page){
		$gui = new HTMLGUI();
		$gui->VersionCheck("Auftraege");
		
		$pSpecData = mUserdata::getPluginSpecificData("Auftraege");
		
		if(isset($pSpecData["pluginSpecificCanOnlyEditOwn"])) $this->addAssocV3("t3.UserID","=",$_SESSION["S"]->getCurrentUser()->getID());
		foreach($pSpecData as $key => $value) 
			if(strstr($key,"pluginSpecificCanSeeAuftraegeFrom")) $this->addAssocV3("t3.UserID","=",str_replace("pluginSpecificCanSeeAuftraegeFrom","",$key),"OR");
		
			
		$this->addJoinV3("Adresse","AdresseID","=","AdresseID");
		#$this->addJoinV3("GRLBM","AuftragID","=","datum");
		$this->addJoinV3("User","UserID","=","UserID");
		#$this->addJoinV3("User","UserID","=","UserID");
		
		$gui->showFilteredCategoriesWarning($this->filterCategories(),$this->getClearClass());
		
		$gesamt = $this->loadMultiPageMode($id, $page, 0);
		#$gesamt = $this->getTotalNum();
		
		
		$oldType = ($_SESSION["BPS"]->isPropertySet("mGRLBMGUI","type") ? $_SESSION["BPS"]->getProperty("mGRLBMGUI","type") : -1);
		$_SESSION["BPS"]->setProperty("mGRLBMGUI","type","-1");
		
		
		$_SESSION["BPS"]->setActualClass("multiPrintBasketGUI");
		$basketBPS = $_SESSION["BPS"]->getAllProperties();
		
		$this->addOrderV3("auftragDatum","DESC");
		if(isset($pSpecData["pluginSpecificCanOnlyEditOwn"])) $this->addAssocV3("t3.UserID","=",$_SESSION["S"]->getCurrentUser()->getID());
		foreach($pSpecData as $key => $value) 
			if(strstr($key,"pluginSpecificCanSeeAuftraegeFrom")) $this->addAssocV3("t3.UserID","=",str_replace("pluginSpecificCanSeeAuftraegeFrom","",$key),"OR");
		
		#$this->setLimitV3(($page * 20).",20");
		$this->lCV3($id);

		if($id == -1){
			$gui->addRowAfter("1","multiPrint");
			$gui->setParser("multiPrint","AuftraegeGUI::multiPrint");
		}
		$gui->isQuickSearchable(get_parent_class($this));
		
		$gui->setAttributes($this->collector);
		$gui->setMultiPageMode($gesamt, $page, 0, "contentRight", str_replace("GUI","",get_class($this)));
		
		$gui->setName("Auftrag");
		$gui->setCollectionOf("Auftrag","Auftrag");
		$gui->setShowAttributes(array("firma","bezahlt"));
		

		$gui->setParser("auftragDatum","Datum::parseGerDate");
		$gui->setParser("bezahlt","AuftraegeGUI::getPaidImg", array("\$aid",(isset($pSpecData["pluginSpecificCanOnlySeeKalk"]) ? "true" : "false"),(isset($basketBPS["ids"]) ? $basketBPS["ids"] : "")));
		$gui->setParser("firma","AuftraegeGUI::firmaParser",array("\$sc->nachname","\$sc->username","\$sc->vorname"));
		
		$gui->setJSEvent("onNew","function(transport) { reloadRightFrame(); }");

		$html = $gui->getBrowserHTML($id);
		$_SESSION["BPS"]->setProperty("mGRLBMGUI","type","$oldType");
		return $html;
	}
	
	public static function multiPrint(){
		$B = new Button("multiDruck\nListe","liste");
		$B->onclick("contentManager.editInPopup('multiPrintBasket','','multiDruck-Liste');");
		return $B;

		#return "<input type=\"button\" class=\"bigButton backgroundColor3\" style=\"background-image:url(./images/navi/liste.png);\" value=\"\" onclick=\"loadFrameV2('contentLeft', 'multiPrintBasket');\" />";
	}
	
	public static function getPaidImg($w, $l, $p){
		
		$s = HTMLGUI::getArrayFromParametersString($p);

		
		$GRLBMs = new mGRLBMGUI(); //-1 is necessary to tell mGRLBM to load no specific type!
		$GRLBMs->addAssocV3("AuftragID","=",$s[0]);
		$GRLBMs->setFieldsV3(array("GROUP_CONCAT(isR) as isR","GROUP_CONCAT(isL) as isL","GROUP_CONCAT(isA) as isA","GROUP_CONCAT(isG) as isG","GROUP_CONCAT(isWhat) as isWhat","/*GROUP_CONCAT(nummer) as */nummer","/*GROUP_CONCAT(datum) as*/ datum"));
		
		$GRLBMs->addGroupV3("AuftragID");
		if($s[1] == "true") $GRLBMs->addAssocV3("isWhat","=","Kalk");
		$GRLBMs->lCV3();
		
		$t = $GRLBMs->getNextEntry();
		
		if($t != null) {
			$A = $t->getA();
			$Gs = substr_count($A->isG,"1");
			$Rs = substr_count($A->isR,"1");
			$Ls = substr_count($A->isL,"1");
			$As = substr_count($A->isA,"1");
			$Kalks = substr_count($A->isWhat,"Kalk");
			$g = $Gs + $Rs + $Ls + $As + $Kalks;

			if($g == 1){
				if($s[2] == ",,") $s[2] = "";
				$imgs = "<img id=\"addID".$t->getID()."\" style=\"".((!strstr($s[2],",".$t->getID().",") OR $s[2] == "") ? "display:block;":"display:none;")."float:left;\" title=\"zu multiDruck-Liste hinzufügen\" class=\"mouseoverFade\" src=\"./images/i2/notok.gif\" onclick=\"Auftrag.addToMultiPrint('".$t->getID()."');\" />
		<img id=\"subID".$t->getID()."\" style=\"".((!strstr($s[2],",".$t->getID().",") OR $s[2] == "") ? "display:none;":"display:block;")."float:left;\" class=\"mouseoverFade\" title=\"von multiDruck-Liste entfernen\" src=\"./images/i2/ok.gif\" onclick=\"Auftrag.subFromMultiPrint('".$t->getID()."');\" />";
				
				$w = "";
				if($Gs != 0) $w = "G";
				if($Rs != 0) $w = "R";
				if($Ls != 0) $w = "L";
				if($As != 0) $w = "A";
				if($Kalks != 0) $w = "K";
				return "$imgs<strong>".$w.$A->nummer."</strong><br /><small>vom ".$A->datum."</small>";
			}
			
			$html = "<table style=\"text-align:right;width:100%;border:0px;\">
				<colgroup>
					<col style=\"width:20%\" />
					<col style=\"width:20%\" />
					<col style=\"width:20%\" />
					<col style=\"width:20%\" />
					<col style=\"width:20%\" />
				</colgroup>
				<tr>
					<th>A</th>
					<th>L</th>
					<th>R</th>
					<th>G</th>
					<th>K</th>
				</tr>
			<tr>";
			$html .= "<td>".($As != 0 ? $As : " ")."</td>";
			$html .= "<td>".($Ls != 0 ? $Ls : " ")."</td>";
			$html .= "<td>".($Rs != 0 ? $Rs : " ")."</td>";
			$html .= "<td>".($Gs != 0 ? $Gs : " ")."</td>";
			$html .= "<td>".($Kalks != 0 ? $Kalks : "")."</td>";
			$html .= "</tr></table>";
			return $html;
			
		} else
			return "";
	}
	
	public static function firmaParser($w,$l,$p){
		$s = HTMLGUI::getArrayFromParametersString($p);
		return ($w == "" ? stripslashes($s[2]).($s[2] != "" ? " " : "").stripslashes($s[0]) : stripslashes($w)).(isset($s[1]) ? "<br /><small style=\"color:grey;\">von $s[1]</small>" : "");
	}
	
	public static function parseRnr($w,$l,$p){
		if($w != "") return $p."$w";
	}
	
	public function getACHTML($attributeName, $query){
		
		$ASH = new AuftraegeSearchHelper();
		
		$gui = new HTMLGUI();
		if($query{0} == "#" AND isset($query{1}) AND ($query{1} == "R" OR $query{1} == "L" OR $query{1} == "K" OR $query{1} == "A" OR $query{1} == "G")){
			$isWhat = 1;
			$query = str_replace("#","", $query);
			$what = "is".$query{0};
			if($query{0} == "K"){
				$isWhat = "Kalk";
				$what = "isWhat";
			}
			$ASH->addJoinV3("GRLBM",$what,"=",$isWhat);
			
			$gui->setParser("nummer","AuftraegeGUI::parseRnr",array($query{0}));
		}
		
		$ASH->addJoinV3("User","UserID","=","UserID");
		$ASH->addAssocV3("isM","=","0");

			
		switch($attributeName){
			case "quickSearchAuftraege":
				$pSpecData = mUserdata::getPluginSpecificData("Auftraege");
				$ud = new mUserdata();
				$d = $ud->getUDValueCached("auftraegeMinDate");
				$d2 = $ud->getUDValueCached("auftraegeMaxDate");
				
				if(isset($pSpecData["pluginSpecificCanOnlyEditOwn"])) $ASH->addAssocV3("t4.UserID","=",$_SESSION["S"]->getCurrentUser()->getID());
				
				foreach($pSpecData as $key => $value) 
					if(strstr($key,"pluginSpecificCanSeeAuftraegeFrom")) $ASH->addAssocV3("t4.UserID","=",str_replace("pluginSpecificCanSeeAuftraegeFrom","",$key),"OR");
		
				$html = "";
				if($d != null OR $d2 != null) {
					$D = new Datum(time());
					$datum = $D->parseGerDate($d);
					
					$D2 = new Datum(time());
					$datum2 = $D2->parseGerDate($d2);
					
					if($datum != -1 OR $datum2 != -1) {
						if($datum != -1) $ASH->addAssocV3("datum",">=", $datum);
						if($datum2 != -1) $ASH->addAssocV3("datum","<=", $datum2);
						
						$html = "<p style=\"padding:3px;\"><img src=\"./images/i2/note.png\" style=\"float:left;margin-right:3px;\" /> Es werden nur A/L/R/G/K angezeigt, die ".($datum != -1 ? "<strong>ab</strong> dem $d" : "").(($datum != -1 AND $datum2 != -1) ? " und " : "").($datum2 != -1 ? "<strong>vor</strong> dem $d2" : "")." erstellt wurden.</p>";
					}
				}
				
				if($d == null){
						$html = "<p style=\"padding:3px;\"><img src=\"./images/i2/note.png\" style=\"float:left;margin-right:3px;\" /><small>Aus Gründen der Performance werden nur die Aufträge der letzten 6 Wochen durchsucht. Bitte stellen Sie manuell ein Datum ein, um dies zu überschreiben.</small></p>";
						$ASH->addAssocV3("datum",">=", time() - 6 * 7 * 24 * 3600);
				}
				
				if(isset($what)) {
					$ASH->addAssocV3("nummer","LIKE","%".substr($query,1)."%","AND","1");
				} else {
					$ASH->addAssocV3("firma","LIKE","%$query%","AND","1");
					$ASH->addAssocV3("kundennummer","LIKE","%$query%","OR","1");
					$ASH->addAssocV3("nachname","LIKE","%$query%","OR","1");
					
					$q2 = DBStorage::findNonUft8($query);
					$ASH->addAssocV3("firma","LIKE","%$q2%","OR","1");
					$ASH->addAssocV3("kundennummer","LIKE","%$q2%","OR","1");
					$ASH->addAssocV3("nachname","LIKE","%$q2%","OR","1");
				}
				$ASH->addOrderV3("datum","DESC");
				$ASH->lCV3();
				
				$gui->setAttributes($ASH->getCollector());

				$gui->setShowAttributes(array("firma","nummer"));
				
				$gui->setParser("firma","AuftraegeGUI::firmaParser",array("\$sc->nachname","\$sc->username","\$sc->vorname"));
				$gui->setParser("nummer","AuftraegeGUI::nummerParser",array("\$sc->datum"));
				
				$_SESSION["BPS"]->registerClass("HTMLGUI");
				$_SESSION["BPS"]->setACProperty("targetFrame","contentLeft");
				$_SESSION["BPS"]->setACProperty("targetPlugin","Auftrag");
				
				echo $html.$gui->getACHTMLBrowser("quickSearchLoadFrame");
			break;
		}
	}
	
	public static function nummerParser($w, $l, $p){
		return $w."<br /><small>".date("d.m.Y",$p+0)."</small>";
	}
	
	public function getContextMenuHTML($identifier){
		$ud = new mUserdata();
		$d = $ud->getUDValueCached("auftraegeMinDate");
		$d2 = $ud->getUDValueCached("auftraegeMaxDate");
		echo "
		<p style=\"padding:5px;\">
			Nur Einträge <strong>ab</strong> Datum: <input id=\"auftraegeMinDate\" value=\"$d\" type=\"text\" style=\"width:100px;\" /> 
			<input src=\"./images/i2/save.gif\" style=\"width:18px;border:0px;\" onclick=\"rme('mUserdata','','setUserdata',new Array('auftraegeMinDate',$('auftraegeMinDate').value),'showMessage(\'gespeichert\')');\" type=\"image\" />
			<input src=\"./images/i2/delete.gif\" style=\"width:18px;border:0px;\" onclick=\"rme('mUserdata','','delUserdata',new Array('auftraegeMinDate'),'showMessage(\'gelöscht\');$(\'auftraegeMinDate\').value = \'\';');\" type=\"image\" />
		</p>
		<p style=\"padding:5px;\">
			Nur Einträge <strong>bis</strong> Datum: <input id=\"auftraegeMaxDate\" value=\"$d2\" type=\"text\" style=\"width:100px;\" /> 
			<input src=\"./images/i2/save.gif\" style=\"width:18px;border:0px;\" onclick=\"rme('mUserdata','','setUserdata',new Array('auftraegeMaxDate',$('auftraegeMaxDate').value),'showMessage(\'gespeichert\')');\" type=\"image\" />
			<input src=\"./images/i2/delete.gif\" style=\"width:18px;border:0px;\" onclick=\"rme('mUserdata','','delUserdata',new Array('auftraegeMaxDate'),'showMessage(\'gelöscht\');$(\'auftraegeMaxDate\').value = \'\';');\" type=\"image\" />
		</p>
		<p style=\"margin-top:10px;padding:5px;\">Es werden folgende Felder durchsucht:<br /><br />Firma<br />Kundennummer<br />Nachname<br /><br />Um eine Rechnung zu finden, suchen Sie z.B. nach '#R070010'.<br />Lieferschein: '#L...',<br />Gutschein: '#G...',<br />Angebot: '#A...' und<br />Kalkulation: '#K...'</p>
		
		<p><img src=\"./images/i2/searchFilter.png\" style=\"float:left;margin-right:5px;\" /> Das Ergebnis der Filterung nach einem Suchbegriff weicht vom Ergebnis der Schnellsuche ab.";

	}
	
	public function getSearchedFields(){
		return array("firma","vorname","nachname");
	}
	
	public function saveContextMenu($identifier, $key){}
}
?>
