<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class AuftragGUI extends Auftrag implements iGUIHTML2 {
	
	function getHTML($id){
		$pSpecData = mUserdata::getPluginSpecificData("Auftraege");
		
		$gui = new HTMLGUI();
		$gui->setObject($this);
		$html = "";
		
		$isNew = false;
		if($this->A ==  null AND $id != -1) $this->loadMe();
		
		if($id == -1) {
			$isNew = true;
			$id = $this->newWithDefaultValues();
		}

		$this->checkUserRestrictions($pSpecData);

		#if(isset($pSpecData["pluginSpecificCanOnlyEditOwn"]) AND $this->A->UserID != $_SESSION["S"]->getCurrentUser()->getID() AND !isset($pSpecData["pluginSpecificCanSeeAuftraegeFrom".$this->A->UserID]))
		#	die("Access denied!");
		
		if($this->AdresseObj == null AND $this->A->AdresseID != 0) $this->AdresseObj = new Adresse($this->A->AdresseID);
		
		$_SESSION["BPS"]->registerClass("mGRLBMGUI");
		$_SESSION["BPS"]->setACProperty("AuftragID",$this->ID);
		
		$d = null;
		
		$_SESSION["BPS"]->setACProperty("type","Kalk");
		$kalkulationen = new mGRLBMGUI();
		$kalkulationen->addAssocV3("AuftragID","=",$this->ID);
		$kalkulationen->lCV3();
		$kalkulation = $kalkulationen->getNextEntry();
		
		if(!isset($pSpecData["pluginSpecificCanOnlySeeKalk"])){
			
			$_SESSION["BPS"]->setACProperty("type","R");
			$rechnungen = new mGRLBMGUI();
			$rechnungen->addAssocV3("AuftragID","=",$this->ID);
			$rechnungen->lCV3();
			$rechnung = $rechnungen->getNextEntry();
			
			$_SESSION["BPS"]->setACProperty("type","A");
			$angebote = new mGRLBMGUI();
			$angebote->addAssocV3("AuftragID","=",$this->ID);
			$angebote->lCV3();
			$angebot = $angebote->getNextEntry();
			
			$_SESSION["BPS"]->setACProperty("type","L");
			$lieferscheine = new mGRLBMGUI();
			$lieferscheine->addAssocV3("AuftragID","=",$this->ID);
			$lieferscheine->lCV3();
			$lieferschein = $lieferscheine->getNextEntry();
			
			$_SESSION["BPS"]->setACProperty("type","G");
			$gutschriften = new mGRLBMGUI();
			$gutschriften->addAssocV3("AuftragID","=",$this->ID);
			$gutschriften->lCV3();
			$gutschrift = $gutschriften->getNextEntry();

			if($angebot != null){
				$angebote->resetPointer();
				$d = $angebote;
				$_SESSION["BPS"]->setACProperty("type","A");
			}
			if($lieferschein != null){
				$lieferscheine->resetPointer();
				$d = $lieferscheine;
				$_SESSION["BPS"]->setACProperty("type","L");
			}
			if($rechnung != null){
				$rechnungen->resetPointer();
				$d = $rechnungen;
				$_SESSION["BPS"]->setACProperty("type","R");
			}
			if($gutschrift != null){
				$gutschriften->resetPointer();
				$d = $gutschriften;
				$_SESSION["BPS"]->setACProperty("type","G");
			}
		}

		if($kalkulation != null AND (isset($pSpecData["pluginSpecificCanOnlySeeKalk"]) OR $d == null)){
			$kalkulationen->resetPointer();
			$d = $kalkulationen;
			$_SESSION["BPS"]->setACProperty("type","Kalk");
		}
		#echo $_SESSION["BPS"]->getACProperty("myID");
		if($_SESSION["S"]->checkForPlugin("Kundenpreise")){
			$_SESSION["BPS"]->registerClass("mArtikelGUI");
			$_SESSION["BPS"]->setACProperty("kundennummer",$this->A->kundennummer);
		}
		
		#echo "Set AuftragID for GRLBMsGUI to $this->ID<br />";
		#$_SESSION["BPS"]->registerClass("GRLBMsGUI");
		#$_SESSION["BPS"]->setACProperty("AuftragID",$this->ID);
		#$_SESSION["BPS"]->setACProperty("type","R");

		$DLB = $gui->getDesktopLinkButton();

		$anyC = new anyC();
		$anyC->setCollectionOf("Auftrag");
		$anyC->addAssocV3("AdresseID", "=", $this->A->AdresseID);
		$AdresseUsed = $anyC->getTotalNum();

		$ButtonEditAdresse = new Button("Adresse bearbeiten","./images/i2/edit.png");
		$ButtonEditAdresse->style("float:right;");
		$ButtonEditAdresse->type("icon");
		if($AdresseUsed == 1) $ButtonEditAdresse->onclick("if(confirm('Achtung: Beim Bearbeiten der Adresse über diesen Knopf geht die Verbindung zur Kundennummer und die USt-IdNr verloren! Die Adressänderung wirkt sich auf alle Belege in diesem Auftrag aus. Fortfahren?')) contentManager.loadFrame('contentRight','Adresse',{$this->A->AdresseID},0,'AdresseGUI;displayMode:auftragsAdresse;AuftragID:$this->ID')");
		else $ButtonEditAdresse->onclick("alert('Diese Adresse kann nicht bearbeitet werden, da sie in ".($AdresseUsed - 1)." anderen ".($AdresseUsed == 2 ? "Auftrag" : "Aufträgen")." verwendet wird.');");
		$html .= "
	<table style=\"width:160px;margin:0px;margin-right:-170px;float:right;margin-top:19px;".($this->AdresseObj == null ? "display:none;" : "")."\">
		<tr>";
		
		if(!isset($pSpecData["pluginSpecificCanOnlySeeKalk"])) $html .= "
			<td><input type=\"button\" class=\"bigButton backgroundColor2\" value=\"Angebot\n".($angebot != null ? "anzeigen" : "erstellen")."\" 				style=\"background-image:url(./images/navi/angebot.png);\"		name=\"".($angebot == null ? 1 : 2)."\"			id=\"AButton\" 			onclick=\"createGRLBM('$this->ID','Auftrag','A');\" /></td>
		</tr>
		<tr id=\"LRow\">
			<td><input type=\"button\" class=\"bigButton backgroundColor2\" value=\"Lieferschein\n".($lieferschein != null ? "anzeigen" : "erstellen")."\" 	style=\"background-image:url(./images/navi/lieferschein.png);\"	name=\"".($lieferschein == null ? 1 : 2)."\"	id=\"LButton\" 			onclick=\"createGRLBM('$this->ID','Auftrag','L');\" /></td>
		</tr>
		<tr>
			<td><input type=\"button\" class=\"bigButton backgroundColor2\" value=\"Rechnung\n".($rechnung != null ? "anzeigen" : "erstellen")."\" 			style=\"background-image:url(./images/navi/rechnung.png);\"		name=\"".($rechnung == null ? 1 : 2)."\"		id=\"RButton\" 			onclick=\"createGRLBM('$this->ID','Auftrag','R');\" /></td>
		</tr>
		<tr id=\"GRow\">
			<td><input type=\"button\" class=\"bigButton backgroundColor2\" value=\"Gutschrift\n".($gutschrift != null ? "anzeigen" : "erstellen")."\" 		style=\"background-image:url(./images/navi/gutschrift.png);\"	name=\"".($gutschrift == null ? 1 : 2)."\"		id=\"GButton\" 			onclick=\"createGRLBM('$this->ID','Auftrag','G');\" /></td>
		</tr>";
		
		$html .= "
		<tr>
			<td><input type=\"button\" class=\"bigButton backgroundColor2\" value=\"Kalkulation\n".($kalkulation != null ? "anzeigen" : "erstellen")."\" 		style=\"background-image:url(./images/navi/kalkulation.png);\"	name=\"".($kalkulation == null ? 1 : 2)."\"		id=\"KalkButton\" 			onclick=\"createGRLBM('$this->ID','Auftrag','Kalk');\" /></td>
		</tr>
	</table>
	<div class=\"backgroundColor1 Tab\"><p>".$gui->getOperationsHTML(get_parent_class($this),$this->ID).$DLB."Auftrag:</p></div>
	<table>
		<colgroup>
			<col width=\"120px\"/>
			<col />
		</colgroup>
		<tr>
			<td class=\"backgroundColor3\" colspan=\"2\">
				<input type=\"button\" value=\"1x-Adresse\nerstellen\" style=\"float:right;background-image:url(./images/navi/1xAddress.png);\" class=\"bigButton backgroundColor2\" onclick=\"loadFrameV2('contentRight','Adresse','AdresseGUI;AuftragID:$this->ID;displayMode:auftragsAdresse');\" />
				<input type=\"button\" value=\"Adresse\n".($this->A->AdresseID != 0 ? "ändern" : "hinzufügen")."\" style=\"background-image:url(./images/navi/address.png);\" class=\"bigButton backgroundColor2\" onclick=\"loadFrameV2('contentRight','Adressen','AdressenGUI;selectionMode:singleSelection,Auftrag,$this->ID,getAdresseCopy,Auftraege,contentLeft,Auftrag,$this->ID');\" />
			</td>
		</tr>
		<tr>
			<td class=\"backgroundColor2\"><label>Adresse:</label></td>
			<td class=\"backgroundColor3\" >".($this->A->AdresseID != 0 ? $ButtonEditAdresse.$this->AdresseObj->getHTMLFormattedAddress() : "")."</td>
		</tr>
		<tr>
			<td class=\"backgroundColor2\" ><label>Kundennummer:</label>
			<td class=\"backgroundColor3\" >".($this->A->kundennummer != -2 ? $this->A->kundennummer : "keine")."</td>
		</tr>
		<tr>
			<td class=\"backgroundColor2\" ><label>USt-IdNr/St.Nr.:</label>
			<td class=\"backgroundColor3\" ><input type=\"text\" value=\"".$this->A->UStIdNr."\" ".($this->A->kundennummer == -2 ? " class=\"multiEditInput2\" onfocus=\"oldValue = this.value;\" onblur=\"if(oldValue != this.value) saveMultiEditInput('Auftrag','".$this->getID()."','UStIdNr');\" id=\"UStIdNrID".$this->getID()."\" type=\"text\" onkeydown=\"if(event.keyCode == 13) saveMultiEditInput('Auftrag','".$this->getID()."','UStIdNr');\" style=\"width:95%;text-align:left;\"" : "readonly=\"readonly\"")." /></td>
		</tr>
		<!--<tr>
			<td class=\"backgroundColor2\" ><label>angelegt am:</label>
			<td class=\"backgroundColor3\" ><input type=\"text\" value=\"".date("d.m.Y",$this->A->auftragDatum)."\" readonly=\"readonly\" /></td>
		</tr>-->
	</table>
	<div style=\"min-height:50px;\" id=\"subframe\">".($d != null ? $d->getHTML(-1,0) : "")."</div>";
		
		/*
		<tr ".($this->AdresseObj == null ? "style=\"display:none;\"" : "").">
			".($rechnung != null ? "<td colspan=\"2\" id=\"subframe\">".$rechnung->getGUIClass()->getHTML("","R","","")."" : "</td>")."
		</tr>*/
		
		return $html;
	}

	public static function renrParser($w,$l,$p){
		$s = HTMLGUI::getArrayFromParametersString($p);
		if($w != "") return "<input type=\"text\" value=\"$w\" id=\"rechnungNummer\" name=\"rechnungNummer\" readonly=\"readonly\" />";
		else return "<input type=\"button\" value=\"Rechnung erstellen\" onclick=\"createRechnung('$s[0]','".$s[1]."');\" />";
	}
/*
	public static function adresseParser($w,$t,$s){
		$sugar = "";

		if($_SESSION["S"]->checkForPlugin("sugarCRM")){
			$B = new Button("sugarCRM-\nKontakt","./open3A/sugarCRM/sugarCRM.png");
			$B->className("backgroundColor2");
			#$B->onclick("loadFrameV2('contentRight','Adressen','AdressenGUI;selectionMode:singleSelection,Auftrag,$s[2],getAdresseCopy,Auftraege,contentLeft,Auftrag,$s[2]');");
			$B->select(false, "msugarCRMContact", "Auftrag", $s[2], "copysugarCRMContactForAuftrag");
			#function select($isMultiSelection, $pluginRight, $pluginLeftID, $calledPlugin, $calledPluginID, $calledPluginFunction)
			$sugar = "
			<tr>
				<td class=\"backgroundColor3\" colspan=\"2\">$B</td>
			</tr>";
		}

		if($_SESSION["S"]->checkForPlugin("mGoogleContact")){
			$B = new Button("Google-\nKontakt","./open3A/Google/Google.png");
			$B->className("backgroundColor2");
			$B->select(false, "mGoogleContact", "Auftrag", $s[2], "copyGoogleContactForAuftrag");
			$sugar = "
			<tr>
				<td class=\"backgroundColor3\" colspan=\"2\">$B</td>
			</tr>";
		}
		
		return ;
	}*/
	
	public function getAdresseCopy($AdresseID){
		parent::getAdresseCopy($AdresseID);
		echo "Adresse übernommen";
	}

	public function createGRLBM($type, $returnID = false){
		echo parent::createGRLBM($type, $returnID);
	}

	function getGRLBMPDF($copy, $pdf = null){
		$brief = $this->getLetter("", $copy == "true" ? true : false);
		if(Util::usePDFViewer() AND $pdf == null){
			$filename = $brief->generate(true, $pdf);
			Util::PDFViewer($filename);
		} else $brief->generate(false, $pdf);
	}

	public static function getEMailTBs(Adresse $A, Stammdaten $Stammdaten, GRLBM $GRLBM, $die = true){
		$ud = new mUserdata();
		$betreff = $ud->getUDValue("sendBelegViaEmailBetreff");
		if($betreff == null) {
			$T = new Textbausteine();
			list($k, $v) = $T->getTBs("emailBetreff", "", true);
			$betreff = isset($k[0]) ? $k[0] : null;
		}
		
		
		$ud = new mUserdata();
		$text = $ud->getUDValue("sendBelegViaEmailText");
		if($text == null) {
			$T = new Textbausteine();
			list($k, $v) = $T->getTBs("emailText", "", true);
			$text = isset($k[0]) ? $k[0] : null;
		}
		
		if($text == null OR $betreff == null) {
			if($die) die("error:AuftraegeMessages.E015");
			else throw new Exception("E-Mail: Textbausteine not found!");
		}
		
	    $T = new Textbaustein($betreff);
	    $T->loadMe();
	    $Subject = $T->getA()->text;
	    $Subject = str_replace("{Firmenname}", $Stammdaten->getA()->firmaLang, $Subject);
	    $Subject = str_replace("{Rechnungsnummer}", $GRLBM->A("prefix").$GRLBM->A("nummer"), $Subject);
	    $Subject = str_replace("{Rechnungsdatum}", $GRLBM->A("datum"), $Subject);

	    
	    $T = new Textbaustein($text);
	    $T->loadMe();
	    
	    $Body = str_replace("{Firmenname}", $Stammdaten->getA()->firmaLang, $T->getA()->text);
		$Body = str_replace("{Benutzername}",$_SESSION["S"]->getCurrentUser()->getA()->name, $Body);
	    $Body = str_replace("{Anrede}", Util::formatAnrede("de_DE", $A), $Body);
	    $Body = str_replace("{Rechnungsnummer}", $GRLBM->A("prefix").$GRLBM->A("nummer"), $Body);
	    $Body = str_replace("{Rechnungsdatum}", $GRLBM->A("datum"), $Body);
	    
		return array($Subject, $Body);
	}

	public static function getEMailSender($Stammdaten = null, $die = true){
		if($Stammdaten == null) $Stammdaten = mStammdaten::getActiveStammdaten();

		$ud = new mUserdata();
		$sender = $ud->getUDValue("sendBelegViaEmailSender", "firm");
		if($sender == "firm") {
			$from = $Stammdaten->getA()->email;
			$fromName = $Stammdaten->getA()->firmaLang;
		}
		if($sender == "user") {
			$from = $_SESSION["S"]->getCurrentUser()->getA()->UserEmail;
			$fromName = $_SESSION["S"]->getCurrentUser()->getA()->name;
		}

		if($Stammdaten->getA()->email == "" AND $sender == "firm"){
			if($die) die("error:AuftraegeMessages.E014");
			else throw new Exception("E-Mail: Please check the firms e-mail address in the Stammdaten");
		}
		if($_SESSION["S"]->getCurrentUser()->getA()->UserEmail == "" AND $sender == "user"){
			if($die) die("error:AuftraegeMessages.E014");
			else throw new Exception("E-Mail: Please check the users e-mail address");
		}

		return array($fromName, $from);
	}

	public static function getEMailRecipient(GRLBM $G, Adresse $AnAdresse, $delete1x = true, $die = true){
		$recipient = $AnAdresse->A("email");

		if($G->A("GRLBM1xEMail") != null AND $G->A("GRLBM1xEMail")){
			$recipient = $G->A("GRLBM1xEMail");
			$G->changeA("GRLBM1xEMail","");
			if($delete1x) $G->saveMe();
		}

	    if($recipient == ""){
	    	if($die) die("error:AuftraegeMessages.E004");
			else throw new Exception("E-Mail: No recipient address found!");
		}
	    #if($Stammdaten->getA()->email == "")
	    #	die("error:AuftraegeMessages.E005");

		return $recipient;
	}

	function getViaEMailWindow($sendVia = "E-Mail"){
		$Stammdaten = mStammdaten::getActiveStammdaten();
		$G = new GRLBM($_SESSION["BPS"]->getProperty("Brief","GRLBMID"));
		$AnAdresse = new Adresse($this->A("AdresseID"));
		
		list($Subject, $Body) = AuftragGUI::getEMailTBs($AnAdresse, $Stammdaten, $G);
		list($fromName, $from) = AuftragGUI::getEMailSender($Stammdaten);
		$recipient = AuftragGUI::getEMailRecipient($G, $AnAdresse, false);

		$tab = new HTMLTable(2);
		$tab->setColWidth(1, "120px;");
		$tab->addLV("Absender:", "$fromName &lt;$from&gt;");
		$tab->addLV("Empfänger:", $recipient);
		$ud = new mUserdata();
		if($_SESSION["S"]->getCurrentUser()->getA()->UserEmail != "" AND $ud->getUDValue("BCCToUser", "false") == "true")
			$tab->addLV("BCC:",$_SESSION["S"]->getCurrentUser()->getA()->UserEmail);

		$tab->addLV("Betreff:", "<input type=\"text\" id=\"EMailSubject$this->ID\" value=\"$Subject\" />");
		$tab->addRow(array("<textarea id=\"EMailBody$this->ID\" style=\"width:100%;height:300px;font-size:10px;\">$Body</textarea>"));
		$tab->addRowColspan(1, 2);


		$BAbort = new Button("Abbrechen","stop");
		$BAbort->onclick("Popup.close('$this->ID', 'EMailPreview');");

		$BGo = new Button("E-Mail\nsenden","okCatch");
		$BGo->style("float:right;");
		if($sendVia == "E-Mail") $BGo->onclick("Auftrag.directMail('$this->ID', $('EMailSubject$this->ID').value, $('EMailBody$this->ID').value); Popup.close('$this->ID', 'EMailPreview');");
		if($sendVia == "sign") $BGo->onclick("Auftrag.plSign('$this->ID', $('EMailSubject$this->ID').value, $('EMailBody$this->ID').value); Popup.close('$this->ID', 'EMailPreview');");

		$tab->addRow(array("$BGo$BAbort"));
		$tab->addRowColspan(1, 2);

		echo $tab;
	}
	
	function printLetter($copy){
		$brief = $this->getLetter($_SESSION["BPS"]->getProperty("mGRLBMGUI","type"), $copy == "true" ? true : false);

		try {
			$drucker = mDrucker::getStandardPrinter($copy == "true" ? true : false);
		} catch (NoStandardPrinterInstalledException $e){
			echo -1;
			return -1;
		}
		
		$filename = $brief->generate(true);

		$P = new PrintersGUI();
		$P->printPDF($drucker, $filename);
		
		unlink($filename);
	}

	function signLetter($Subject = "", $Body = ""){
		$G = new GRLBM($_SESSION["BPS"]->getProperty("Brief","GRLBMID"));
		if($G->A("GRLBM1xEMail") != null AND $G->A("GRLBM1xEMail")){
			$altEMailAddress = $G->A("GRLBM1xEMail");
			$G->changeA("GRLBM1xEMail","");
			$G->saveMe();
		} else $altEMailAddress = "";
		
		$brief = $this->getLetter("", false);
		
		$filename = $brief->generate(true);

		$AnAdresse = new Adresse($this->A->AdresseID);
		$AnAdresse->loadMe();
		
		if($altEMailAddress != "") $AnAdresse->changeA("email", $altEMailAddress);

		if(isset($_SESSION["viaInterface"]) OR $_SESSION["S"]->checkForPlugin("PL")) $PL = new PLGUI();
		if($_SESSION["S"]->checkForPlugin("SP")) $PL = new SPGUI();
		
		return $PL->sign($filename, $AnAdresse, $Subject, $Body);
	}
	
	function sendViaMail(){
		$brief = $this->getLetter("", false);
		
		$filename = $brief->generate(true);
		
		$AnAdresse = new Adresse($this->A->AdresseID);
		$AnAdresse->loadMe();
		
		$PL = new PLGUI();
		return $PL->mail($filename, $AnAdresse);
	}
	
	public function doDefaultAction(){
		if($this->A("kundennummer") == "-2") return;
		
		$this->loadMe();
		
		$K = new mKappendix();
		$K->addAssocV3("kundennummer", "=", $this->A("kundennummer"));
		$K = $K->getNextEntry();
		
		if($K == null) die("error:AuftraegeMessages.E016");
		
		$m = array("keiner", "Post", "E-Mail","E-Mail signiert", "Drucken");
		if(!isset($K->getA()->KappendixRechnungsversand) OR $K->A("KappendixRechnungsversand") == "0") return;
		
		if($K->A("KappendixRechnungsversand") == "1") $this->sendViaMail();
		if($K->A("KappendixRechnungsversand") == "2") $this->sendViaEMail(/*$K->A("KappendixRechnungsversandEmail")*/);
		if($K->A("KappendixRechnungsversand") == "3") $this->signLetter(/*$K->A("KappendixRechnungsversandEmail")*/);
		if($K->A("KappendixRechnungsversand") == "4") $this->printLetter("false");
	}
	
	static function getNextNumber($t){
		return parent::getNextNumber($t);
	}
	
	public function getMyStammdaten(){
		return parent::getMyStammdaten();
	}

	public function saveMultiEditField($field,$value){
		parent::saveMultiEditField($field,$value);
		echo "Änderung gespeichert";
	}
}
?>