<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class GRLBMGUI extends GRLBM implements iGUIHTML2, icontextMenu {
	
	private $kdNummer = "";
	private $ustidnr = "";
	public $additionalKalkFields = "";
	public $additionalNonKalkFields = "";
	
	function __construct($id){
		if($id == -2)
			$id = $_SESSION["BPS"]->getProperty("GRLBMGUI","myID");

		parent::__construct($id);
	}
	
	public function markMeAsUnprinted(){
		parent::markMeAsUnprinted();
	}
	
	public function setLetterType($type){
		$this->letterType = $type;
	}
	
	public function setIsCopy($copy){
		$this->isCopy = $copy;
	}
	
	public function setKundennummer($kdnr){
		$this->kdNummer = $kdnr;
	}
	
	public function setKundenUStIdNr($ustidnr){
		$this->ustidnr = $ustidnr;
	}
	
	function getHTML($id){
		if($id == -2)
			$id = $_SESSION["BPS"]->getProperty("GRLBMGUI","myID");
			
		#------------------------ einige Einstellungen für die multiPrint-Liste
		$_SESSION["BPS"]->setActualClass("multiPrintBasketGUI");
		$basketBPS = $_SESSION["BPS"]->getAllProperties();
		
		if($basketBPS == -1 OR !isset($basketBPS["ids"])) {
			if($basketBPS == -1) $basketBPS = array();
			$basketBPS["ids"] = "";
		}
		if($basketBPS["ids"] == ",,") $basketBPS["ids"] = "";
		#------------------------ 
		
		$gui = new HTMLGUI();
		$gui->setObject($this);
		$gui->customize($this->customizer);


		/**
		 * DEPRECATED BUT REQUIRED FOR THIS CLASS
		 */
		$_SESSION["BPS"]->registerClass("GRLBMGUI");
		$_SESSION["BPS"]->setACProperty("myID",$id);
		/**
		 * NEW
		 */
		$_SESSION["BPS"]->registerClass("Brief");
		$_SESSION["BPS"]->setACProperty("GRLBMID",$id);
		
		$type = $_SESSION["BPS"]->getProperty("mGRLBMGUI","type");

		if($id == -1 AND $type == "Kalk"){
			$G = new GRLBM(-1);
			$this->A = $G->newAttributes();
			$this->A->isWhat = $type;
			$mG = new mGRLBMGUI("Kalk");
			$this->A->nummer = $mG->getIncrementedField("nummer");
			$id = $this->newMe();
			$this->forceReload();
		}

		#if($type == "Kalk"){
		#	$_SESSION["BPS"]->registerClass("GRLBMGUI");
		#	$_SESSION["BPS"]->setACProperty("myID",$id);
		#}
		
		$this->loadMe();
		
		#-------- Posten -----------------------------------------
			$postenRechnung = new mPostenGUI();
			$_SESSION["BPS"]->registerClass("mPostenGUI");
			$_SESSION["BPS"]->setACProperty("loadGRLBMID",$this->ID);
			$_SESSION["BPS"]->setACProperty("GRLBMType",$type);
			$_SESSION["BPS"]->setACProperty("AuftragID",$this->A->AuftragID);
			$_SESSION["BPS"]->registerClass("PostenGUI");
			$_SESSION["BPS"]->setACProperty("GRLBMType",$type);
			#$postenRechnung->setAssociation("GRLBMID",$this->ID);
		#/------- Posten -----------------------------------------
		
			
		// If Plugin Provisionen exists, set some values for it
		if($_SESSION["S"]->checkForPlugin("Provisionen")){
			$_SESSION["BPS"]->registerClass("ProvisionSwitchGUI");
			$_SESSION["BPS"]->setACProperty("useGRLBMID",$this->ID);
			$_SESSION["BPS"]->setACProperty("useAuftragID",$this->A->AuftragID);
		}
		/*$html2 = "
		<table>
			<tr>
				<td class=\"backgroundColor3\"><input type=\"button\" class=\"bigButton backgroundColor2\" style=\"background-image:url(./images/navi/".strtolower(Stammdaten::getLongType($type)).".png);\" onclick=\"$('".$type."Button').name = '1';createGRLBM('".$this->A->AuftragID."','Auftrag','$type');\" value=\"".Stammdaten::getLongType($type)."\nerstellen\" /></td>
			</tr>
		</table>";*/
		
		
		/**
		 * Textbaustein-Dropdowns:
		 */
		$Tbos = new Textbausteine();
		$Tbos = $Tbos->getTBs("oben", $this->getMyPrefix());
		
		$To = "";
		if($Tbos) foreach($Tbos[0] As $key => $value)
			$To .= "<option ".($this->A->textbausteinObenID == $value ? "selected=\"selected\"": "")." value=\"".$value."\">".$Tbos[1][$key]."</option>";
		$To .= "<option ".($this->A->textbausteinObenID == "0" ? "selected=\"selected\"": "")." value=\"0\">Freitext...</option>";
		
		//---------------
		$Tbos = new Textbausteine();
		$Tbos = $Tbos->getTBs("unten", $this->getMyPrefix());
		
		$Tu = "";
		if($Tbos) foreach($Tbos[0] As $key => $value)
			$Tu .= "<option ".($this->A->textbausteinUntenID == $value ? "selected=\"selected\"": "")." value=\"".$value."\">".$Tbos[1][$key]."</option>";
		$Tu .= "<option ".($this->A->textbausteinUntenID == "0" ? "selected=\"selected\"": "")." value=\"0\">Freitext...</option>";
				
		//---------------
		$Tbos = new Textbausteine();
		$Tbos = $Tbos->getTBs("zahlungsbedingungen", $this->getMyPrefix());
		
		$Tz = "";
		if($Tbos) foreach($Tbos[0] As $key => $value)
			$Tz .= "<option ".($this->A->zahlungsbedingungenID == $value ? "selected=\"selected\"": "")." value=\"".$value."\">".$Tbos[1][$key]."</option>";
		$Tz .= "<option ".($this->A->zahlungsbedingungenID == "0" ? "selected=\"selected\"": "")." value=\"0\">Freitext...</option>";
		
		
		
		$html2 = GRLBMsGUI::getButtons($type, $this->A->AuftragID, true);
		$gui = new HTMLGUI();
		
		/*$B = new Button("Beleg\nzustellen","navigation");
		$B->onclick("if(confirm('Beleg wirklich zustellen? (Es können Kosten entstehen.)')) ");
		$B->rme("Auftrag",$this->A->AuftragID,"doDefaultAction","","checkResponse(transport);");
		$B->className("backgroundColor2");
		$B->style("float:right;");*/
		$B = "";
		$eSig = "";
	
		if($_SESSION["S"]->checkForPlugin("PL") AND ($type == "R" OR $type == "G")) {
			$BPL = new Button("mit PixelLetter\nsignieren","./open3A/PixelLetter/pl.png");
			$BPL->onclick("Auftrag.windowMail(".$this->A->AuftragID.",'sign');");#plSign('{$this->A->AuftragID}');
			$BPL->style("float:right;");
			$BPL->className("backgroundColor2");
			
			$SPL = new Button("Einstellungen","./images/i2/settings.png");
			$SPL->type("icon");
			$SPL->className("calendarIcon mouseoverFade");
			$SPL->onclick("contextMenu.start(this, 'PL','1','Einstellungen:','right','up');");
			
			$eSig = $BPL.$SPL;
		}
		
		if($_SESSION["S"]->checkForPlugin("SP") AND ($type == "R" OR $type == "G")) {
			$BPL = new Button("versenden mit\nsignaturportal.de","./open3A/signaturportal/sp.png");
			$BPL->onclick("Auftrag.windowMail(".$this->A->AuftragID.",'sign');");#plSign('{$this->A->AuftragID}');
			$BPL->style("float:right;");
			$BPL->className("backgroundColor2");
			
			$SPL = new Button("Einstellungen","./images/i2/settings.png");
			$SPL->type("icon");
			$SPL->className("calendarIcon mouseoverFade");
			$SPL->onclick("contextMenu.start(this, 'SP','1','Einstellungen:','right','up');");
			
			$eSig = $BPL.$SPL;
		}

		$BMail = new Button("per E-Mail\nverschicken","mail");
		$BMail->onclick("Auftrag.windowMail(".$this->A->AuftragID.",'E-Mail');");
		$BMail->className("backgroundColor2");
		#<input type=\"button\" style=\"background-image:url(./images/navi/mail.png);\" class=\"bigButton backgroundColor2\" value=\"per E-Mail\nverschicken\" onclick=\"directMail('false',".$this->A->AuftragID.",'Auftrag');\" />

		$Stammdaten = mStammdaten::getActiveStammdaten();
		$CurrentVorlage = $Stammdaten->A("ownTemplate");
		$CurrentVorlage = new $CurrentVorlage($Stammdaten);
		$CustomFields = "";
		
		for($i = 1; $i < 10; $i++){
			$labelName = "labelCustomField$i";
			$IN = new HTMLInput("GRLBMCustomField$i", "text", $this->A("GRLBMCustomField$i"));
			$IN->id("GRLBMCustomField$i");
			if(isset($CurrentVorlage->$labelName) AND $CurrentVorlage->$labelName != null)
				$CustomFields .= "
						<tr>
							<td><label for=\"GRLBMCustomField$i\">".$CurrentVorlage->$labelName.":</label></td>
							<td>$IN</td>
						</tr>";
		}

		$LAAdresse = "Lieferadresse";
		if($type == "A") $LAAdresse = "Angebotsadresse";

		$html = "
			<form id=\"GRLBMForm\">
				<div class=\"backgroundColor1 Tab\" style=\"margin-top:30px;\"><p>".$gui->getOperationsHTML("GRLBM",$id)."<!--<img src=\"./images/navi/".strtolower(Stammdaten::getLongType($type)).".png\" style=\"float:right;margin-top:-20px;\" />-->".Stammdaten::getLongType($type).":</p></div>
				<table>
					<colgroup>
						<col width=\"120px\" class=\"backgroundColor2\" />
						<col class=\"backgroundColor3\" />
					</colgroup>
					$CustomFields".(($_SESSION["S"]->checkForPlugin("Abschlussrechnung") AND $type == "R") ? "
					<tr>
						<td><label for=\"isAbschlussrechnung\">Abschlussre.:</label></td>
						<td><input type=\"checkbox\" ".($this->A->isAbschlussrechnung == "1" ? "checked=\"checked\"" : "")." id=\"isAbschlussrechnung\" name=\"isAbschlussrechnung\" /></td>
					</tr>
					" : "").(($type == "L" OR $type == "A") ? "
					<tr>
						<td>
							<label>$LAAdresse:</label>
						</td>
						<td>".($this->A->lieferAdresseID != 0 ? "
							<img
								title=\"$LAAdresse löschen\"
								style=\"float:right;margin-left:10px;\"
								class=\"mouseoverFade\"
								onclick=\"rme('GRLBM','$this->ID','getLieferscheinAdresseCopy','0','new Ajax.Updater(\'subframe\',\'./interface/loadFrame.php?p=GRLBM&id=$this->ID\');');\"
								src=\"./images/i2/delete.gif\"
							/>" : "")."
							<img
								title=\"1x-$LAAdresse verwenden\"
								class=\"mouseoverFade\"
								style=\"margin-left:10px;float:right;\"
								src=\"./open3A/Auftraege/1xlieferAdresse.png\"
								onclick=\"loadFrameV2('contentRight','Adresse','AdresseGUI;AuftragID:{$this->ID};displayMode:lieferAdresse');\"
							/>
							<img
								title=\"$LAAdresse ändern\"
								class=\"mouseoverFade\"
								style=\"float:right;\"
								src=\"./open3A/Auftraege/lieferAdresse.png\"
								onclick=\"loadFrameV2('contentRight','Adressen','AdressenGUI;selectionMode:singleSelection,GRLBM,$this->ID,getLieferscheinAdresseCopy,Auftraege,subframe,GRLBM,$this->ID');\"
							/>
							".($this->A->lieferAdresseID == "0" ? "wie Rechnungsadresse" : new Adresse($this->A->lieferAdresseID))."
						</td>
					</tr>"
					: "")."
					<tr>
						<td id=\"rechnungNummerEditL\"><label for=\"nummer\">Nummer:</label></td>
						<td id=\"rechnungNummerEditR\"><input type=\"text\" value=\"".$this->A->nummer."\" id=\"nummer\" name=\"nummer\" /></td>
					</tr>
					<tr>
						<td id=\"datumEditL\"><label for=\"datum\">Datum:</label></td>
						<td id=\"datumEditR\"><img src=\"./images/i2/calendar.gif\" class=\"calendarIcon mouseoverFade\" style=\"margin-right:0px;\" onclick=\"Kalender.show(null,null,'datum',-365,0,'%d.%m.%y');\" /><input onfocus=\"focusMe(this);\" onblur=\"blurMe(this);\" type=\"text\" value=\"".(strstr($this->A->datum,".") ? $this->A->datum : date("d.m.Y",$this->A->datum))."\" id=\"datum\" style=\"width:90%\" name=\"datum\" /></td>
					</tr>
					<tr ".($type != "R" ? "style=\"display:none;\"" : "").">
						<td id=\"lieferDatumEditL\"><label for=\"lieferDatum\">Lieferdatum:</label></td>
						<td id=\"lieferDatumEditR\"><img style=\"margin-right:0px;\" src=\"./images/i2/calendar.gif\" class=\"calendarIcon mouseoverFade\" onclick=\"Kalender.show(null,null,'lieferDatum',-365,0,'%d.%m.%y');\" /><img style=\"float:right;margin-right:10px;\" class=\"mouseoverFade\" onclick=\"$('lieferDatum').value=$('datum').value;\" title=\"entspricht Rechnungsdatum\" src=\"./images/i2/insert.png\" /><input onfocus=\"focusMe(this);\" onblur=\"blurMe(this);\" type=\"text\" value=\"".(strstr($this->A->lieferDatum,".") ? $this->A->lieferDatum : date("d.m.Y",$this->A->lieferDatum))."\" id=\"lieferDatum\" name=\"lieferDatum\" style=\"width:70%;\" /></td>
					</tr>
					".($type == "A" ? "
					<tr>
						<td><label for=\"printAB\">AB erstellen?:</label></td>
						<td><input type=\"checkbox\" ".($this->A->printAB == "1" ? "checked=\"checked\"" : "")." id=\"printAB\" name=\"printAB\" /></td>
					</tr>
					" : "")."
					".($type != "Kalk" ? "<tr id=\"textbausteinObenEdit1\">
						<td rowspan=\"3\"><label>Textbausteine:<br /><small>oben, unten, Zahlungsbed.</small></label></td>
						<td>
							<select onchange=\"if(this.value=='0') $('textbausteinOben').style.display = ''; else  $('textbausteinOben').style.display = 'none';\" name=\"textbausteinObenID\">$To</select>
							<textarea
								class=\"resizableTextarea\" 
								style=\"margin-top:5px;".($this->A->textbausteinObenID != "0" ? "display:none;" : "")."\" 
								onblur=\"blurMe(this);\" 
								onfocus=\"focusMe(this);this.style.height='80px';$('zahlungsbedingungen').style.height='18px';$('textbausteinUnten').style.height='18px';\" 
								name=\"textbausteinOben\" 
								id=\"textbausteinOben\">".$this->A->textbausteinOben."</textarea>
						</td>
					</tr>
					<tr id=\"textbausteinUntenEdit2\">
						<td>
							<select onchange=\"if(this.value=='0') $('textbausteinUnten').style.display = ''; else  $('textbausteinUnten').style.display = 'none';\" name=\"textbausteinUntenID\">$Tu</select>
							<textarea 
								class=\"resizableTextarea\" 
								style=\"margin-top:5px;".($this->A->textbausteinUntenID != "0" ? "display:none;" : "")."\" 
								onblur=\"blurMe(this);\" 
								onfocus=\"focusMe(this);this.style.height='80px';$('textbausteinOben').style.height='18px';$('zahlungsbedingungen').style.height='18px';\"
								name=\"textbausteinUnten\"
								id=\"textbausteinUnten\">".$this->A->textbausteinUnten."</textarea>
						</td>
					</tr>
					<tr id=\"zahlungsbedingungenEdit3\">
						<td>
							<select onchange=\"if(this.value=='0') $('zahlungsbedingungen').style.display = ''; else  $('zahlungsbedingungen').style.display = 'none';\" name=\"zahlungsbedingungenID\">$Tz</select>
							<textarea 
								style=\"margin-top:5px;".($this->A->zahlungsbedingungenID != "0" ? "display:none;" : "")."\" 
								class=\"resizableTextarea\" 
								onblur=\"blurMe(this);\" 
								onfocus=\"focusMe(this);this.style.height='80px';$('textbausteinOben').style.height='18px';$('textbausteinUnten').style.height='18px';\"
								name=\"zahlungsbedingungen\"
								id=\"zahlungsbedingungen\">".$this->A->zahlungsbedingungen."</textarea>
						</td>
					</tr>
					$this->additionalNonKalkFields":"
					
					<tr>
						<td id=\"rabattEditL\"><label for=\"rabatt\">Rabatt:<br /><small>in %</small></label></td>
						<td id=\"rabattEditR\"><input onfocus=\"focusMe(this);\" onblur=\"blurMe(this);\" type=\"text\" value=\"".$this->A->rabatt."\" id=\"rabatt\" name=\"rabatt\" /></td>
					</tr>
					<tr>
						<td id=\"rabattInWEditL\"><label for=\"rabattInW\">Rabatt:<br /><small>in €</small></label></td>
						<td id=\"rabattInWEditR\"><input onfocus=\"focusMe(this);\" onblur=\"blurMe(this);\" type=\"text\" value=\"".$this->A->rabattInW."\" id=\"rabattInW\" name=\"rabattInW\" /><br /><small>überschreibt Rabatt in %, falls nicht 0</small></td>
					</tr>
					<tr>
						<td id=\"leasingrateEditL\"><label for=\"leasingrate\">Leasingfaktor:<br /><small>in %</small></label></td>
						<td id=\"leasingrateEditR\"><input onfocus=\"focusMe(this);\" onblur=\"blurMe(this);\" type=\"text\" value=\"".$this->A->leasingrate."\" id=\"leasingrate\" name=\"leasingrate\" /></td>
					</tr>
					$this->additionalKalkFields")."
					
					<tr>
						<td class=\"backgroundColor2\" colspan=\"2\"><input type=\"button\" style=\"background-image:url(./images/i2/save.gif);\" onclick=\"saveClass(
							'".get_parent_class($this)."',
							'".$this->ID."',
							function() { 
								showMessage('Änderungen gespeichert');
							},'GRLBMForm'
						);\" value=\"Änderungen speichern\" />
						<input type=\"hidden\" name=\"isR\" id=\"isR\" value=\"".$this->A->isR."\" />
						<input type=\"hidden\" name=\"isL\" id=\"isL\" value=\"".$this->A->isL."\" />
						<input type=\"hidden\" name=\"isG\" id=\"isG\" value=\"".$this->A->isG."\" />
						<input type=\"hidden\" name=\"isB\" id=\"isB\" value=\"".$this->A->isB."\" />
						<input type=\"hidden\" name=\"isM\" id=\"isM\" value=\"".$this->A->isM."\" />
						<input type=\"hidden\" name=\"isWhat\" id=\"isWhat\" value=\"".$this->A->isWhat."\" />
						<input type=\"hidden\" name=\"AuftragID\" id=\"AuftragID\" value=\"".$this->A->AuftragID."\" />
						</td>
					</tr>
					<tr>
						<td id=\"printButtonEditR\" colspan=\"2\" class=\"backgroundColor3\">
							<input type=\"button\" style=\"float:right;background-image:url(./images/navi/pdf.png);\" class=\"bigButton backgroundColor2\" value=\"Kopie\" onclick=\"javascript:document.open('./interface/rme.php?bps=_Brief;templateType:PDF&class=Auftrag&amp;constructor=".$this->A->AuftragID."&amp;method=getGRLBMPDF&amp;parameters=\'true\'','Druckansicht','height=650,width=875,left=20,top=20');\" />
							<img src=\"./images/i2/settings.png\" class=\"calendarIcon mouseoverFade\" onclick=\"contextMenu.start(this, 'GRLBM','1','Kopie:','right','up');\">
							<input type=\"button\" style=\"background-image:url(./images/navi/pdf.png);\" class=\"bigButton backgroundColor2\" value=\"Original\" onclick=\"javascript:document.open('./interface/rme.php?bps=_Brief;templateType:PDF&class=Auftrag&amp;constructor=".$this->A->AuftragID."&amp;method=getGRLBMPDF&amp;parameters=\'false\'','Druckansicht','height=650,width=875,left=20,top=20');\" />
						</td>
					</tr>
					".($_SESSION["S"]->checkForPlugin("mDrucker") ? "
					<tr>
						<td id=\"printButtonEditR\" colspan=\"2\" class=\"backgroundColor3\">
							<input type=\"button\" style=\"float:right;background-image:url(./images/navi/printer.png);\" class=\"bigButton backgroundColor2\" value=\"Kopie\" onclick=\"directPrint('true',".$this->A->AuftragID.",'Auftrag','R');\" />
							<input type=\"button\" style=\"background-image:url(./images/navi/printer.png);\" class=\"bigButton backgroundColor2\" value=\"Original\" onclick=\"directPrint('false',".$this->A->AuftragID.",'Auftrag','R');\" />
						</td>
					</tr>" : "")."
					<tr>
						<td id=\"\" colspan=\"2\" class=\"backgroundColor3\" style=\"vertical-align:top;\">
							$eSig
							$BMail
							<img src=\"./images/i2/settings.png\" class=\"mouseoverFade\" onclick=\"contextMenu.start(this, 'GRLBM','viaMail','E-Mail:','right','up');\">
						</td>
					<tr>
						<td id=\"\" colspan=\"2\" class=\"backgroundColor3\">
							".(($_SESSION["S"]->checkForPlugin("Dtaus") AND $type == "R") ? "<input
								type=\"button\"
								style=\"background-image:url(./images/navi/disk.png);float:right;\"
								class=\"bigButton backgroundColor2\"
								value=\"Dtaus-Datei\nerstellen\"
								onclick=\"Dtaus.createFile('$this->ID');\"
							/>": "")."
							<input type=\"button\" id=\"GRLBMAddToMultiPrintList\" style=\"background-image:url(./images/navi/addtolist.png);".((!strstr($basketBPS["ids"],",".$this->ID.",") OR $basketBPS["ids"] == "") ? "":"display:none;")."\" class=\"bigButton backgroundColor2\" value=\"zur multiDruck-\nListe hinzufügen\" onclick=\"addToMultiPrintAusAuftrag($this->ID);\" />
							<input type=\"button\" id=\"GRLBMSubFromMultiPrintList\" style=\"background-image:url(./images/navi/subfromlist.png);".((!strstr($basketBPS["ids"],",".$this->ID.",") OR $basketBPS["ids"] == "") ? "display:none":";")."\" class=\"bigButton backgroundColor2\" value=\"von multiDruck-\nListe entfernen\" onclick=\"subFromMultiPrintAusAuftrag($this->ID);\" />
						</td>
					</tr>
					<!--<tr>
						<td class=\"backgroundColor3\" colspan=\"2\">$B</td>
					</tr>-->
				</table>
			</form>";
		
		if($_SESSION["S"]->checkForPlugin("mFile")){
			$D = new mDateiGUI();
			$D->classID = $this->ID;
			$D->className = "GRLBM";
			$D->onAddClass = "GRLBM";
			#$D->onReloadFrame = "subframe";
			#$D->onReloadClass = "GRLBM";
			#$D->onReloadID = "-2";
			$D->onDeleteFunction = "function() { new Ajax.Request('./interface/loadFrame.php?p=GRLBM&id=-2', {onSuccess: function(transport){if(checkResponse(transport)) $('subframe').update(transport.responseText);}}); }";
		}
		return $html2.$postenRechnung->getHTML(-1,$this->A->AuftragID,"",$this->ID).$html.($_SESSION["S"]->checkForPlugin("mFile") ? "<div style=\"margin-top:30px;\">".$D->getHTML(-1, 0)."</div>" : "");#($type != "Kalk" ? $html : "");
	}
	#new Ajax.Updater(\'subframe\',\'./interface/loadFrame.php?p=mGRLBM&id=-2\');
	public function getContextMenuHTML($identifier){
		
		$options = explode(":",$identifier);
		$identifier = $options[0];
		
		switch($identifier) {
			case "1":
				$gui = new HTMLGUI();
				
				$aSd = mStammdaten::getActiveStammdaten();
				
				$ud = new mUserdata();
			
				$aT = $ud->getUDValue("activePDFCopyTemplate");
				
				if($aT == null){
					$selectedKey = $aSd->getA()->ownTemplate;
				} else $selectedKey = $aT;
				
				$FB = new FileBrowser();
				$FB->addDir("../open3A/Brief/");
				$FB->addDir("../specifics/");
				$a = $FB->getAsLabeledArray("iVorlage",".class.php",true);
				
				/*$kAL = array();
				if($aSd->getA()->ownTemplate != "") $kAL[$aSd->getA()->ownTemplate] = $aSd->getA()->ownTemplate;
				if($aSd->getA()->ownTemplatePrint != "") $kAL[$aSd->getA()->ownTemplatePrint] = $aSd->getA()->ownTemplatePrint;
				if($aSd->getA()->ownTemplateEmail != "") $kAL[$aSd->getA()->ownTemplateEmail] = $aSd->getA()->ownTemplateEmail;
				$kAL["StPDFBriefkopf"] = "für leeres Papier";
				$kAL["StPDFBriefkopfOL"] = "für bedrucktes Papier";*/
				
				echo $gui->getContextMenu(array_flip($a), "GRLBM", "1", $selectedKey);
		
				echo "<br />";
				
				$ud = new mUserdata();
				$aT = $ud->getUDValue("activePDFCopyVermerk");
				
				if($aT == null){
					$selectedKey = "true";
				} else $selectedKey = $aT;
				
				$kAL = array();
				$kAL["true"] = "mit Kopie-Vermerk";
				$kAL["false"] = "ohne Kopie-Vermerk";
				
				echo $gui->getContextMenu($kAL, "GRLBM", "2", $selectedKey);
			break;
			
			case "viaMail":
				echo "
				<div style=\"margin:1px;margin-top:5px;padding:3px;font-weight:bold;\" class=\"backgroundColor2\">BCC an ".$_SESSION["S"]->getCurrentUser()->getA()->UserEmail."?:</div>";

				$gui = new HTMLGUI();
				$ud = new mUserdata();
				$selectedKey = $ud->getUDValue("BCCToUser", "false");
				/*
				if($aT == null)
					$selectedKey = "true";
				else $selectedKey = $aT;*/
				
				$kAL = array();
				$kAL["false"] = "Nein";
				$kAL["true"] = "Ja";
				
				echo $gui->getContextMenu($kAL, "GRLBM", "BCCToUser", $selectedKey);
				
				echo "
				<div style=\"margin:1px;margin-top:5px;padding:3px;font-weight:bold;\" class=\"backgroundColor2\">Betreff:</div>";
				
				$ud = new mUserdata();
				$selectedKey = $ud->getUDValue("sendBelegViaEmailBetreff");
						
				$kAL = array();
				$T = new Textbausteine();
				$T->addAssocV3("KategorieID","=","41");
				while($s = $T->getNextEntry()){
					$kAL[$s->getID()] = $s->getA()->label;
					if($s->getA()->isKatDefault == "1" AND $selectedKey == null) $selectedKey = $s->getID();
				}
				if(count($kAL) == 0) echo "<p>keine Textbausteine eingetragen!</p>";
				echo $gui->getContextMenu($kAL, "GRLBM", "mailBetreff", $selectedKey);
				
				echo "
				<div style=\"margin:1px;margin-top:5px;padding:3px;font-weight:bold;\" class=\"backgroundColor2\">Text:</div>";
				
				$ud = new mUserdata();
				$selectedKey = $ud->getUDValue("sendBelegViaEmailText");
						
				$kAL = array();
				$T = new Textbausteine();
				$T->addAssocV3("KategorieID","=","42");
				while($s = $T->getNextEntry()){
					$kAL[$s->getID()] = $s->getA()->label;
					if($s->getA()->isKatDefault == "1" AND $selectedKey == null) $selectedKey = $s->getID();
				}
				
				if(count($kAL) == 0) echo "<p>keine Textbausteine eingetragen!</p>";
				echo $gui->getContextMenu($kAL, "GRLBM", "mailText", $selectedKey);
				
						
				echo "<div style=\"margin:1px;margin-top:5px;padding:3px;font-weight:bold;\" class=\"backgroundColor2\">Absender:</div>";
				$Stammdaten = mStammdaten::getActiveStammdaten();
				
				$ud = new mUserdata();
				$selectedKey = $ud->getUDValue("sendBelegViaEmailSender", "firm");
				
				$kAL = array();
				$kAL["firm"] = "Firma (".$Stammdaten->getA()->email.")";
				$kAL["user"] = "Benutzer (".$_SESSION["S"]->getCurrentUser()->getA()->UserEmail.")";
				
				echo $gui->getContextMenu($kAL, "GRLBM", "mailSender", $selectedKey);
				
				echo "<div style=\"margin:1px;margin-top:5px;padding:3px;font-weight:bold;\" class=\"backgroundColor2\">Datei-Anhänge:</div>";

				if($_SESSION["S"]->checkForPlugin("mFile")){
					$ud = new mUserdata();
					$selectedKey = $ud->getUDValue("sendBelegViaEmailAttachments", "false");
					
					$kAL = array();
					$kAL["true"] = "mit";
					$kAL["false"] = "ohne";
					
					echo $gui->getContextMenu($kAL, "GRLBM", "mailAttachments", $selectedKey);
				}
			break;
			
			case "setPayed":
				$pSpecData = mUserdata::getPluginSpecificData("Auftraege");
				if(!isset($pSpecData["pluginSpecificCanSetPayed"])) 
					die("<p><small>Sie können keine Rechnungen als bezahlt markieren.<br /><br />Damit Sie Rechnungen als bezahlt markieren können, muss im Administrations-Bereich eine Plugin-spezifische Berechtigung gesetzt werden. Wählen Sie dazu den Benutzer aus, klicken Sie auf \"Plugin-spezifisch\". Wählen Sie Aufträge und \"kann Rechnungen als bezahlt markieren\".</small></p>");
				
				$G = new GRLBM($options[2]);
				$G->loadMe();
				
				$tab = new HTMLTable(1);
				
				$tab->addRow("<input style=\"background-image:url(./images/i2/save.gif);\" type=\"button\" value=\"markieren\" onclick=\"Auftrag.nowSetRechnungPayed('$options[1]', '$options[2]');\" />");
				$tab->addRowClass("backgroundColor3");
				if(isset($G->getA()->GRLBMTeilzahlungen) AND $this->CustomizerTeilzahlungen) {
					$tab->addRow("<input type=\"checkbox\" onclick=\"Auftrag.showTeilzahlung();\" id=\"isTeilzahlung\" style=\"float:left;margin-right:5px;\" /> <label style=\"text-align:left;font-weight:normal;float:none;\" for=\"isTeilzahlung\">Teilzahlung</label>");
					$tab->addRowClass("backgroundColor0");
					
					$tab->addRow("Betrag: <input id=\"GRLBMTeilzahlungenBetrag\" type=\"text\" style=\"text-align:right;width:100px;\" value=\"".Util::CLFormatCurrency(0,false)."\" onkeydown=\"if(event.keyCode == 13) Auftrag.nowSetRechnungPayed('$options[1]', '$options[2]');\" />");
					$tab->addCellStyle(1,"display:none;");
					$tab->addCellID(1, "GRLBMTeilzahlungenBetragCell");
				}
				
				$tab->addRow("mit Skonto: <input id=\"withSkonto\" type=\"text\" value=\"\" style=\"text-align:right;width:50px;\" onkeydown=\"if(event.keyCode == 13) Auftrag.nowSetRechnungPayed('$options[1]', '$options[2]');\" /> %");
				$tab->addCellID(1, "markAsPayedSkonto");
				$tab->addRow("Datum: <input id=\"withDate\" type=\"text\" style=\"text-align:right;width:100px;\" value=\"".date("d.m.Y")."\" onkeydown=\"if(event.keyCode == 13) Auftrag.nowSetRechnungPayed('$options[1]', '$options[2]');\" />");
				
				echo $tab;
			break;
		}

	}
	
	public function saveContextMenu($identifier, $key){
		$ud = new mUserdata();
		
		if($identifier == "1"){
			$ud->setUserdata("activePDFCopyTemplate",$key);
		}
		if($identifier == "2"){
			$ud->setUserdata("activePDFCopyVermerk",$key);
		}

		if($identifier == "BCCToUser"){
			$ud->setUserdata("BCCToUser",$key);
		}

		if($identifier == "viaMail"){
			$ud->setUserdata("sendBelegCopyViaEmail",$key);
		}
		if($identifier == "mailBetreff"){
			$ud->setUserdata("sendBelegViaEmailBetreff",$key);
		}
		if($identifier == "mailText"){
			$ud->setUserdata("sendBelegViaEmailText",$key);
		}
		if($identifier == "mailSender"){
			$ud->setUserdata("sendBelegViaEmailSender",$key);
		}
		if($identifier == "mailAttachments"){
			$ud->setUserdata("sendBelegViaEmailAttachments",$key);
		}
	}
	
	public function getProvisionCopy($ProvisionID){
		parent::getProvisionCopy($ProvisionID);
		echo "Posten erstellt";
	}
	
	public function getPostenCopy($ArtikelID){
		parent::getPostenCopy($ArtikelID);
		echo "Posten erstellt";
	}

	public function setPayed($p, $skonto = "0,00", $datum = "0", $isTeilzahlung = "false", $TeilzahlungBetrag = "", $save = true){
		echo parent::setPayed($p, $skonto, $datum, $isTeilzahlung, $TeilzahlungBetrag, $save);
	}
	
	public function copyPostenFrom($fromId){
		parent::copyPostenFrom($fromId);
		echo "message:AuftraegeMessages.M002";
	}
	
	public function copyPostenByTypeAndNumber($fromNumber, $fromType){
		parent::copyPostenByTypeAndNumber($fromNumber, $fromType);
	}
	
	public function addFile($id){
		mFileGUI::addFile("GRLBM",$this->ID, $id);
		echo "message:GlobalMessages.M002";
	}
	
	public function getLieferscheinAdresseCopy($adresseID){
		if($adresseID != 0){
			$AdresseOld = new Adresse($adresseID);
			$AdresseOld->changeA("AuftragID", $this->ID);
			$AdresseOld->changeA("type","lieferAdresse");
			$newID = $AdresseOld->newMe();
		} else $newID = 0;
		#if($newID == 0){
			$this->loadMe();
			$this->changeA("lieferAdresseID", $newID);
			$this->saveMe();
		#}
	}
}
?>