<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class GRLBMsGUI extends anyC implements iGUIHTMLMP2 {
	
	protected $gui;
	protected $type;
	protected $loadOldId = false;
	
	function __construct() {
		$this->setCollectionOf("GRLBM");
		#$this->type = "A";
		#$this->collectionOf = "GRLBM";
		$this->setParser("datum","Datum::parseGerDate");
		$this->setParser("lieferDatum","Datum::parseGerDate");
		$this->setParser("rabatt","mPosten::numberParser");
		$this->setParser("rabattInW","mPosten::numberParser");
		$this->setParser("leasingrate","mPosten::numberParser");
		$this->customize();
		$this->gui = new HTMLGUI();
		
		$this->gui->setName("GRLBM");
		$this->gui->setCollectionOf($this->collectionOf);
	}
	
	function getHTML($id, $page){

		$bps = $this->getMyBPSData();
		
		$pSpecData = mUserdata::getPluginSpecificData("Auftraege");
		if(isset($pSpecData["pluginSpecificCanOnlySeeKalk"]) AND $this->type != "Kalk")
			return "Access denied!";
		
		$html = GRLBMsGUI::getButtons($this->type,$bps["AuftragID"]);
		
		$this->addAssocV3("AuftragID","=",$bps["AuftragID"]);
		$this->addOrderV3("nummer","DESC");
		if($this->loadOldId)
			$this->addAssocV3("GRLBMID","=",$_SESSION["BPS"]->getProperty("GRLBMGUI","myID"));
			
		$gesamt = $this->loadMultiPageMode(-1, $page, 12);
		$this->gui->setMultiPageMode($gesamt, $page, 12, "subframe", "mGRLBM");
		#$entries, $page, $entriesPerPage, $targetFrame, $targetClass
		#if($this->A == null) $this->lCV3(-1);
		if($this->collector != null) $this->gui->setAttributes($this->collector);
		
		$this->gui->addColStyle("isAbschlussrechnung","width:20px;");
		$this->gui->setShowAttributes(array("nummer","datum"));
		$this->gui->setIsDisplayMode(true);
		$this->gui->setEditInDisplayMode(true,"subframe");
		#$this->gui->setDeleteInDisplayMode(true);

		$this->gui->addColStyle("nummer","width:150px;font-weight:bold;text-align:right;");
		
		$this->gui->setParser("datum","GRLBMsGUI::datumParser",array("\$isAbschlussrechnung", "\$isPrinted"));
		$this->gui->setParser("isAbschlussrechnung","GRLBMsGUI::isAbschlussrechnungParser");
		
		#try {
			if(count($this->collector) == 1 AND $page == 0)
				return $this->collector[0]->getGUIClass()->getHTML($this->collector[0]->getID(),$this->type,"","");
				
			return $html.$this->gui->getBrowserHTML(-1);
		#} catch (Exception $e){ echo "EXCEPTION!! $e"; }
	}
	
	public static function datumParser($w, $l, $p){
		$s = HTMLGUI::getArrayFromParametersString($p);
		return ($s[1] == "1" ? "<img style=\"float:right;margin-left:5px;\" title=\"Rechnung wurde als gedruckt markiert\" src=\"./images/i2/printeds.png\" />" : "").($s[0] == "1" ? "<img style=\"float:right;\" title=\"Abschlussrechnung\" src=\"./images/i2/ok.gif\" />" : "").$w;
	}
	
	public static function isAbschlussrechnungParser($w, $l, $p){
		return "";
	}
	
	public static function getButtons($type, $AuftragID, $pbutton = false){
		$pSpecData = mUserdata::getPluginSpecificData("Provisionen");
		return "
		<table>
			<tr>
				<td class=\"backgroundColor3\">
					".(( $type == "R" AND $pbutton AND $_SESSION["S"]->checkForPlugin("Provisionen") AND isset($pSpecData["pluginSpecificCanGiveProvisions"])) ? "<input type=\"button\" class=\"bigButton backgroundColor2\" style=\"float:right;background-image:url(./images/navi/provision.png);\" onclick=\"loadFrameV2('contentLeft','ProvisionSwitch');\" value=\"Provisionen\nvergeben\" />" : "")."
					<input type=\"button\" class=\"bigButton backgroundColor2\" style=\"background-image:url(./images/navi/".strtolower(Stammdaten::getLongType($type)).".png);\" onclick=\"$('".$type."Button').name = '1';createGRLBM('".$AuftragID."','Auftrag','$type');\" value=\"".Stammdaten::getLongType($type)."\nerstellen\" />
				</td>
			</tr>
		</table>";
	}
}
?>
