<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class PostenGUI extends Posten implements iGUIHTML2 {
	
	function __construct($ID){
		parent::__construct($ID);
		$this->setParser("mwst","Util::CLNumberParserZ");
	}
	
	function getHTML($id){
		#if($id != -1) $this->recalcNetto = false;
		$userLabels = mUserdata::getRelabels("Artikel");
		$userHiddenFields = mUserdata::getHides("Artikel");

		$mode = $_SESSION["BPS"]->getProperty("mPostenGUI","loadGRLBMID");
		$this->loadMeOrEmpty();

		if($this->A->isBrutto == "1")
			$this->A->preis = Util::CLNumberParserZ($this->A->bruttopreis,"load");
	
		if($id == -1) {
			$this->A = $this->newAttributes();
			$this->A->GRLBMID = $mode;
		}


		$gui = new HTMLGUI();
		$gui->setObject($this);
		$gui->setName("Posten");
		$gui->setFormID("1xPostenForm");
		
		$gui->setLabel("gebinde","Einheit");
		$gui->setType("beschreibung","textarea");
		$gui->setType("bemerkung","hidden");

		$gui->setParser("preis","ArtikelGUI::preisInputParser",array("Brutto- in Nettopreis umrechnen"));
		
		$gui->insertSpaceAbove("menge");
		$gui->insertSpaceAbove("beschreibung");
		$gui->insertSpaceAbove("EK1");
		$gui->insertSpaceAbove("createArtikel");
		$gui->hideAttribute("PostenID");


		$gui->setType("createArtikel", "checkbox");
		if($this->A("oldArtikelID") != "0" AND $this->A("oldArtikelID") != "")
			$gui->setType("createArtikel", "hidden");
		$gui->setLabel("createArtikel", "Artikel?");
		$gui->setFieldDescription("createArtikel","Soll dieser Posten als Artikel angelegt werden?");

		if($_SESSION["S"]->checkForPlugin("mBrutto")){
			$gui->setType("isBrutto","checkbox");
			$gui->setLabel("isBrutto","Bruttopreis?");
			$gui->setFieldDescription("isBrutto","Ist der angegebene Preis ein Bruttopreis?");
			$gui->setLabel("preis","Preis");
		} else {
			$gui->hideAttribute("isBrutto");
		}

		$gui->hideAttribute("bruttopreis");
		
		foreach($userHiddenFields as $key => $value)
			$gui->hideAttribute($key);
		
		foreach($userLabels as $key => $value)
			$gui->setLabel($key,$value);
			
		$gui->setType("GRLBMID","hidden");
		$kat = new Kategorien();
		$kat->addAssocV3("type","=","mwst");
		#$gui->setType("bemerkung","textarea");
		#$gui->setLabelDescription("bemerkung","intern");
		$gui->setType("oldArtikelID","hidden");
		$keys = array();
		$values = $kat->getArrayWithValues();
		for($i=0;$i<count($values);$i++)
			$keys[] = str_replace("%","",$values[$i]);

		$keys[] = "0";
		$values[] = "bitte auswählen";
		
		$gui->setOptions("mwst",$keys,$values);
		$gui->setType("mwst","select");
		
		$gui->setJSEvent("onSave","function() { 
					"./*($this->ID != -1 ?
					"new Ajax.Updater('BrowserMain".$this->ID."','./interface/loadFrame.php?p=mPosten&amp;id=".$this->ID."&amp;type=main');" 
					: */
					"contentManager.loadFrame('contentRight','Auftraege');
					contentManager.loadFrame('subframe','mGRLBM','-2');"/*)*/."
				}");

		$gui->customize($this->customizer);

		$gui->setStandardSaveButton($this);
		/*$gui->setSaveButtonOnClick("
			saveClass(
				'".get_parent_class($this)."',
				'".$this->ID."',
				
			,'1xPostenForm');");*/
		
		return $gui->getEditHTML();
	}
	
	public function saveMultiEditField($field,$value){
		parent::saveMultiEditField($field,$value);
		echo "Änderung gespeichert";
	}
}
?>