<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class mPostenGUI extends mPosten implements iGUIHTML2, icontextMenu {

	public $additionalCalculatorFields = "";
	public $showRabatt = false;
	
	function __construct(){
		$this->setParser("menge","Util::CLNumberParserZ");
		$this->setParser("preis","Util::CLNumberParserZ");
		$this->setParser("EK1","Util::CLNumberParserZ");
		$this->setParser("EK2","Util::CLNumberParserZ");
		$this->customize();
		parent::__construct();
	}
	
	function getHTML($id){
		$ud = new mUserdata();
		$aT = $ud->getUDValue("GRLBMAnsicht");
		
		if($aT == null)
			$view = "2";
		else $view = $aT;
		
		$bps = $this->getMyBPSData();
		if($bps["GRLBMType"] == "Kalk" AND $view < 3) $view = 3;
		#print_r($this->getMyBPSData());
		$this->setAssocV3("GRLBMID","=",$bps["loadGRLBMID"]);
		
		$tempPosten = new Posten(-1);
		$PostenAttributes = $tempPosten->newAttributes();
		
		//Be sure this field exists else the Rechnung will show 0,00€ total
		if(!isset($PostenAttributes->bruttopreis)) throw new FieldDoesNotExistException("bruttopreis","");
		
		unset($tempPosten);
		$PostenAttributes = PMReflector::getAttributesArrayAnyObject($PostenAttributes);
		#unset($PostenAttributes[array_search("createArtikel", $PostenAttributes)]);
		$PostenAttributes[] = "menge AS mengeUnparsed";
		$PostenAttributes[] = "preis AS preisUnparsed";
		$PostenAttributes[] = "EK1 AS EK1Unparsed";
		$PostenAttributes[] = "EK2 AS EK2Unparsed";
		$PostenAttributes[] = "mwst AS mwstUnparsed";
		
		$this->setFieldsV3($PostenAttributes);
		
		$GRLBM = new GRLBM($bps["loadGRLBMID"]);
		$GRLBM->loadMe();
		
		if($this->A == null) $this->lCV3($id);
		$userLabels = mUserdata::getRelabels("Artikel");
		$userHiddenFields = mUserdata::getHides("Artikel");

		$gui = new HTMLGUI();
		$gui->setObject($this);
		$gui->customize($this->customizer);
		
		$html = "
		<form id=\"mPostenForm\">
		<div class=\"backgroundColor1 Tab\" style=\"margin-top:30px;\"><p><img src=\"./images/navi/".strtolower(Stammdaten::getLongType($bps["GRLBMType"])).".png\" style=\"float:right;margin-top:-20px;\" />".Stammdaten::getLongType($bps["GRLBMType"],true)."posten:</p></div>
		<table>
			<colgroup>
				<col class=\"backgroundColor3\" style=\"width:80px;\" />
				<col class=\"backgroundColor2\" />
				<col class=\"backgroundColor3\" style=\"width:80px;\" />
				".($view > 1 ? "<col class=\"backgroundColor2\" style=\"width:35px;\" />" : "")."
			</colgroup>
			<tr>
				<td class=\"backgroundColor3\" colspan=\"4\">".$this->addPostenButton2("","",array($bps["loadGRLBMID"], $GRLBM->getA()->isPayed))."</td>
			</tr>";
		
		if($this->numLoaded() == 0 OR $view > 3){
			$html .= "
			<tr>
				<td colspan=\"4\"><input type=\"button\" value=\"Posten\nkopieren\" style=\"background-image:url(./images/navi/seiten.png);\" class=\"bigButton backgroundColor2\" onclick=\"contextMenu.start(this, 'mPosten','1','Kopieren aus:');\" /></td>
			</tr>";
		}
		if($this->numLoaded() > 0) while($t = $this->getNextEntry()) {
			$ta = $t->getA();

			#<img style=\"float:right;\" class=\"calendarIcon mouseoverFade\" style=\"margin-right:0px;\" src=\"./images/i2/delete.gif\" onclick=\"\"/>
			$BSettings = new Button("Optionen","./images/i2/settings.png");
			$BSettings->type("icon");
			$BSettings->style("float:right;");
			$BSettings->onclick("if($('optionsPosten".$t->getID()."').style.display == 'none') $('optionsPosten".$t->getID()."').style.display = ''; else $('optionsPosten".$t->getID()."').style.display = 'none';");

			$BTrash = new Button("Posten löschen","./images/i2/delete.gif");
			$BTrash->type("icon");
			$BTrash->style("float:right;margin-right:10px;");
			$BTrash->onclick("deleteClass('Posten','".$t->getID()."',function() { $('PostenDisplayD".$t->getID()."1').style.display='none'; $('PostenDisplayD".$t->getID()."2').style.display='none'; if($('PostenDisplayD".$t->getID()."4')) $('PostenDisplayD".$t->getID()."4').style.display='none'; $('PostenDisplayD".$t->getID()."3').style.display='none'; $('optionsPosten".$t->getID()."').style.display='none';  },'Posten wirklich löschen?');");

			$BEdit = new Button("Posten bearbeiten","./images/i2/edit.png");
			$BEdit->type("icon");
			$BEdit->style("float:right;");
			$BEdit->onclick("contentManager.loadFrame('contentRight','Posten','{$t->getID()}');");

			if($ta->isBrutto == "1") {
				$ta->preis = Util::CLNumberParserZ($ta->bruttopreis, "load");
				$ta->preisUnparsed = $ta->bruttopreis;
			}
			$html .= "
			<tr id=\"PostenDisplayD".$t->getID()."3\">
				<td class=\"backgroundColor0\"></td>
			</tr>
			<tr class=\"backgroundColor2\" id=\"PostenDisplayD".$t->getID()."1\">
				<td colspan=\"4\">
					$BSettings
					<input
						style=\"float:right;margin-right:10px;width:40%;text-align:left;\"
						class=\"multiEditInput2\"
						onfocus=\"oldValue = this.value;\"
						onblur=\"if(oldValue != this.value) saveMultiEditInput('Posten','".$t->getID()."','beschreibung');\" value=\"".htmlentities($ta->beschreibung, ENT_COMPAT, "UTF-8")."\"
						id=\"beschreibungID".$t->getID()."\"
						type=\"text\"
						onkeydown=\"if(event.keyCode == 13) saveMultiEditInput('Posten','".$t->getID()."','beschreibung');\"  /> 
						
					<input
						style=\"width:49%;font-weight:bold;text-align:left;\"
						class=\"multiEditInput2\"
						onfocus=\"oldValue = this.value;\"
						onblur=\"if(oldValue != this.value) saveMultiEditInput('Posten','".$t->getID()."','name');\"
						value=\"".htmlentities($ta->name, ENT_COMPAT, "UTF-8")."\"
						id=\"nameID".$t->getID()."\"
						type=\"text\"
						onkeydown=\"if(event.keyCode == 13) saveMultiEditInput('Posten','".$t->getID()."','name');\"  />
				</td>
			</tr>
			<tr id=\"optionsPosten".$t->getID()."\" style=\"display:none;\">
				<td colspan=\"4\">$BEdit$BTrash</td>
			</tr>
			<tr id=\"PostenDisplayD".$t->getID()."2\">
				<td>M: <input class=\"multiEditInput2\" onfocus=\"oldValue = this.value;\" onblur=\"if(oldValue != this.value) saveMultiEditInput('Posten','".$t->getID()."','menge'); updateEKs('".$t->getID()."');\" value=\"$ta->menge\" id=\"mengeID".$t->getID()."\" type=\"text\"onkeyup=\" updateEKs('".$t->getID()."');\" onkeydown=\"if(event.keyCode == 13) saveMultiEditInput('Posten','".$t->getID()."','menge');\"  /></td>
				<td>".($this->showRabatt ? "<span  style=\"float:right;\">R: <input class=\"multiEditInput2\" onfocus=\"oldValue = this.value;\" onblur=\"if(oldValue != this.value) saveMultiEditInput('Posten','".$t->getID()."','rabatt');\" value=\"$ta->rabatt\" id=\"rabattID".$t->getID()."\" type=\"text\" onkeyup=\"updateEKs('".$t->getID()."');\" onkeydown=\"if(event.keyCode == 13) saveMultiEditInput('Posten','".$t->getID()."','rabatt');\"  /></span>" : "")."$ta->gebinde</td>
				<td>P: <input class=\"multiEditInput2\" onfocus=\"oldValue = this.value;\" onblur=\"if(oldValue != this.value) saveMultiEditInput('Posten','".$t->getID()."','preis');\" value=\"$ta->preis\" id=\"preisID".$t->getID()."\" type=\"text\" onkeyup=\"updateEKs('".$t->getID()."');\" onkeydown=\"if(event.keyCode == 13) saveMultiEditInput('Posten','".$t->getID()."','preis');\"  /></td>
				".($view > 1 ? "<td style=\"text-align:right;\">".Util::formatNumber("de_DE", $ta->mwst*1, 2, false, false)."%</td>" : "")."
			</tr>".
				
			(($view > 2 AND $bps["GRLBMType"] == "Kalk") ? "
			<tr id=\"PostenDisplayD".$t->getID()."4\" ".((isset($userHiddenFields["EK1"]) AND isset($userHiddenFields["EK2"])) ? "style=\"display:none;\"" : "").">
				<td></td>
				<td colspan=\"3\">
					".(!isset($userHiddenFields["EK1"]) ? (isset($userLabels["EK1"]) ? $userLabels["EK1"] : "EK1").": <input style=\"margin-right:30px;\" class=\"multiEditInput2\" onfocus=\"oldValue = this.value;\" onblur=\"if(oldValue != this.value) saveMultiEditInput('Posten','".$t->getID()."','EK1');\" value=\"$ta->EK1\" id=\"EK1ID".$t->getID()."\" type=\"text\" onkeydown=\"if(event.keyCode == 13) saveMultiEditInput('Posten','".$t->getID()."','EK1');\"  />" : "")."

					".(!isset($userHiddenFields["EK2"]) ? (isset($userLabels["EK2"]) ? $userLabels["EK2"] : "EK2").": <input class=\"multiEditInput2\" onfocus=\"oldValue = this.value;\" onblur=\"if(oldValue != this.value) saveMultiEditInput('Posten','".$t->getID()."','EK2');\" value=\"$ta->EK2\" id=\"EK2ID".$t->getID()."\" type=\"text\" onkeydown=\"if(event.keyCode == 13) saveMultiEditInput('Posten','".$t->getID()."','EK2');\"  />" : "")."</td>
			</tr>" : "").
				
			(($view > 2 AND $bps["GRLBMType"] != "Kalk") ? "
			<tr id=\"PostenDisplayD".$t->getID()."4\" ".((isset($userHiddenFields["EK1"]) AND isset($userHiddenFields["EK2"])) ? "style=\"display:none;\"" : "").">
				<td colspan=\"4\" style=\"color:grey;\">
					".(!isset($userHiddenFields["EK1"]) ? (isset($userLabels["EK1"]) ? $userLabels["EK1"] : "EK1").": <input style=\"width:70px;text-align:right;margin-right:20px;\" value=\"".(Util::CLNumberParserZ($ta->mengeUnparsed * $ta->EK1Unparsed,"load"))."\" id=\"EK1dID".$t->getID()."\" type=\"text\" readonly=\"readonly\"  /><input value=\"$ta->EK1\" id=\"EK1ID".$t->getID()."\" type=\"hidden\" />" : "")."
					".(!isset($userHiddenFields["EK2"]) ? (isset($userLabels["EK2"]) ? $userLabels["EK2"] : "EK2").": <input style=\"width:70px;text-align:right;margin-right:20px;\" value=\"".(Util::CLNumberParserZ($ta->mengeUnparsed * $ta->EK2Unparsed,"load"))."\" id=\"EK2dID".$t->getID()."\" type=\"text\" readonly=\"readonly\"  /><input value=\"$ta->EK2\" id=\"EK2ID".$t->getID()."\" type=\"hidden\" />" : "")."
					VK: <input style=\"width:70px;text-align:right;margin-right:30px;\" value=\"".(Util::CLNumberParserZ($ta->mengeUnparsed * $ta->preisUnparsed,"load"))."\" id=\"VKID".$t->getID()."\" type=\"text\" readonly=\"readonly\"  />
					</td>
			</tr>" : "");
		
		}
		
		if($bps["GRLBMType"] == "Kalk") $html .= "
		</table>
		</form>
		<table>
			<colgroup>
				<col class=\"backgroundColor2\" style=\"width:120px;\" />
				<col class=\"backgroundColor3\" />
			</colgroup>
			<tr>
				<td class=\"backgroundColor0\"></td>
			</tr>
			".(!isset($userHiddenFields["EK1"]) ? "<tr>
				<td><label>ges. ".(isset($userLabels["EK1"]) ? $userLabels["EK1"] : "EK1").":</label></td>
				<td id=\"gesamtEK1\" style=\"text-align:right;\"></td>
			</tr>" : "")."
			".(!isset($userHiddenFields["EK2"]) ? "<tr>
				<td><label>ges. ".(isset($userLabels["EK2"]) ? $userLabels["EK2"] : "EK2").":</label></td>
				<td id=\"gesamtEK2\" style=\"text-align:right;\"></td>
			</tr>" : "")."
			<tr>
				<td><label>ges. VK:</label></td>
				<td id=\"gesamtVK\" style=\"text-align:right;\"></td>
			</tr>
			<tr>
				<td class=\"backgroundColor0\"></td>
			</tr>
			<tr>
				<td><label>Rabatt in %:</label></td>
				<td id=\"rabattInP\" style=\"text-align:right;\"></td>
			</tr>
			<tr>
				<td><label>Rabatt in €:</label></td>
				<td id=\"rabattInW2\" style=\"text-align:right;\"></td>
			</tr>
			<tr>
				<td><label>ges. VK:</label></td>
				<td id=\"gesamtVK2\" style=\"text-align:right;\"></td>
			</tr>
			<tr>
				<td class=\"backgroundColor0\"></td>
			</tr>
			".(!isset($userHiddenFields["EK1"]) ? "<tr>
				<td><label>VK - ".(isset($userLabels["EK1"]) ? $userLabels["EK1"] : "EK1").":</label></td>
				<td id=\"VKEK1\" style=\"text-align:right;font-weight:bold;\"></td>
			</tr>" : "")."
			".(!isset($userHiddenFields["EK2"]) ? "<tr>
				<td><label>VK - ".(isset($userLabels["EK2"]) ? $userLabels["EK2"] : "EK2").":</label></td>
				<td id=\"VKEK2\" style=\"text-align:right;font-weight:bold;\"></td>
			</tr>" : "")."
			<tr>
				<td><label>Leasingrate:</label></td>
				<td id=\"leasingrate2\" style=\"text-align:right;\"></td>
			</tr>
			$this->additionalCalculatorFields
			<tr>
				<td colspan=\"2\"><input type=\"button\" value=\"Werte berechnen\" onclick=\"calculateKalk();\" /></td>
			</tr>
		</table>";
		elseif($view > 3){
			$html .= "
		</table>
		</form>
		<table>
			<colgroup>
				<col class=\"backgroundColor2\" style=\"width:120px;\" />
				<col class=\"backgroundColor3\" />
			</colgroup>
			".(!isset($userHiddenFields["EK1"]) ? "<tr>
				<td><label>ges. ".(isset($userLabels["EK1"]) ? $userLabels["EK1"] : "EK1").":</label></td>
				<td id=\"gesamtEK1\" style=\"text-align:right;\"></td>
			</tr>" : "")."
			".(!isset($userHiddenFields["EK2"]) ? "<tr>
				<td><label>ges. ".(isset($userLabels["EK2"]) ? $userLabels["EK2"] : "EK2").":</label></td>
				<td id=\"gesamtEK2\" style=\"text-align:right;\"></td>
			</tr>" : "")."
			<tr>
				<td><label>ges. VK:</label></td>
				<td id=\"gesamtVK\" style=\"text-align:right;\"></td>
			</tr>
			<tr>
				<td class=\"backgroundColor0\"></td>
			</tr>
			".(!isset($userHiddenFields["EK1"]) ? "<tr>
				<td><label>VK - ".(isset($userLabels["EK1"]) ? $userLabels["EK1"] : "EK1").":</label></td>
				<td id=\"VKEK1\" style=\"text-align:right;font-weight:bold;\"></td>
			</tr>" : "")."
			".(!isset($userHiddenFields["EK2"]) ? "<tr>
				<td><label>VK - ".(isset($userLabels["EK2"]) ? $userLabels["EK2"] : "EK2").":</label></td>
				<td id=\"VKEK2\" style=\"text-align:right;font-weight:bold;\"></td>
			</tr>" : "")."
			<tr>
				<td colspan=\"2\"><input type=\"button\" value=\"Werte berechnen\" onclick=\"calculateKalk();\" /></td>
			</tr>
		</table>";
		} else $html .= "
		</table>
		</form>";
		return $html;
	}
	
	public function addPostenButton2($w,$t,$p){
		#$bps = $this->getMyBPSData();
		#$s = HTMLGUI::getArrayFromParametersString($p);
		
		$html = "<img src=\"./images/i2/settings.png\" class=\"calendarIcon mouseoverFade\" onclick=\"contextMenu.start(this, 'mPosten','100','Ansicht:');\">";
		
		if($p[1] == "0") return "
		<input type=\"button\" value=\"1x-Posten\nhinzufügen\" class=\"bigButton backgroundColor2\" style=\"float:right;background-image:url(./images/navi/1xPosten.png);\" onclick=\"loadFrameV2('contentRight','Posten');\" />
		$html
		<input type=\"button\" value=\"Posten\nhinzufügen\" class=\"bigButton backgroundColor2\" style=\"background-image:url(./images/navi/package.png);\" onclick=\"loadFrameV2('contentRight','mArtikel','_mArtikelGUI;selectionMode:multiSelection,GRLBM,-2,getPostenCopy,Auftraege,subframe,mGRLBM,-2');\" />";
		
		else return $html."Diese Rechnung wurde als bezahlt makiert und kann daher nicht mehr bearbeitet werden.";
	}
	
	public function getContextMenuHTML($identifier){
		$bps = $this->getMyBPSData();
		
		switch($identifier){
			case "1":
				echo "
				<table>
					<tr>
						<td><input type=\"button\" value=\"Angebot\" style=\"background-image:url(./images/navi/angebot.png);\" class=\"bigButton backgroundColor2\" onclick=\"contextMenu.update('mPosten','A','Angebote:');\" /></td>
					</tr>
					<tr>
						<td><input type=\"button\" value=\"Lieferschein\" style=\"background-image:url(./images/navi/lieferschein.png);\" class=\"bigButton backgroundColor2\" onclick=\"contextMenu.update('mPosten','L','Lieferscheine:');\" /></td>
					</tr>
					<tr>
						<td><input type=\"button\" value=\"Rechnung\" style=\"background-image:url(./images/navi/rechnung.png);\" class=\"bigButton backgroundColor2\" onclick=\"contextMenu.update('mPosten','R','Rechnungen:');\" /></td>
					</tr>
					<tr>
						<td><input type=\"button\" value=\"Gutschrift\" style=\"background-image:url(./images/navi/gutschrift.png);\" class=\"bigButton backgroundColor2\" onclick=\"contextMenu.update('mPosten','G','Gutschriften:');\" /></td>
					</tr>
				</table>";
			break;
			
			case "A":
			case "L":
			case "R":
			case "G":
				echo "
				<div id=\"copyContextExtension\" class=\"borderColor1 backgroundColor0\" style=\"float:right;width:200px;margin-right:-207px;padding:5px;border-style:solid;border-width:1px;\"></div>
				<table>
					<colgroup>
						<col style=\"width:20px;\" />
						<col class=\"backgroundColor2\" />
						<col class=\"backgroundColor3\" />
					</colgroup>";
				$G = new mGRLBMGUI();
				$G->addJoinV3("Auftrag","AuftragID","=","AuftragID");
				$G->setAssocV3("is$identifier","=","1");
				if($bps != -1) $G->addAssocV3("GRLBMID","!=",$bps["loadGRLBMID"]);
				$G->addOrderV3("nummer","DESC");
				$G->setLimitV3("10");
				$G->lCV3();
				while(($t = $G->getNextEntry())){

					$Adresse = null;
					if($t->getA()->AdresseID != ""){
						$Adresse = new Adresse($t->getA()->AdresseID);
						$Adresse->loadMe();
					}
					
					echo "
					<tr onclick=\"Auftrag.copyPostenFrom('".$t->getID()."','".$bps["loadGRLBMID"]."','$identifier','subframe');\" class=\"".(($bps != -1 AND $bps["AuftragID"] == $t->getA()->AuftragID) ? "backgroundColor1" : "")."\" onmouseout=\"this.className='".(($bps != -1 AND $bps["AuftragID"] == $t->getA()->AuftragID) ? "backgroundColor1" : "")."';\" style=\"cursor:pointer;\" onmouseover=\"this.className = 'backgroundColor0'; $('copyContextExtension').update('".($Adresse != null ? $Adresse->getA()->firma.($Adresse->getA()->nachname != "" ? "<br />".$Adresse->getA()->nachname." ".$Adresse->getA()->vorname : "") : "keine Daten verfügbar")."');\">
						<td><img src=\"./images/i2/copy.png\" class=\"mouseoverFade\" /></td>
						<td>".$identifier.$t->getA()->nummer."</td>
						<td>".$t->getA()->datum."</td>
					</tr>";
				}
				
				$B = new Button("Posten kopieren","./images/i2/save.gif");
				$B->type("icon");
				$B->style("float:right;");
				$B->onclick("Auftrag.copyPostenByTypeAndNumber($('copyFromNumber').value, '$identifier', '".$bps["loadGRLBMID"]."', 'subframe');");
				
				echo "<tr>
					<td colspan=\"3\">Geben Sie die Nummer ein:</td>
				</tr><tr>
					<td colspan=\"3\">$B<input type=\"text\" style=\"width:80%;\" id=\"copyFromNumber\"></td>
				</tr>
				</table>";
			break;
			
			case "100":
				$ud = new mUserdata();
	
				$aT = $ud->getUDValue("GRLBMAnsicht");
				
				if($aT == null)
					$selectedKey = "2";
				else $selectedKey = $aT;
				
				$kAL = array();
				$kAL["1"] = "wenig";
				$kAL["2"] = "normal";
				$kAL["3"] = "viel";
				$kAL["4"] = "sehr viel";
				
				$gui = new HTMLGUI();
				echo $gui->getContextMenu($kAL, "mPosten", "100", $selectedKey, "new Ajax.Updater(\'subframe\',\'./interface/loadFrame.php?p=mGRLBM&id=-2\');");
			break;
		}
	}
	
	public function saveContextMenu($identifier, $key){
		$ud = new mUserdata();
		
		if($identifier == "100") $ud->setUserdata("GRLBMAnsicht",$key);
	}
	
}
?>
