<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class multiPrintBasketGUI extends UnpersistentClass implements iGUIHTML2 {

	public function addToList() {
		$_SESSION["BPS"]->setActualClass(get_class($this));
		$bps = $_SESSION["BPS"]->getAllProperties();
		
		$pSpecData = mUserdata::getPluginSpecificData("Auftraege");
		
		if($bps == -1 OR !isset($bps["add"])) return;
		else $what = $bps["add"];
			
		$bps = $_SESSION["BPS"]->getAllProperties();
		
		$gs = new anyC();
		$gs->setCollectionOf("GRLBM");
		if($what != "Kalk") $gs->addAssocV3("is$what","=","1");
		else $gs->addAssocV3("isWhat","=","$what");
		$gs->addAssocV3("isPrinted","=","0");
		if($what != "M") $gs->addJoinV3("Auftrag","AuftragID","=","AuftragID");
		if($what != "M") $gs->addAssocV3("auftragDatum","IS","NOT NULL");

		if($what == "R") $gs->addAssocV3("isPayed","!=","2"); //keine stornierten Rechnungen

		if(isset($pSpecData["pluginSpecificCanOnlyEditOwn"])) $gs->addAssocV3("UserID","= ",$_SESSION["S"]->getCurrentUser()->getID());
		
		$newIds = array();
		while(($t = $gs->getNextEntry())){
			if(isset($bps["ids"]) AND strstr($bps["ids"],",,".$t->getID().",,")) continue;
			$newIds[] = $t->getID();
		}
		$_SESSION["BPS"]->setACProperty("add","");
		$_SESSION["BPS"]->setACProperty("ids",(isset($bps["ids"]) ? $bps["ids"] : ",,").implode(",,",$newIds).(count($newIds) > 0 ? ",," : ""));
	}

	public function emptyList() {
		//has to do nothing, the list will be emptied via BPS
	}
	
	/**
	 * @return GRLBMsGUI
	 */
	public function getGRLBMS(){
		$gs = new GRLBMsGUI();
		
		$_SESSION["BPS"]->setActualClass("multiPrintBasketGUI");
		$bps = $_SESSION["BPS"]->getAllProperties();

		if(!isset($bps["ids"])) {
			$bps = array();
			$bps["ids"] = ",,";
		}
		$ids = explode(",,",$bps["ids"]);
		$gs->addAssocV3("GRLBMID","=","-1","OR");
		
		for($i=1;$i<count($ids)-1;$i++)
			$gs->addAssocV3("GRLBMID","=",$ids[$i],"OR");
		
		return $gs;
	}
	
	function getHTML($id){
		$bps = $this->getMyBPSData();
		if($bps != -1 AND isset($bps["add"]) AND $bps["add"] != "") $this->addToList();
			

		$pSpecData = mUserdata::getPluginSpecificData("Auftraege");

		$BE = new Button("Liste\nleeren","clear");
		$BE->className("backgroundColor2");
		#$BE->rmePCR("multiPrintBasket", "", "emptyList", "", "",'multiPrintBasketGUI;-');
		$BE->onclick("contentManager.loadFrame('editDetailsContentmultiPrintBasket','multiPrintBasket','',0,'multiPrintBasketGUI;-');");
		#rme('multiPrintBasket', '', 'emptyList', '', "loadFrameV2('contentLeft','multiPrintBasket');",'multiPrintBasketGUI;-');

		$BK = new Button("Neue Kalkulationen hinzufügen","kalkulation");
		$BK->type("icon");
		$BK->style("float:right;margin-right:3px;");
		$BK->onclick("contentManager.loadFrame('editDetailsContentmultiPrintBasket','multiPrintBasket','',0,'_multiPrintBasketGUI;add:Kalk');");

		$BM = new Button("Neue Mahnungen hinzufügen","mahnung");
		$BM->type("icon");
		$BM->style("float:right;margin-right:3px;");
		$BM->onclick("contentManager.loadFrame('editDetailsContentmultiPrintBasket','multiPrintBasket','',0,'_multiPrintBasketGUI;add:M');");

		$BG = new Button("Neue Gutschrift hinzufügen","gutschrift");
		$BG->type("icon");
		$BG->style("float:right;margin-right:3px;");
		$BG->onclick("contentManager.loadFrame('editDetailsContentmultiPrintBasket','multiPrintBasket','',0,'_multiPrintBasketGUI;add:G');");

		$BR = new Button("Neue Rechnungen hinzufügen","rechnung");
		$BR->type("icon");
		$BR->style("float:right;margin-right:3px;");
		$BR->onclick("contentManager.loadFrame('editDetailsContentmultiPrintBasket','multiPrintBasket','',0,'_multiPrintBasketGUI;add:R');");

		$BL = new Button("Neue Lieferscheine hinzufügen","lieferschein");
		$BL->type("icon");
		$BL->style("float:right;margin-right:3px;");
		$BL->onclick("contentManager.loadFrame('editDetailsContentmultiPrintBasket','multiPrintBasket','',0,'_multiPrintBasketGUI;add:L');");

		$BA = new Button("Neue Angebote hinzufügen","angebot");
		$BA->type("icon");
		$BA->style("float:right;margin-right:3px;");
		$BA->onclick("contentManager.loadFrame('editDetailsContentmultiPrintBasket','multiPrintBasket','',0,'_multiPrintBasketGUI;add:A');");

		#<input type=\"button\" class=\"bigButton backgroundColor2\" value=\"\" style=\"background-image:url(./images/navi/clear.png);\" onclick=\"\" />
		$html = "
		<!--<div class=\"backgroundColor1 Tab\"><p>multiDruck Liste:</p></div>-->
		<table>
			<colgroup>
				<col class=\"backgroundColor3\" />
				<col class=\"backgroundColor2\" style=\"width:20px;\" />
				<col class=\"backgroundColor3\" style=\"width:20px;\" />
				<col class=\"backgroundColor0\" style=\"width:20px;\" />
			</colgroup>
			<tr>
				<td colspan=\"4\">
					".($_SESSION["applications"]->getActiveApplication() == "open3A" ? "
					$BK<!--<img style=\"float:right;margin-right:3px;\" src=\"./images/navi/kalkulation.png\"		title=\"Neue Kalkulationen hinzufügen\"		class=\"mouseoverFade\" onclick=\"addToList('_multiPrintBasketGUI;add:Kalk');\" />-->
					".(!isset($pSpecData["pluginSpecificCanOnlySeeKalk"]) ? "
					$BM$BG$BR$BL$BA<!--<img style=\"float:right;margin-right:3px;\" src=\"./images/navi/mahnung.png\"			title=\"Neue Mahnungen hinzufügen\"			class=\"mouseoverFade\" onclick=\"addToList('_multiPrintBasketGUI;add:M');\" />
					<img style=\"float:right;margin-right:3px;\" src=\"./images/navi/gutschrift.png\"		title=\"Neue Gutschriften hinzufügen\"		class=\"mouseoverFade\" onclick=\"addToList('_multiPrintBasketGUI;add:G');\" />
					<img style=\"float:right;margin-right:3px;\" src=\"./images/navi/rechnung.png\"			title=\"Neue Rechnungen hinzufügen\"		class=\"mouseoverFade\" onclick=\"addToList('_multiPrintBasketGUI;add:R');\" />
					<img style=\"float:right;margin-right:3px;\" src=\"./images/navi/lieferschein.png\"		title=\"Neue Lieferscheine hinzufügen\"		class=\"mouseoverFade\" onclick=\"addToList('_multiPrintBasketGUI;add:L');\" />
					<img style=\"float:right;margin-right:3px;\" src=\"./images/navi/angebot.png\"			title=\"Neue Angebote hinzufügen\"			class=\"mouseoverFade\" onclick=\"addToList('_multiPrintBasketGUI;add:A');\" />-->
					" : "")." " : "")."
					$BE
					</td>
			</tr>";

		/*if($this->isExternal){
			$html = "
		<table>
			<colgroup>
				<col class=\"backgroundColor3\" />
				<col class=\"backgroundColor2\" style=\"width:20px;\" />
				<col class=\"backgroundColor3\" style=\"width:20px;\" />
				<col class=\"backgroundColor0\" style=\"width:20px;\" />
			</colgroup>";
		}*/

		$gs = $this->getGRLBMS();
	
		$BPL = "";
		if($_SESSION["S"]->checkForPlugin("PL")){
			$BPL = new Button("mit PixelLetter\nverschicken","./open3A/PixelLetter/pl.png");
			$BPL->className("backgroundColor2");
			$BPL->style("float:right;");
			$BPL->onclick("if(confirm('Rechnungen jetzt mit PixelLetter signieren und verschicken?')) ");
			$BPL->rme("multiPrintBasket", "", "sendViaPL","","if(checkResponse(transport)) { Popup.create(12346, \'mpbLog\', \'PL-Versand Logbuch\'); Popup.update(transport, 12346, \'mpbLog\'); }");
		}
		
		while(($t = $gs->getNextEntry())){
			$M = "";
			if($t->getMyPrefix() == "M"){
				$GRLBM = new GRLBM($t->A("AuftragID"));
				$M = $GRLBM->A("nummer")."/";
			}
			
			if($_SESSION["S"]->checkForPlugin("PL") AND $t->getMyPrefix() != "R")
				$BPL->disabled(true);
			
			#editDetailsContentmultiPrintBasket

			$subFromMultiPrint = "contentManager.loadFrame('editDetailsContentmultiPrintBasket','multiPrintBasket',0,0,'_multiPrintBasketGUI;-ids:".$t->getID()."'); if($('subID".$t->getID()."')) $('subID".$t->getID()."').style.display = 'none'; if($('addID".$t->getID()."')) $('addID".$t->getID()."').style.display = 'block';";

			$OK = "";
			if($t->A("isPrinted") == "0"){
				$OK = new Button("bereits gedruckt - als gedruckt markieren und aus Liste entfernen","./images/i2/okCatch.png");
				$OK->type("icon");
				$OK->rmePCR("multiPrintBasket", "", "setPrinted", $t->getID(), $subFromMultiPrint);#"subFromMultiPrint(\'".$t->getID()."\');"
			}


			$BUP = new Button("bereits gedruckt (klicken Sie, um den gedruckt-Status wieder aufzuheben)","./images/i2/printeds.png");
			$BUP->rmePCR("GRLBM", $t->getID(), "markMeAsUnprinted", "", "contentManager.loadFrame('editDetailsContentmultiPrintBasket','multiPrintBasket');");
			$BUP->type("icon");
			#<img id=\"printedSymbol".$t->getID()."\" class=\"mouseoverFade\" onclick=\"rme('GRLBM','".$t->getID()."','markMeAsUnprinted','','$(\'printedSymbol".$t->getID()."\').style.display=\'none\';');\" src=\"./images/i2/printeds.png\" title=\"bereits gedruckt (klicken Sie, um den gedruckt-Status wieder aufzuheben)\" />

			$html .= "
			<tr>
				<td>".str_replace("Kalk","K",$t->getMyPrefix()).$M.$t->getA()->nummer."</td>
				<td>".($t->getA()->isPrinted == 1 ? $BUP : "")."</td>
				<td>$OK</td>
				<td><img src=\"./images/i2/delete.gif\" onclick=\"$subFromMultiPrint\" class=\"mouseoverFade\" /></td>
			</tr>";
		}
		
		$BM = new Button("per E-Mail\nverschicken","mail");
		$BM->className("backgroundColor2");
		$BM->rme("multiPrintBasket", "", "sendViaEmail","","if(checkResponse(transport)) { Popup.create(12345, \'mpbLog\', \'E-Mail-Versand Logbuch\'); Popup.update(transport, 12345, \'mpbLog\'); }");

		$BP = new Button("als gedruckt\nmarkieren","printed");
		$BP->className("backgroundColor2");
		$BP->rmePCR("multiPrintBasket", "", "markListAsPrinted","","contentManager.loadFrame('editDetailsContentmultiPrintBasket','multiPrintBasket');");
		#<input type=\"button\" style=\"background-image:url(./images/navi/printed.png);\" class=\"bigButton backgroundColor2\" value=\"als gedruckt\nmarkieren\" onclick=\"markListAsPrinted();\" />
		#rme('multiPrintBasket', '', 'markListAsPrinted', '', "loadFrameV2('contentLeft','multiPrintBasket');");

		if($gs->numLoaded() > 0) $html .= "
		<tr>
			<td colspan=\"4\">
				<input type=\"button\" class=\"bigButton backgroundColor2\" value=\"Kopie\" style=\"float:right;background-image:url(./images/navi/pdf.png);\" onclick=\"windowWithRme('multiPrintBasket', '', 'getFPDF', 'true');\" />
				<img src=\"./images/i2/settings.png\" class=\"calendarIcon mouseoverFade\" onclick=\"contextMenu.start(this, 'GRLBM','1','Kopie:');\">
				<input type=\"button\" style=\"background-image:url(./images/navi/pdf.png);\" class=\"bigButton backgroundColor2\" value=\"Original\" onclick=\"windowWithRme('multiPrintBasket', '', 'getFPDF', 'false');\" />
			</td>
		</tr>
		<tr>
			<td colspan=\"4\">$BPL$BM</td>
		</tr>
		<tr>
			<td colspan=\"4\">
				$BP
			</td>
		</tr>";

		/*
		 *
				".(($_SESSION["S"]->checkForPlugin("Dtaus")) ? "<input
					type=\"button\"
					style=\"background-image:url(./images/navi/disk.png);float:right;\"
					class=\"bigButton backgroundColor2\"
					value=\"Dtaus-Datei\nerstellen\"
					onclick=\"Dtaus.createMultiFile();\"
				/>": "")."
		 */

		else {
			$html .= "
		<tr>
			<td colspan=\"4\">keine Einträge</td>
		</tr>";
		}

		$html .= "
		</table>";

		$html = "<div style=\"overflow:auto;max-height:500px;\">$html</div>";

		return $html;
	}

	public function setPrinted($GRLBMID){
		$G = new GRLBM($GRLBMID);
		$G->changeA("isPrinted", "1");
		$G->saveMe();
	}

	public function markListAsPrinted(){
		$gs = $this->getGRLBMS();
		while(($t = $gs->getNextEntry()))
			$t->markMeAsPrinted();
			
		echo $gs->numLoaded();
	}
	
	public function sendViaEmail(){
		$U = new Util();
		$gs = $this->getGRLBMS();

		while($GRLBM = $gs->getNextEntry()){
			
			$AuftragID = $GRLBM->getA()->AuftragID;
			$M = "";
			if($GRLBM->getMyPrefix() == "M") {
				$G = new GRLBM($GRLBM->A("AuftragID"));
				$AuftragID = $G->A("AuftragID");
				$M = $G->A("nummer")."/";
			}
			
			$_SESSION["BPS"]->registerClass("Brief");
			$_SESSION["BPS"]->setProperty("Brief","GRLBMID",$GRLBM->getID());
			
			$A = new AuftragGUI($AuftragID);
			$U->logStatusMessages(array($GRLBM->getMyPrefix().$M.$GRLBM->A("nummer")), $A, "sendViaEmail", null);
		}
		
		echo $U->getStatusMessgesLog(2);
	}
	
	public function sendViaPL(){
		$U = new Util();
		$gs = $this->getGRLBMS();

		while($GRLBM = $gs->getNextEntry()){
			if($GRLBM->getMyPrefix() != "R") continue;
			
			$AuftragID = $GRLBM->getA()->AuftragID;
			
			$_SESSION["BPS"]->registerClass("Brief");
			$_SESSION["BPS"]->setProperty("Brief","GRLBMID",$GRLBM->getID());
			
			$A = new AuftragGUI($AuftragID);
			$U->logStatusMessages(array($GRLBM->getMyPrefix().$GRLBM->A("nummer")), $A, "signLetter", null);
		}
		
		echo $U->getStatusMessgesLog(2);
	}
	
	public function getFPDF($copy){
		
		$brief = new Brief();
		$brief->isCopy = $copy == "true" ? true : false;
		$brief->setStammdaten(Stammdaten::getActiveStammdaten());
		$pdf = $brief->PDFObjectFactory();
		$gs = $this->getGRLBMS();
		$i = 0;
		while(($t = $gs->getNextEntry())){
			if($i++ != 0)
				$pdf->AddPage('',true);
			
			$_SESSION["BPS"]->registerClass("Brief");
			$_SESSION["BPS"]->setProperty("Brief","GRLBMID",$t->getID());

			$AuftragID = $t->getA()->AuftragID;
			if($t->getMyPrefix() == "M") {
				$GRLBM = new GRLBM($t->A("AuftragID"));
				$AuftragID = $GRLBM->A("AuftragID");
			}
			
			$pdf->nbTag = "{nb$i}";
			$A = new AuftragGUI($AuftragID);
			$A->getGRLBMPDF($copy,$pdf);
			$pdf->addReplacement("{nb$i}",$pdf->PageNo());
		}
		
		$filename = $brief->getMultiDruckOutput(true);
		Util::PDFViewer($filename);
	}
}
?>