<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */

class Brief extends UnpersistentClass {
	
	private $letter = null;
/*
	private $adresse = null;
	private $longType = "";
	private $content = null;

	private $contents = array();
	*/
	private $Adresse;
	private $GRLBM;
	private $Posten;
	private $TextbausteinOben;
	private $TextbausteinUnten;
	private $Zahlungsbedingungen;
	private $stammdaten = null;

	public $nummer;
	public $datum;
	public $kunde;
	public $type = "";
	
	public $rabatt = "";
	public $leasingrate = "";
	public $rabattInW = "";
	
	public $isCopy = false;
	
	public function setStammdaten(Stammdaten $S){
		$this->stammdaten = $S;
	}
	
	public function setGRLBM(GRLBM $G){
		$this->GRLBM = $G;
	}
	
	public function setAdresse(Adresse $A){
		$this->Adresse = $A;
	}
	
	public function setTextbausteinOben(Textbaustein $T){
		$this->TextbausteinOben = $T;
	}
	
	public function setZahlungsbedingungen(Textbaustein $T){
		$this->Zahlungsbedingungen = $T;
	}
	
	public function setTextbausteinUnten(Textbaustein $T){
		$this->TextbausteinUnten = $T;
	}
	
	public function setPosten(mPosten $P){
		$this->Posten = $P;
	}
	
	public function PDFObjectFactory(){
		if($this->stammdaten == null) {
			$_SESSION["messages"]->addMessage("No Stammdaten set. Please use setStammdaten() before calling PDFObjectFactory()!");
			die("No Stammdaten set. See Message log for details.");
		}

		$SA = $this->stammdaten->getA();
		
		$_SESSION["BPS"]->setActualClass("Brief");
		$bps = $_SESSION["BPS"]->getAllProperties();
		
		if($bps == -1 OR !isset($bps["templateType"])) {
			$_SESSION["BPS"]->setActualClass("Brief");
			$_SESSION["BPS"]->setACProperty("templateType","PDF");
		}
		$n = ($SA->ownTemplate != "" ? $SA->ownTemplate : "StPDFBriefkopf");
			
		#if($_SESSION["BPS"]->getProperty("Brief","templateType") == "Email" AND $SA->ownTemplateEmail != "") 
		#	$n = $SA->ownTemplateEmail;
			
		if($_SESSION["BPS"]->getProperty("Brief","templateType") == "Print" AND $SA->ownTemplatePrint != "") 
			$n = $SA->ownTemplatePrint;

		$ud = new mUserdata();
		$aT = $ud->getUDValue("activePDFCopyTemplate");
		
		if($aT != null AND $aT != "" AND $this->isCopy)
			$n = $aT;
		
		try{
			new $n();
		} catch (ClassNotFoundException $e){
			echo Util::getBasicHTMLError("Die Vorlage $n konnte nicht gefunden werden.<br />Bitte überprüfen Sie, ob sich die Vorlage im specifics-Verzeichnis befindet.","Vorlagenfehler");
			die();
		}
			
		$this->letter = new $n($this->stammdaten);

		return $this->letter;
	}
	
	public function getFilename(){
		return str_replace(array(":",";"),array("",""),Util::replaceNonURLChars($this->letter->getFilename($this)));
	}
	
	public function generate($safe = false, $pdfToUse = null){
		if($this->stammdaten == null) {
			$_SESSION["messages"]->addMessage("No Stammdaten set. Please use setStammdaten() before calling generate()!");
			die("No Stammdaten set. See Message log for details.");
		}

		$this->letter = ($pdfToUse == null ? $this->PDFObjectFactory() : $pdfToUse);

		$this->letter->leasingrate = $this->leasingrate;
		$this->letter->rabatt = $this->rabatt;
		$this->letter->rabattInW = $this->rabattInW;
	
		if($this->Adresse != null)
			$this->letter->printAdresse($this->Adresse);
			
		if($this->GRLBM != null)
			$this->letter->printGRLBM($this->GRLBM);
			
		if($this->TextbausteinOben != null)
			$this->letter->printTextbaustein($this->TextbausteinOben);
			
		if($this->GRLBM != null AND $this->GRLBM->getA()->isAbschlussrechnung == "1")
			$this->letter->printTeilrechnungen($this->GRLBM, $this->Posten);
			
		if($this->Posten != null)
			$this->letter->printPosten($this->Posten);
			
		if($this->Zahlungsbedingungen != null)
			$this->letter->printTextbaustein($this->Zahlungsbedingungen);
			
		if($this->TextbausteinUnten != null)
			$this->letter->printTextbaustein($this->TextbausteinUnten);
		
		$filename = str_replace(":","_",$this->getFilename());
		$filename = str_replace(array("ä","ö","ü"),array("ae","oe","ue"), $filename);
		$filename = str_replace(array("Ä","Ö","Ü"),array("Ae","Oe","Ue"), $filename);
		$filename = str_replace(array("ß"),array("ss"), $filename);
		$filename = str_replace(array("Á","À","Â","Ã","á","à","â","ã"), array("A","A","A","A","a","a","a","a"), $filename);
		$filename = str_replace(array("Ç","ç","É","È","Ê","é","è","ê"), array("C","c","E","E","E","e","e","e"), $filename);
		$filename = str_replace(array("Í","Ì","í","ì","Õ","Ô","Ó"), array("I","I","i","i","O","O","O"), $filename);
		$filename = str_replace(array("õ","ô","ó","Ú","ú"), array("o","o","o","U","u"), $filename);
		
		$_SESSION["BPS"]->registerClass("PDFFilename");
		$_SESSION["BPS"]->setACProperty("filename",$filename);
			
		if($pdfToUse == null) {
			$tmpfname = $this->getTemp($safe);
	
			$this->letter->Output(($safe ? $tmpfname : $filename.".pdf"),($safe ? "F" : "I"));
			
			if($safe) return $tmpfname;
		}
	}
	
	public function getTemp($safe){
		if(!$safe) return "";
		
		$_SESSION["BPS"]->setActualClass("PDFFilename");
		$bps = $_SESSION["BPS"]->getAllProperties();
		$_SESSION["BPS"]->unregisterClass("PDFFilename");

		return Util::getTempFilename(($bps != -1 AND isset($bps["filename"])) ? $bps["filename"] : null);
	}
	
	function getMultiDruckOutput($safe = false){
		
		$tmpfname = $this->getTemp($safe);

		$this->letter->Output(($safe ? $tmpfname : "GRLBM.pdf"),($safe ? "F" : "I"));
		
		if($safe) return $tmpfname;
	}
}
?>
