<?php
/**
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class PDFBrief extends FPDF_Protection {

	protected $stammdaten;
	protected $VarsEmpfaengerAdresse;
	protected $VarsGRLBM;
	
	public $gesamt_netto = array();
	public $gesamt_brutto;
	public $gesamtEK1 = 0;
	public $gesamtEK2 = 0;
	public $rabatt = "";
	public $leasingrate = "";
	public $rabattInW = "";
	
	public $language = "de_DE";
	
	public $labelRechnung = "Rechnung";
	public $labelLieferschein = "Lieferschein";
	public $labelGutschrift = "Gutschrift";
	public $labelAngebot = "Angebot";
	public $labelKalkulation = "Kalkulation";
	public $labelMahnung = "Mahnung";
	public $labelBestaetigung = "Auftragsbestätigung";
	
	public $labelTelefon = "Telefon";
	public $labelFax = "Fax";
	public $labelHandy = "Handy";
	public $labelEMail = "E-Mail";
	public $labelInternet = "Internet";
	
	public $labelDatum = "Datum";
	public $labelLieferdatum = "Lieferdatum";
	public $labelUstID = "Ust-IdNr";
	public $labelStNr = "Steuernummer";
	public $labelKundennummer = "Kundennummer";
	public $labelKundeUstID = "Kunden-Ust-IdNr";
	public $labelKundeStNr = "Kunden-Steuernummer";
	
	public $labelPosition = "Pos";
	public $labelMenge = "Menge";
	public $labelEinheit = "Einheit";
	public $labelArtikelnummer = "Art.Nr.";
	public $labelBezeichnung = "Bezeichnung";
	public $labelEinzelpreis = "Einzelpreis";
	public $labelGesamt = "Gesamt";
	
	public $labelGesamtNetto = "Gesamt Netto";
	public $labelUmsatzsteuer = "Umsatzsteuer";
	public $labelRechnungsbetrag = "Rechnungsbetrag";
	public $labelGutschriftsbetrag = "Gutschriftsbetrag";
	public $labelGesamtBrutto = "Gesamt Brutto";
	
	public $labelGes = "ges.";
	public $labelVK = "VK";
	public $labelEK1 = "EK1";
	public $labelEK2 = "EK2";
	public $labelRabatt = "Rabatt";
	public $labelLeasingrate = "Leasingrate";
	public $labelRabattpreis = "Preis";
	
	public $labelAmtsgericht = "Amtsgericht";
	public $labelHandelsregister = "Handelsregister Nr.";
	public $labelSeite = "Seite";
	public $labelFortsetzung = "Fortsetzung auf Seite";
	public $labelUebertrag = "Übertrag";
	
	public $labelKopie = "Kopie";
	
	public $labelVersandkosten = "Versandkosten";

	//Es stehen bis zu 3 frei wählbare Felder zur Verfügung
	public $labelCustomField1 = null;
	public $labelCustomField2 = null;
	public $labelCustomField3 = null;

	public $marginLeft = 20;
	public $marginTop = 20;
	public $marginRight = 20;
	public $marginBottom = 40;
	
	//Angaben in Millimeter von der Ecke links oben
	//Zum Ausblenden null setzen
	public $positionAbsenderZeile = array(20, 50);
	public $positionAbsenderZeileLinie = array(20, 54);
	public $positionEmpfaengerAdresse = array(20, 55);
	public $positionDetailsAdresse = array(140, 30);
	public $positionDetails = array(130, 40);
	public $positionRechnungsInfo = array(130, 59);
	public $positionRechnungsInfo2teSeite = array(130, 30);
	public $positionTextbausteinOben = array(20, 95);
	public $positionPosten2teSeite = array(20, 50);
	public $positionFirmaSchriftzug = null; #array(20, 12);
	public $positionKopieLabel = array(90, 59);
	public $positionKopieLabel2teSeite = array(90, 30);
	public $positionFooter = array(20, 275);
	public $positionLogo = array(140, 10);
	
	public $widthLogo = 50;
	public $widthDetails = 60;
	public $widthRechnungsInfo = 60;
	
	public $widthPosition = null;
	public $widthMenge = 19;
	public $widthEinheit = 28;
	public $widthArtikelnummer = null;
	public $widthBezeichnung = 55;
	public $widthEinzelpreis = 35;
	public $widthGesamt = 33;
	public $widthEK1 = 35;
	public $widthEK2 = 30;
	public $widthVK = 31;
	public $widthRabatt = null; //Funktioniert nur mit dem Rabatt-Customizer
	public $widthRabattpreis = null; //Funktioniert nur mit dem Rabatt-Customizer
	
	public $showFalzmarken = true;
	public $showAnredeInEmpfaenger = false;
	
	protected $pageFormat = "A4";
	
	public $nbTag = "{nb}";
	public $labelLong = array();

	public $showBruttoPreise = false;
	public $showNullPreise = true;
	public $showDezimalstellen = null;

	public $footerShowLine = true;
	public $footerAmtsgerichtPosition = 120;
	public $footerDetailsPosition = 20;
	public $footerSeitePosition = 175;
	
	public $fontAbsenderZeile = array('Arial', '', 8);
	public $fontDetails = array('Arial', '', 8);
	public $fontRechnungsInfo = array('Arial', '', 9);
	public $fontKopieLabel = array('Arial', 'B', 24);
	public $fontPositionen = array('Arial', '', 9);
	public $fontPositionenHeader = array('Arial', 'BI', 9);
	public $fontPositionenBeschreibung = array('Arial', '', 7);
	public $fontFooter = array('Arial', '', 8);
	public $fontEmpfaengerAdresse = array('Arial', '', 11);
	public $fontFirmaSchriftzug = array('Arial', 'B', 28);
	public $fontTextbausteine = array('Arial','',10);
	
	public $sumAlignment = "horizontal";
	public $sumShowGesamtNetto = true;
	public $sumShowAlleNettopreise = false;
	public $sumShowUmsatzsteuer = true;
	public $sumShowBetrag = true;
	public $sumGesamtNettoPosition = 72;
	public $sumUmsatzsteuerPosition = 122;
	public $sumBetragPosition = 157;
	public $sumGesamtNettoWidth = 50;
	public $sumUmsatzsteuerWidth = 35;
	public $sumBetragWidth = 33;
	
	public $currentArticle = null;
	public $isInPosten = false;

	// <editor-fold defaultstate="collapsed" desc="PageNo">
	function PageNo(){
		return $this->fakePage;
	}
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="getFilename">
	function getFilename(Brief $brief){
		return $brief->type.$brief->nummer."-".$brief->datum."-".$brief->kunde.($brief->isCopy ? "-K" : "");
	}
	// </editor-fold>
	
	function __construct($S){
		parent::__construct('P','mm',$this->pageFormat);
		
		$this->labelLong = array(
			"R" => $this->labelRechnung,
			"L" => $this->labelLieferschein,
			"G" => $this->labelGutschrift,
			"A" => $this->labelAngebot,
			"M" => $this->labelMahnung,
			"B" => $this->labelBestaetigung,
			"Kalk" => $this->labelKalkulation);
		
		if($S != null) $this->sd = $S->getA();
		$this->stammdaten = $S;
		$this->setMargins($this->marginLeft, $this->marginTop, $this->marginRight);
		$this->SetAutoPageBreak(true, $this->marginBottom);

		if($S != null) $this->AddPage();
		
		$this->encrypted = false;
		
		if($_SESSION["S"]->checkForPlugin("mBrutto"))
			$this->showBruttoPreise = true;
	}

	// <editor-fold defaultstate="collapsed" desc="SetDash">
    function SetDash($black = false, $white = false){
        if($black and $white)
            $s=sprintf('[%.3f %.3f] 0 d', $black*$this->k, $white*$this->k);
        else
            $s='[] 0 d';
        $this->_out($s);
    }
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="LCell">
	function LCell($marginRight, $height, $string, $border=0, $ln=0, $align='', $fill=0, $link=''){
		$this->Cell($this->GetStringWidth(utf8_decode($string))+$marginRight , $height , utf8_decode($string), $border=0, $ln=0, $align='', $fill=0, $link='');
	}
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="Header">
	function Header() {
		$startx = $this->getX();
		$starty = $this->getY();
		
		$this->Ln(10);
		if($this->PageNo() == 1){
			$this->SetFont($this->fontDetails[0], $this->fontDetails[1], $this->fontDetails[2]);
			#-------------------- Adressen
			if($this->positionDetailsAdresse != null){
				$this->SetXY($this->positionDetailsAdresse[0], $this->positionDetailsAdresse[1]);
				$this->MultiCell(0 , 3.5 , utf8_decode($this->sd->strasse." ".$this->sd->nr."\n".$this->sd->plz." ".$this->sd->ort),0,"R");
			}
			
			if($this->positionDetails != null){
				$x = $this->positionDetails[0];
				$y = $this->positionDetails[1];
				if($this->sd->telefon != ""){
					$this->setXY($x,$y);
					$this->Cell(30,3.5,utf8_decode($this->labelTelefon));
					$this->Cell($this->widthDetails - 30,3.5,utf8_decode($this->sd->telefon),"",0,"R");
					$y += 3.5;
				}
				
				if($this->sd->fax != ""){
					$this->setXY($x,$y);
					$this->Cell(30,3.5,utf8_decode($this->labelFax));
					$this->Cell($this->widthDetails - 30,3.5,utf8_decode($this->sd->fax),"",0,"R");
					$y += 3.5;
				}
				
				if($this->sd->mobil != ""){
					$this->setXY($x,$y);
					$this->Cell(30,3.5,utf8_decode($this->labelHandy));
					$this->Cell($this->widthDetails - 30,3.5,utf8_decode($this->sd->mobil),"",0,"R");
					$y += 3.5;
				}
				
				if($this->sd->email != ""){
					$this->setXY($x,$y);
					$this->Cell(30,3.5,utf8_decode($this->labelEMail));
					$this->Cell($this->widthDetails - 30,3.5,utf8_decode($this->sd->email),"",0,"R");
					$y += 3.5;
				}
				
				if($this->sd->internet != ""){
					$this->setXY($x,$y);
					$this->Cell(30,3.5,utf8_decode($this->labelInternet));
					$this->Cell($this->widthDetails - 30,3.5,utf8_decode($this->sd->internet),"",0,"R");
					$y += 3.5;
				}
			}
			
			#-------------------- Adressen
			if($this->positionAbsenderZeile != null){
				$this->SetFont($this->fontAbsenderZeile[0], $this->fontAbsenderZeile[1], $this->fontAbsenderZeile[2]);
				$this->SetXY($this->positionAbsenderZeile[0], $this->positionAbsenderZeile[1]);
				$text = utf8_decode(($this->sd->firmaKurz != "" ? $this->sd->firmaKurz : $this->sd->vorname." ".$this->sd->nachname).", ".$this->sd->strasse." ".$this->sd->nr.", ".$this->sd->plz." ".$this->sd->ort);
				$this->Cell(100 , 5 , $text,"",1);
				if($this->positionAbsenderZeileLinie != null) $this->Line($this->positionAbsenderZeileLinie[0], $this->positionAbsenderZeileLinie[1], $this->GetStringWidth($text) + 22, $this->positionAbsenderZeileLinie[1]);
			}
		}
		
		if($this->showFalzmarken){
			$this->Line(7 , 105, 11 , 105);
			$this->Line(7 , 148, 11 , 148);
			$this->Line(7 , 192, 11 , 192);
		}
		
		if($this->positionFirmaSchriftzug != null) {
			#$this->setY(12);
			$this->SetXY($this->positionFirmaSchriftzug[0], $this->positionFirmaSchriftzug[1]);
			
			$this->SetFont($this->fontFirmaSchriftzug[0], $this->fontFirmaSchriftzug[1], $this->fontFirmaSchriftzug[2]);
			
	#		$this->SetFont('Arial','B',28);
			$this->LCell(2 , 10 , $this->sd->firmaLang);
		}

		if($this->PageNo() > 1){
			$this->printGRLBM($this->VarsGRLBM);
			
			$this->setXY($this->positionPosten2teSeite[0], $this->positionPosten2teSeite[1]);
		}
	}
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="AddPage">
	function AddPage($orientation='',$resetFakePageCounter = false){
		if($this->isInPosten) {
			$this->Line($this->marginLeft , $this->getY(), 210-$this->marginRight , $this->getY());

			$this->SetAutoPageBreak(false);
			$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);
			$this->Cell8(0,5,$this->labelFortsetzung." ".($this->PageNo()+1),0,0,"R");
			$this->SetAutoPageBreak(true, $this->marginBottom);
		}
		
		parent::AddPage($orientation, $resetFakePageCounter);
		
		if($this->isInPosten){
			$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);
			$this->Cell(0,5,utf8_decode($this->labelUebertrag).": ".Util::conv_euro(Util::formatCurrency($this->language, array_sum($this->gesamt_netto) * 1,true)),0,0,"R");
			$this->Ln();
			$this->printPDFHeader();
			if($this->currentArticle != null){
				$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);
				$this->Cell(0,5,utf8_decode("Fortsetzung ".$this->currentArticle->A("name")));
				$this->ln();
			}
			$this->SetFont($this->fontPositionenBeschreibung[0], $this->fontPositionenBeschreibung[1], $this->fontPositionenBeschreibung[2]);
		}
	}
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="Footer">
	function Footer() {

		if($this->positionFooter == null) return;
		
	    if($this->footerShowLine) $this->Line($this->positionFooter[0] , $this->positionFooter[1], 210 - $this->positionFooter[0] , $this->positionFooter[1]);
		$this->SetY($this->positionFooter[1] + 1);
		
		$this->SetFont($this->fontFooter[0], $this->fontFooter[1], $this->fontFooter[2]);
		$this->SetXY($this->footerDetailsPosition, $this->positionFooter[1] + 1);
		$this->MultiCell(0 , 4 , utf8_decode($this->sd->firmaLang).($this->sd->inhaber != "" ? ($this->sd->firmaLang != "" ? ", " : "")."Inhaber: ".utf8_decode($this->sd->inhaber) : "").($this->sd->geschaeftsfuehrer != "" ? ($this->sd->firmaLang != "" ? ", " : "").utf8_decode("Geschäftsführer: ".$this->sd->geschaeftsfuehrer) : "")."\n"./*(($this->sd->inhaber != "" OR $this->sd->geschaeftsfuehrer != "") ? "\n" : "").*/($this->sd->bank != "" ? "Bankverbindung: ".utf8_decode($this->sd->bank).", BLZ: ".$this->sd->blz.", Kto.-Nr: ".$this->sd->ktonr.(($this->sd->IBAN != "" OR $this->sd->SWIFTBIC != "") ? "\n" : "").($this->sd->IBAN != "" ? "IBAN: ".$this->sd->IBAN : "").($this->sd->SWIFTBIC != "" ? ", SWIFT/BIC: ".$this->sd->SWIFTBIC : "") : ""),0,"L");
		
		if($this->sd->amtsgericht != "" OR $this->sd->handelsregister != ""){
			$this->SetXY($this->footerAmtsgerichtPosition, $this->positionFooter[1] + 1);
			if($this->sd->amtsgericht != "") $this->MultiCell(0,4, "$this->labelAmtsgericht\n".utf8_decode($this->sd->amtsgericht."\n".$this->sd->handelsregister));
			else $this->MultiCell(0,4, utf8_decode("$this->labelHandelsregister\n".$this->sd->handelsregister));
		}
		
		if($this->labelSeite != null){
		    $this->SetXY($this->footerSeitePosition, $this->positionFooter[1] + 1);
			$this->SetFont($this->fontFooter[0], "I", $this->fontFooter[2]);
		    $this->Cell(0,4,utf8_decode($this->labelSeite).' '.($this->PageNo())."/$this->nbTag",0,0,'L');
		}
	}
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="printTeilrechnungen">
	function printTeilrechnungen(GRLBM $GRLBM, mPosten $Posten){
		
		$widthRechnungsnummer = 30;
		$widthDatum = 30;
		$widthNetto = 40;
		$widthMwSt = 37;
		$widthBrutto = 33;
		
		$this->SetFont($this->fontPositionenHeader[0], $this->fontPositionenHeader[1], $this->fontPositionenHeader[2]);
		
		$this->Cell($widthRechnungsnummer, 5, "Rechnungsnr.", 0, 0, "R");
		$this->Cell($widthDatum, 5, "Datum", 0 , 0);
		$this->Cell($widthNetto, 5, "Netto", 0 , 0, "R");
		$this->Cell($widthMwSt, 5, "Umsatzsteuer", 0 , 0, "R");
		$this->Cell($widthBrutto, 5, "Brutto", 0 , 1, "R");
		
		$this->Line($this->marginLeft , $this->getY(), 210-$this->marginRight , $this->getY());
		
		$aC = new anyC();
		$aC->setCollectionOf("GRLBM");
		$aC->addAssocV3("AuftragID","=", $GRLBM->getA()->AuftragID);
		$aC->addAssocV3("isAbschlussrechnung","=", "0");
		$aC->addAssocV3("isR","=", "1");
		
		
		$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);
		
		$re_netto = 0;
		$re_brutto = 0;
		$desc = "Rechnungen ";
		
		$lastMwSt = "";
		
		while($a = $aC->getNextEntry()){
			list($ges_netto, $ges_mwst, $ges_brutto, $mwsts) = $a->getSumOfPosten(true);

			if($lastMwSt == "" AND count($mwsts) > 0) $lastMwSt = $mwsts[0];
			
			if(count($mwsts) > 1 OR count($mwsts) == 0 OR $lastMwSt != $mwsts[0])
				die(Util::getBasicHTMLError("<b>Achtung:</b><br /><br />Die Teilrechnungen dürfen nicht mehrere unterschiedliche MwSt-Sätze verwenden!<br />Eine Teilrechnung ohne Posten erzeugt diesen Fehler auch (MwSt-Satz 0%)!","open3A-Fehler"));

			$this->Cell($widthRechnungsnummer, 5, $a->getA()->nummer, 0, 0, "R");
			$this->Cell($widthDatum, 5, Util::formatDate($this->language, $a->getA()->datum), 0, 0);
			$this->Cell($widthNetto, 5, Util::conv_euro(Util::formatCurrency($this->language, $ges_netto, true)), 0, 0, "R");
			$this->Cell(17, 5, Util::formatNumber("de_DE", $mwsts[0]*1, 2, true, false)."%", 0, 0, "R");
			$this->Cell($widthMwSt - 17, 5, Util::conv_euro(Util::formatCurrency($this->language, $ges_mwst, true)), 0, 0, "R");
			$this->Cell($widthBrutto, 5, Util::conv_euro(Util::formatCurrency($this->language, $ges_brutto, true)), 0, 1, "R");
			
			$desc .= ($desc != "Rechnungen " ? ", " : "").$a->getA()->nummer;
			#echo $ges_brutto."<br />";
			$re_netto += $ges_netto;
			$re_brutto += $ges_brutto;
		}
		
		$this->Line($this->marginLeft , $this->getY(), 210-$this->marginRight , $this->getY());
		
		$this->ln(15);

		$Posten->addVirtualPosten(1, "", "Teilrechnungen", $desc, -$re_netto, "$mwsts[0]", "1", -$re_brutto);
	}
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="printAdresse">
	function printAdresse(Adresse $Adresse){
		$this->VarsEmpfaengerAdresse = $Adresse;
		
		if($this->positionEmpfaengerAdresse == null) return;
		
		$this->SetXY($this->positionEmpfaengerAdresse[0], $this->positionEmpfaengerAdresse[1]);
		$this->SetFont($this->fontEmpfaengerAdresse[0], $this->fontEmpfaengerAdresse[1], $this->fontEmpfaengerAdresse[2]);

		$this->MultiCell(80 , 5 , utf8_decode($Adresse->getFormattedAddress($this->showAnredeInEmpfaenger, $this->language)),0,"L");
	}
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="printGRLBM">
	public function printGRLBM(GRLBM $GRLBM){
		$this->VarsGRLBM = $GRLBM;
		
		$GRLBM->loadMe();
		if($GRLBM->A("isM") != "1") $Auftrag = new Auftrag($GRLBM->getA()->AuftragID);
		else {
			$G = new GRLBM($GRLBM->A("AuftragID"));
			$Auftrag = new Auftrag($G->A("AuftragID"));
		}
		$Auftrag->loadMe();
		
		if($this->positionRechnungsInfo == null) return;
		
		$ud = new mUserdata();
		$cv = $ud->getUDValue("activePDFCopyVermerk");
		$S = Stammdaten::getActiveStammdaten();

		$startX = $this->getX();
		$startY = $this->getY();
		
		#$this->SetFont('Arial','',9);
		
		$y = $this->positionRechnungsInfo[1];
		$x = $this->positionRechnungsInfo[0];
	
		if($this->PageNo() > 1){
			$y = $this->positionRechnungsInfo2teSeite[1];
			$x = $this->positionRechnungsInfo2teSeite[0];
			
			if($this->positionRechnungsInfo2teSeite == null) return;
		}
		
	
		if($GRLBM->isCopy AND ($cv == null OR $cv == "true") AND $this->positionKopieLabel != null){
			$this->SetTextColor(170);
			$this->SetFont($this->fontKopieLabel[0], $this->fontKopieLabel[1], $this->fontKopieLabel[2]);
			
			if($this->PageNo() == 1) {
				$this->SetXY($this->positionKopieLabel[0],$this->positionKopieLabel[1]);
				$this->Cell(40,10,$this->labelKopie,0,0,"L");
			}
			if($this->PageNo() > 1 AND $this->positionKopieLabel2teSeite != null) { 
				$this->SetXY($this->positionKopieLabel2teSeite[0],$this->positionKopieLabel2teSeite[1]);
				$this->Cell(40,10,$this->labelKopie,0,0,"L");
			}
			
			$this->SetTextColor(0);
		}
		
		$this->SetXY($x,$y);
		$this->SetFont($this->fontRechnungsInfo[0], "B", $this->fontRechnungsInfo[2]);
		$this->Cell(30 , 6 , utf8_decode($this->labelLong[$GRLBM->getMyPrefix()]), "", 0, "L");
		
		$storedPrefix = $GRLBM->getA()->prefix;
		if($storedPrefix == "A" AND $GRLBM->A("printAB") == "1") $storedPrefix = $S->getPrefix($GRLBM->getMyPrefix());
		
		$prefix = ($GRLBM->getA()->prefix != "" ? $storedPrefix : $S->getPrefix($GRLBM->getMyPrefix()));
		
		if($GRLBM->getMyPrefix() != "M") $this->Cell($this->widthRechnungsInfo - 30 , 6 , $prefix.$GRLBM->getA()->nummer,0,0,"R");
		else {
			$oldGRLBM = new GRLBM($GRLBM->getA()->AuftragID);
			$oldGRLBM->loadMe();
			$this->Cell($this->widthRechnungsInfo - 30 , 6 , $prefix.$oldGRLBM->getA()->nummer."/".$GRLBM->getA()->nummer,0,0,"R");
		}
		
		$y += 4;
		$this->SetXY($x,$y);
		$this->SetFont($this->fontRechnungsInfo[0], $this->fontRechnungsInfo[1], $this->fontRechnungsInfo[2]);

		$this->Cell(30 , 6 , utf8_decode($this->labelDatum), "", 0, "L");
		$this->Cell($this->widthRechnungsInfo - 30 , 6 , $GRLBM->getA()->datum * 1 < 100000000 ? $GRLBM->getA()->datum  : Util::formatDate($this->language, $GRLBM->getA()->datum), "", 0, "R");
		
		if($GRLBM->getMyPrefix() == "R" AND $this->labelLieferdatum != null){
			$y += 4;
			$this->SetXY($x,$y);
			$this->Cell(30 , 6 , utf8_decode($this->labelLieferdatum), "", 0, "L");
			$this->Cell($this->widthRechnungsInfo - 30 , 6 , $GRLBM->getA()->lieferDatum * 1 < 100000000 ? utf8_decode($GRLBM->getA()->lieferDatum) : Util::formatDate($this->language, $GRLBM->getA()->lieferDatum), "", 0, "R");
		}

		for($i = 1;$i < 10; $i++){
			$labelName = "labelCustomField$i";
			$fieldName = "GRLBMCustomField$i";
			if(isset($this->$labelName) AND $this->$labelName != null AND $GRLBM->A($fieldName) != null AND $GRLBM->A($fieldName) != ""){
				$y += 4;
				$this->SetXY($x,$y);
				$this->Cell8(30 , 6 , $this->$labelName, "", 0, "L");
				$this->Cell8($this->widthRechnungsInfo - 30 , 6 , $GRLBM->A($fieldName),0,0,"R");
			}
		}

		if($S->getA()->ustidnr != "" AND $this->PageNo() == 1 AND $this->labelUstID != null){
			$y += 4;
			$this->SetXY($x,$y);
			$this->Cell(30 , 6 , (ereg("(^[A-Za-z]{2})",$S->getA()->ustidnr,$regs) ? utf8_decode($this->labelUstID) : utf8_decode($this->labelStNr)), "", 0, "L");
			$this->Cell($this->widthRechnungsInfo - 30 , 6 , $S->getA()->ustidnr,0,0,"R");
		}

		$y += 4;
		$this->SetXY($x,$y);
		$this->Cell(30 , 6 , "", "", 0, "L");
		$this->Cell(0 , 6 , "", "", 0, "R");
			
		if($Auftrag->getA()->kundennummer != "" 
		AND $Auftrag->getA()->kundennummer != "-2" 
		AND $this->PageNo() == 1){
			$y += 4;
			$this->SetXY($x,$y);
			$this->Cell(30 , 6 , utf8_decode($this->labelKundennummer), "", 0, "L");
			$this->Cell($this->widthRechnungsInfo - 30 , 6 , $S->getPrefix("K").$Auftrag->getA()->kundennummer, "", 0, "R");
		}
	
		
		if($Auftrag->getA()->UStIdNr != "" AND $this->PageNo() == 1){
			$y += 4;
			$this->SetXY($x,$y);
			$this->Cell(30 , 6 , (ereg("(^[A-Za-z]{2})",$Auftrag->getA()->UStIdNr,$regs) ? utf8_decode($this->labelKundeUstID) : utf8_decode($this->labelKundeStNr)), "", 0, "L");
			$this->Cell($this->widthRechnungsInfo - 30 , 6 , $Auftrag->getA()->UStIdNr, "", 0, "R");
		}
		
		if($this->PageNo() == 1) $this->setXY($this->positionTextbausteinOben[0], $this->positionTextbausteinOben[1]);
		#else $this->setXY($this->positionTextbausteinOben[0], $this->positionTextbausteinOben[1]);
	}
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="printTextbaustein">
	function printTextbaustein(Textbaustein $T){
		$T->loadMe();
		$TBText = $T->getA()->text;
		
		$date = Util::CLDateParser($this->VarsGRLBM->getA()->datum, "store");
		if($date == -1) $date = $this->VarsGRLBM->getA()->datum;
		
		if($this->VarsEmpfaengerAdresse != null)
			$TBText = str_replace("{Anrede}", Util::formatAnrede($this->language, $this->VarsEmpfaengerAdresse), $TBText);

		if(ereg("{Rabatt:([0-9]*)%}", $TBText, $regs)){
			$rabatt = Util::formatCurrency($this->language, Util::kRound($this->gesamt_brutto / 100 * (100 - $regs[1]),2), true);
			$TBText = str_replace("{Rabatt:$regs[1]%}", $rabatt, $TBText);
		}

		$TBText = str_replace("{+1Woche}", Util::CLDateParser($date + 7 * 3600 * 24), $TBText);
		$TBText = str_replace("{+2Wochen}", Util::CLDateParser($date + 14 * 3600 * 24), $TBText);
		$TBText = str_replace("{+3Wochen}", Util::CLDateParser($date + 21 * 3600 * 24), $TBText);

		$TBText = str_replace("{Benutzername}",$_SESSION["S"]->getCurrentUser()->getA()->name, $TBText);
		
		if(strpos($TBText, "{+1Monat}") !== false) {
			$date = new Datum($date);
			$date->addMonth();
			$TBText = str_replace("{+1Monat}",Util::CLDateParser($date->time()),$TBText);
		}
			
		$TBText = str_replace("{Gesamtsumme}", Util::formatCurrency($this->language, $this->gesamt_brutto, true), $TBText);
		
		
		$this->SetFont($this->fontTextbausteine[0], $this->fontTextbausteine[1], $this->fontTextbausteine[2]);
		
		$this->MultiCell(0 , 5 , utf8_decode(Util::conv_euro($TBText)),0,"L");
		$this->ln();
	}
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="printPosten">
	function printPosten(mPosten $P){
		$this->isInPosten = true;
		$P->getFPDF($this);
		$this->isInPosten = false;
	}
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="printGesamt">
	function printGesamt($type){
		if($type == "L") return;

		$this->SetFont($this->fontPositionen[0], 'B', $this->fontPositionen[2]);

		if($type == "R" OR $type == "A" OR $type == "G"){
			#print_r($this->gesamt_brutto);
			$sum_mwst = 0;
			$sum_netto = 0;
			foreach($this->gesamt_netto as $key => $value){
				$sum_mwst += Util::kRound($value * ($key / 100),2);
				#$sum_netto += $value;
			}
			$sum_ges = $this->gesamt_brutto;# =  = Util::kRound($sum_netto)+Util::kRound($sum_mwst);
			$sum_netto = Util::kRound($sum_ges,2) - $sum_mwst;

			#$sum_netto += $this->VarsGRLBM->A("versandkosten");

			if(abs($sum_netto - array_sum($this->gesamt_netto)) > 0.1)
				die("Die Netto-Beträge stimmen nicht überein!<pre>Aus Posten berechneter Netto-Betrag: ".array_sum($this->gesamt_netto)."\nAus Brutto-Betrag berechneter Netto-Betrag: $sum_netto</pre>Bitte melden Sie diesen Fehler zusammen mit einer Beispielrechnung an Support@phynx.de<br />Vielen Dank");

			if($this->VarsGRLBM->getA()->isPayed == "0"){
				$this->VarsGRLBM->changeA("nettobetrag",$sum_netto);
				$this->VarsGRLBM->changeA("bruttobetrag",$sum_ges);
				$this->VarsGRLBM->changeA("steuern",$sum_mwst);
				$this->VarsGRLBM->saveMe();
			#print_r($this->VarsGRLBM);
			}
			switch($this->sumAlignment){
				case "horizontal":
					$firstLineY = $this->GetY();

					if($this->sumShowGesamtNetto){
						$this->SetXY($this->sumGesamtNettoPosition, $firstLineY);
						$this->Cell($this->sumGesamtNettoWidth, 5, utf8_decode($this->labelGesamtNetto), 0, 0, "R");
					}
					if($this->sumShowUmsatzsteuer){
						$this->SetXY($this->sumUmsatzsteuerPosition, $firstLineY);
						$this->Cell($this->sumUmsatzsteuerWidth, 5, utf8_decode($this->labelUmsatzsteuer), 0, 0, "R");
					}
					if($this->sumShowBetrag){
						$this->SetXY($this->sumBetragPosition, $firstLineY);
						if($type == "R") $this->Cell($this->sumBetragWidth, 5, utf8_decode($this->labelRechnungsbetrag), 0, 0, "R");
						if($type == "G") $this->Cell($this->sumBetragWidth, 5, utf8_decode($this->labelGutschriftsbetrag), 0, 0, "R");
						if($type == "A") $this->Cell($this->sumBetragWidth, 5, utf8_decode($this->labelGesamtBrutto), 0, 0, "R");
					}

					$this->Ln();
					$secondLineY = $this->GetY();

					$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);

					if($this->sumShowGesamtNetto){
						if(!$this->sumShowAlleNettopreise){
							$this->SetXY($this->sumGesamtNettoPosition, $secondLineY);
							$this->Cell($this->sumGesamtNettoWidth, 5, Util::conv_euro(Util::formatCurrency($this->language, $sum_netto, true)), 0, 0, "R");
						} else {
							$i = 0;
							foreach($this->gesamt_netto as $key => $value){
								$this->SetXY($this->sumGesamtNettoPosition, $secondLineY + $i * 5);
								#$this->Cell(15, 5, Util::formatNumber("de_DE", $key*1, 2, true, false)."%", 0, 0, "R");
								$this->Cell($this->sumGesamtNettoWidth, 5, Util::conv_euro(Util::formatCurrency($this->language, $value, true)), 0, 2, "R");
								$i++;
							}
						}
					}

					$i = 0;
					foreach($this->gesamt_netto as $key => $value){

						if($this->sumShowUmsatzsteuer){
							$this->SetXY($this->sumUmsatzsteuerPosition, $secondLineY + $i * 5);
							$this->Cell(15, 5, Util::formatNumber("de_DE", $key*1, 2, true, false)."%", 0, 0, "R");
							$this->Cell($this->sumUmsatzsteuerWidth - 15, 5, Util::conv_euro(Util::formatCurrency($this->language, $value * ($key / 100), true)), 0, 2, "R");
						}
						$i++;
					}

					//Fixes mispaced Rechnungsbetrag
					if($i == 0) $i++;

					if(!$this->sumShowUmsatzsteuer) $this->ln();

					$this->SetFont($this->fontPositionen[0], 'B', $this->fontPositionen[2]);
					if(count($this->gesamt_netto) > 0) $this->SetY($this->GetY()-5);

					if($this->sumShowBetrag){
						$this->SetXY($this->sumBetragPosition, $secondLineY + ($i - 1) * 5);
						$this->Cell($this->sumBetragWidth, 5, Util::conv_euro(Util::formatCurrency($this->language, $sum_ges, true)), 0, 0, "R");
					}

				break;
				case "vertical":
					$firstLineY = $this->GetY();
					$labelsRight = $this->sumBetragPosition - 50;
					$i = 0;
					if($this->sumShowGesamtNetto AND !$this->sumShowAlleNettopreise){
						$this->SetXY($labelsRight, $firstLineY);
						$this->Cell(50, 5, utf8_decode($this->labelGesamtNetto), 0, 0, "R");
						$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);

						#if(!$this->sumShowAlleNettopreise){
							$this->Cell($this->sumBetragWidth, 5, Util::conv_euro(Util::formatCurrency($this->language, $sum_netto, true)), 0, 0, "R");
							$i++;
						/*} else {
							foreach($this->gesamt_netto as $key => $value){
								$this->SetXY($this->sumBetragPosition, $firstLineY + $i * 5);
								$this->Cell(15, 5, Util::formatNumber($this->language, $key*1, 2, true, false)."%", 0, 0, "R");
								$this->Cell($this->sumBetragWidth - 15, 5, Util::conv_euro(Util::formatCurrency($this->language, $value, true)), 0, 0, "R");

								$i++;
							}
						}*/
					}
					if($this->sumShowUmsatzsteuer AND !$this->sumShowAlleNettopreise){
						$this->SetFont($this->fontPositionen[0], 'B', $this->fontPositionen[2]);
						$this->SetXY($labelsRight, $firstLineY + $i * 5);
						$this->Cell(50, 5, utf8_decode($this->labelUmsatzsteuer), 0, 0, "R");

						$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);

						foreach($this->gesamt_netto as $key => $value){
							$this->SetXY($this->sumBetragPosition, $firstLineY + $i * 5);
							$this->Cell(15, 5, Util::formatNumber($this->language, $key*1, 2, true, false)."%", 0, 0, "R");
							$this->Cell($this->sumBetragWidth - 15, 5, Util::conv_euro(Util::formatCurrency($this->language, $value * ($key / 100), true)), 0, 0, "R");

							$i++;
						}
					}

					if($this->sumShowAlleNettopreise){
						$this->SetXY($labelsRight, $firstLineY);
						$this->Cell(50, 5, utf8_decode($this->labelGesamtNetto), 0, 0, "R");
						$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);

						$this->Cell($this->sumBetragWidth, 5, Util::conv_euro(Util::formatCurrency($this->language, $sum_netto, true)), 0, 0, "R");
						$i++;

						foreach($this->gesamt_netto as $key => $value){
							$this->SetXY($labelsRight, $firstLineY + $i * 5);
							$this->Cell(35, 5, Util::formatNumber($this->language, $key*1, 2, true, false)."% ".utf8_decode($this->labelUmsatzsteuer.":"), 0, 0, "R");
							$this->Cell(15, 5, Util::conv_euro(Util::formatCurrency($this->language, $value, true)), 0, 0, "R");
							$this->Cell($this->sumBetragWidth, 5, Util::conv_euro(Util::formatCurrency($this->language, $value * ($key / 100), true)), 0, 0, "R");

							$i++;
						}
					}

					if($this->sumShowBetrag){
						$this->SetFont($this->fontPositionen[0], 'B', $this->fontPositionen[2]);
						$this->SetXY($labelsRight, $firstLineY + $i * 5);
						if($type == "R") $this->Cell(50, 5, utf8_decode($this->labelRechnungsbetrag), 0, 0, "R");
						if($type == "G") $this->Cell(50, 5, utf8_decode($this->labelGutschriftsbetrag), 0, 0, "R");
						if($type == "A") $this->Cell(50, 5, utf8_decode($this->labelGesamtBrutto), 0, 0, "R");

						$this->Cell($this->sumBetragWidth, 5, Util::conv_euro(Util::formatCurrency($this->language, $sum_ges, true)), 0, 0, "R");

					}
				break;
			}


			$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);
			$this->Line($this->marginLeft , $this->getY()+5, 210-$this->marginRight , $this->getY()+5);
			$this->ln(10);
		}
		if($type == "Kalk"){

			$G = $this->VarsGRLBM;

			$userLabels = mUserdata::getRelabels("Artikel");
			$userHiddenFields = mUserdata::getHides("Artikel");

			$this->Cell(109,5,(!isset($userHiddenFields["EK1"]) ? utf8_decode($this->labelGes)." ".(isset($userLabels["EK1"]) ? utf8_decode($userLabels["EK1"]) : utf8_decode($this->labelEK1)) : ""),0,0,"R");
			$this->Cell(30,5,(!isset($userHiddenFields["EK2"]) ? utf8_decode($this->labelGes)." ".(isset($userLabels["EK2"]) ?utf8_decode( $userLabels["EK2"]) : utf8_decode($this->labelEK2)) : ""),0,0,"R");
			$this->Cell(0,5,utf8_decode($this->labelGes)." ".utf8_decode($this->labelVK),0,0,"R");
			$this->ln();
			$gesamt = array_sum($this->gesamt_netto);
			$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);
			$this->Cell(109,5,(!isset($userHiddenFields["EK1"]) ? Util::conv_euro(Util::formatCurrency($this->language, $this->gesamtEK1, true)) : ""),0,0,"R");
			$this->Cell(30,5,(!isset($userHiddenFields["EK2"]) ? Util::conv_euro(Util::formatCurrency($this->language, $this->gesamtEK2, true)) : ""),0,0,"R");
			$this->Cell(0,5,Util::conv_euro(Util::formatCurrency($this->language, $gesamt, true)),0,0,"R");
			$this->ln();
			$this->Line(100 , $this->getY(), 210-$this->marginRight , $this->getY());

			$this->SetFont($this->fontPositionen[0], 'B', $this->fontPositionen[2]);
			$this->Cell(109,5,"",0,0,"R");
			$this->Cell(30,5,utf8_decode($this->labelRabatt),0,0,"R");
			$this->Cell(0,5,utf8_decode($this->labelGes)." ".utf8_decode($this->labelVK),0,0,"R");
			$this->ln();

			$this->rabatt = str_replace(",",".",$this->rabatt);
			$this->rabattInW = str_replace(",",".",$this->rabattInW);
			$this->leasingrate = str_replace(",",".",$this->leasingrate);
			$rabatt = $gesamt * $this->rabatt / 100;
			if($this->rabattInW != 0.00) $rabatt = $this->rabattInW;
			$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);
			$this->Cell(109,5,"",0,0,"R");

			if($this->rabattInW != 0.00) {
				$this->Cell(30,5,Util::conv_euro(Util::formatCurrency($this->language, $rabatt * 1, true)),0,0,"R");
				$this->Cell(0,5,Util::conv_euro(Util::formatCurrency($this->language, $gesamt - $rabatt, true)),0,0,"R");
			} else {
				$this->Cell(30,5,Util::formatNumber($this->language,$this->rabatt*1)."%: ".Util::conv_euro(Util::formatCurrency($this->language, $rabatt, true)),0,0,"R");
				$this->Cell(0,5,Util::conv_euro(Util::formatCurrency($this->language, $gesamt - $rabatt, true)),0,0,"R");
			}

			$this->ln();
			$this->Line(100 , $this->getY(), 210-$this->marginRight , $this->getY());
			$gesamt -= $rabatt;

			$this->SetFont($this->fontPositionen[0], 'B', $this->fontPositionen[2]);
			$this->Cell(109,5,(!isset($userHiddenFields["EK1"]) ? utf8_decode($this->labelVK)." - ".(isset($userLabels["EK1"]) ? utf8_decode($userLabels["EK1"]) : utf8_decode($this->labelEK1)) : ""),0,0,"R");
			$this->Cell(30,5,(!isset($userHiddenFields["EK2"]) ? utf8_decode($this->labelVK)." - ".(isset($userLabels["EK2"]) ? utf8_decode($userLabels["EK2"]) : utf8_decode($this->labelEK2)) : ""),0,0,"R");
			$this->Cell(0,5,utf8_decode($this->labelLeasingrate),0,0,"R");
			$this->ln();

			$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);
			$this->Cell(109,5,(!isset($userHiddenFields["EK1"]) ? Util::conv_euro(Util::formatCurrency($this->language, $gesamt - $this->gesamtEK1, true)) : ""),0,0,"R");
			$this->Cell(30,5,(!isset($userHiddenFields["EK2"]) ? Util::conv_euro(Util::formatCurrency($this->language, $gesamt - $this->gesamtEK2, true)) : ""),0,0,"R");
			$this->Cell(0,5,Util::formatNumber($this->language, $this->leasingrate * 1, 2, true,false)."%: ".Util::conv_euro(Util::formatCurrency($this->language, $gesamt * $this->leasingrate / 100, true)),0,0,"R");

			$this->ln();
			$this->Line(100 , $this->getY(), 210-$this->marginRight , $this->getY());

			if(isset($G->getA()->servicepolice1)){
				$this->SetFont($this->fontPositionen[0], 'B', $this->fontPositionen[2]);
				$this->Cell(109,5,utf8_decode("Servicepolice 1"),0,0,"R");
				$this->Cell(30,5,utf8_decode("Servicepolice 2"),0,0,"R");
				$this->Cell(0,5,utf8_decode("Servicepolice 3"),0,0,"R");
				$this->ln();

				$s1 = Util::CLNumberParser($G->getA()->servicepolice1, "store");
				$s2 = Util::CLNumberParser($G->getA()->servicepolice2, "store");
				$s3 = Util::CLNumberParser($G->getA()->servicepolice3, "store");

				$this->SetFont($this->fontPositionen[0], $this->fontPositionen[1], $this->fontPositionen[2]);
				$this->Cell(109,5,Util::formatNumber($this->language, $s1, 5, true,false)."%: ".Util::conv_euro(Util::formatCurrency($this->language, $this->gesamtEK2 * $s1 / 100, true)),0,0,"R");
				$this->Cell(30,5,Util::formatNumber($this->language, $s2, 5, true,false)."%: ".Util::conv_euro(Util::formatCurrency($this->language, $this->gesamtEK2 * $s2 / 100, true)),0,0,"R");
				$this->Cell(0,5,Util::formatNumber($this->language, $s3, 5, true,false)."%: ".Util::conv_euro(Util::formatCurrency($this->language, $this->gesamtEK2 * $s3 / 100, true)),0,0,"R");

				$this->ln();
				$this->Line(100 , $this->getY(), 210-$this->marginRight , $this->getY());
			}

			$this->ln(10);
		}
	}
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="printPDFHeader">
	function printPDFHeader(){
		$userLabels = mUserdata::getRelabels("Artikel");
		$userHiddenFields = mUserdata::getHides("Artikel");
		
		$type = $this->VarsGRLBM->getMyPrefix();
		
		$this->SetFont($this->fontPositionenHeader[0], $this->fontPositionenHeader[1], $this->fontPositionenHeader[2]);
		#$fpdf->SetFont('Arial','BI',9);

		if($type != "Kalk" AND $this->widthPosition)
			$this->Cell($this->widthPosition, 5, utf8_decode($this->labelPosition), 0, 0, "R");
				
		if($this->widthMenge)
			$this->Cell($this->widthMenge, 5, utf8_decode($this->labelMenge),0,0,"R");
		
		if($type == "R" OR $type == "A" OR $type == "G" OR $type == "L"){
				
			if($this->widthEinheit)
				$this->Cell($this->widthEinheit, 5, utf8_decode($this->labelEinheit), 0, 0, "L");
				
			if($this->widthArtikelnummer)
				$this->Cell($this->widthArtikelnummer, 5, utf8_decode($this->labelArtikelnummer), 0, 0, "L");
				
			if($this->widthBezeichnung)
				$this->Cell($this->widthBezeichnung, 5, utf8_decode($this->labelBezeichnung), 0, 0, "L");
				
			if($type != "L"){
				if($this->widthEinzelpreis)
					$this->Cell($this->widthEinzelpreis,5,utf8_decode($this->labelEinzelpreis), 0, 0, "R");
					
				if($this->widthRabatt)
					$this->Cell($this->widthRabatt,5,utf8_decode($this->labelRabatt), 0, 0, "R");
					
				if($this->widthRabattpreis)
					$this->Cell($this->widthRabattpreis,5,utf8_decode($this->labelRabattpreis), 0, 0, "R");
					
				if($this->widthGesamt)
					$this->Cell($this->widthGesamt, 5, utf8_decode($this->labelGesamt), 0, 0, "R");
			}
		}
		if($type == "Kalk"){
			#$fpdf->Cell(28,5,"Einheit",0,0,"L");
			if($this->widthBezeichnung)
				$this->Cell($fpdf->widthBezeichnung, 5, utf8_decode($this->labelBezeichnung), 0, 0, "L");
				
			if($this->widthEK1)
				$this->Cell($this->widthEK1, 5, (!isset($userHiddenFields["EK1"]) ? (isset($userLabels["EK1"]) ? $userLabels["EK1"] : utf8_decode($this->labelEK1)) : ""), 0, 0, "R");

			if($this->widthEK2)
				$this->Cell($this->widthEK2, 5, (!isset($userHiddenFields["EK2"]) ? (isset($userLabels["EK2"]) ? $userLabels["EK2"] : utf8_decode($this->labelEK2)) : ""), 0, 0, "R");

			if($this->widthVK)
				$this->Cell($this->widthVK, 5, utf8_decode($this->labelVK), 0, 0, "R");
		}
		$this->Ln();
		$this->SetFont('Arial','',9);
		
		$lineY = $this->getY();
		$this->Line($this->marginLeft , $lineY, 210-$this->marginRight , $lineY);
	}
	// </editor-fold>

	// <editor-fold defaultstate="collapsed" desc="Output">
	function Output($filename = "",$mode = ""){
		$this->AliasNbPages("{nb}");
		parent::Output($filename,$mode);
	}
	// </editor-fold>
	
	// <editor-fold defaultstate="collapsed" desc="getLeftMargin">
	public function getLeftMargin(){
		return $this->lMargin;
	}
	// </editor-fold>
}
?>