<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class ExcelExport extends UnifiedTable {
	public function getExport($filename){
		$workbook = new Spreadsheet_Excel_Writer();

		$format_header = $workbook->addFormat();
		$format_header->setSize(15);
		$format_header->setBold();
		$format_header->setTextWrap(true);

		$format_bold = $workbook->addFormat();
		$format_bold->setBold();

		$format_right = $workbook->addFormat();
		$format_right->setAlign('right');

		$format_right_bold = $workbook->addFormat();
		$format_right_bold->setAlign('right');
		$format_right_bold->setBold();

		$worksheet = $workbook->addWorksheet();

		foreach($this->colWidth AS $k => $v)
			$worksheet->setColumn($k - 1,$k - 1,20);

		$line = 0;

		if($this->caption != null){
			$worksheet->setRow(0,50);
			$worksheet->setMerge(0,0,0,$this->numCols-1);

			$worksheet->write(0, 0, utf8_decode($this->caption), $format_header);

			$line++;
		}

		if($this->header != null){
			foreach($this->header AS $k => $v){
				$layoutClass = $format_bold;
				if(isset($this->colClass[$k + 1])){
					switch($this->colClass[$k + 1]){
						case "right":
						case "rightBold":
							$layoutClass = $format_right_bold;
						break;
					}
				}

				$worksheet->write($line, $k, utf8_decode($v), $layoutClass);
			}

			$line++;
		}

		foreach($this->content AS $k => $v){
			foreach($v AS $col => $content){
				$layoutClass = null;
				if(isset($this->colClass[$col + 1])){
					switch($this->colClass[$col + 1]){
						case "right":
							$layoutClass = $format_right;
						break;

						case "rightBold":
							$layoutClass = $format_right_bold;
						break;
					}
				}

				$worksheet->write($line, $col, utf8_decode($content), $layoutClass);
			}
			
			$line++;
		}

		$workbook->send($filename);
		$workbook->close();
	}
}
?>
