<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class KategorienGUI extends Kategorien implements iGUIHTMLMP2, iCategoryFilter {
	function getHTML($id,$page){

		$gui = new HTMLGUI();
		$gui->VersionCheck("Kategorien");
		
		$merge = $this->getAvailableCategories(false);

		foreach($merge as $key => $value)
			$this->addAssocV3("type","=","$value","OR");
			
		$this->addAssocV3("type","=","3","OR");
		$this->addOrderV3("type","ASC");
		
		$gui->showFilteredCategoriesWarning($this->filterCategories(),$this->getClearClass());
		$gesamt = $this->loadMultiPageMode($id, $page, 0);
		
		$gui->setMultiPageMode($gesamt, $page, 0, "contentRight", str_replace("GUI","",get_class($this)));
		if($this->collector != null) $gui->setAttributes($this->collector);
		$gui->setName("Kategorie");
		$gui->setCollectionOf("Kategorie","Kategorie");

		$gui->setShowAttributes(array("name"));
		
		$gui->setDisplayGroup("type",array_flip($merge));
		
		$gui->setParser("type","KategorienGUI::typeParser");
		$gui->setParser("name","KategorienGUI::nameParser", array("\$type"));
		
		return $gui->getBrowserHTML($id);
	}
	
	/*public function getSelectorHTML($tableLabel, $checkupTable, $identifier){

		$gui = new HTMLGUI();
		
		$this->lCV3(-1);
		
		if($this->collector != null) $gui->setAttributes($this->collector);
		$gui->setName($tableLabel);
		$gui->setCollectionOf("Kategorie");
		
		$gui->setIsDisplayMode(true);
		
		$gui->setShowAttributes(array("KategorieID","name"));
		
		$gui->addColStyle("KategorieID", "width:18px;");
		
		$gui->setParser("KategorieID", "KategorienGUI::IDParser", array("\$".$checkupTable."ID", $checkupTable,"\$aid", $identifier));
		
		return $gui->getBrowserHTML(-1);
	}*/
	
	public static function IDParser($w, $l, $p){
		$s = HTMLGUI::getArrayFromParametersString($p);
		
		$B = new Button("", "./images/i2/".($s[0] != "" ? "" : "not")."ok.gif");
		$B->type("icon");
		if($s[0] == "") $B->rme($s[1], "-1", "createRemote", array("'$s[2]'", "'$s[3]'"), "if(checkResponse(transport)) reloadLeftFrame();");
		else $B->rme($s[1], $s[0], "deleteRemote", '', "if(checkResponse(transport)) reloadLeftFrame();");
		
		return $B;
	}
	
	public function getAvailableCategories($flip = true){
		if(isset($_SESSION["nil"]["kategorien"]) AND isset($_SESSION[$_SESSION["applications"]->getActiveApplication()]["kategorien"])) $merge = array_merge($_SESSION[$_SESSION["applications"]->getActiveApplication()]["kategorien"], $_SESSION["nil"]["kategorien"]);
		elseif(isset($_SESSION[$_SESSION["applications"]->getActiveApplication()]["kategorien"])) $merge = $_SESSION[$_SESSION["applications"]->getActiveApplication()]["kategorien"];
		elseif(isset($_SESSION["nil"]["kategorien"])) $merge = $_SESSION["nil"]["kategorien"];
		else $merge = array();
		
		return $flip ? array_flip($merge) : $merge;
	}
	
	public function getCategoryFieldName(){
		return "type";
	}
	
	public static function typeParser($w){
		$ks = array_flip($_SESSION[$_SESSION["applications"]->getActiveApplication()]["kategorien"]);
		return (isset($ks[$w]) ? $ks[$w] : "Typ nicht registriert");
	}
	
	public static function nameParser($w, $l, $p){
		if($p == "mwst")
			return Util::CLNumberParser(Util::parseFloat("de_DE",str_replace("%","",$w)),"load")."%";
		else return $w;
	}
}
?>
