<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class Kappendix extends PersistentObject {
	public function __construct($id){
		parent::__construct($id);

		$this->customize();
	}

	public function newAttributes(){
		$A = parent::newAttributes();
		$A->KappendixSameKontoinhaber = 1;
		
		if($this->customizer != null)
			$this->customizer->customizeNewAttributes($this->getClearClass(get_class($this)), $A);

		return $A;
	}

	// <editor-fold defaultstate="collapsed" desc="getKappendixIDToAdresse">
	public static function getKappendixIDToAdresse($AdresseID, $returnKundennummer = false){
		$ac = new anyC();
		$ac->setCollectionOf("Kappendix");
		$ac->addAssocV3("AdresseID", "=", $AdresseID);

		$K = $ac->getNextEntry();

		if($K != null) return $K->getID();
		else return null;
	}
	// </editor-fold>
}
?>
