<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class KappendixGUI extends Kappendix implements iGUIHTML2 {
	public $showAttributes = array("kundennummer","UStIdNr", "KappendixSameKontoinhaber",
			"KappendixKontoinhaber","KappendixKontonummer","KappendixBLZ","KappendixSWIFTBIC","KappendixEinzugsermaechtigung","KappendixEinzugsermaechtigungAltZBTB",
			"KappendixKreditkarte","KappendixKartennummer","KappendixKarteValidUntil","bemerkung",
			"RTextbausteinOben","RTextbausteinUnten","RZahlungsbedingungen",
			"GTextbausteinOben","GTextbausteinUnten","GZahlungsbedingungen",
			"ATextbausteinOben","ATextbausteinUnten","AZahlungsbedingungen",
			"LTextbausteinOben","LTextbausteinUnten","LZahlungsbedingungen");

	function getHTML($id){
		#if($this->A == null AND $id != -1) $this->loadMe();
		$this->loadMeOrEmpty();
		
		$bps = $this->getMyBPSData();
		
		$gui = new HTMLGUI();
		$gui->setObject($this);
		$gui->setName("Kundendaten");

		$gui->setType("AdresseID","hidden");
		$gui->setType("bemerkung","textarea");
		$gui->setFormID("KappendixForm");
		
		$gui->setLabel("UStIdNr","USt-IdNr/St.Nr.");
		
		$gui->setLabel("KappendixKontoinhaber","Kontoinhaber");
		$gui->setLabel("KappendixKontonummer","Kontonummer");
		$gui->setLabel("KappendixBLZ","BLZ");
		$gui->setLabel("KappendixSWIFTBIC","SWIFT/BIC");
		#$gui->insertSpaceAbove("KappendixKontoinhaber");
		$gui->insertSpaceAbove("KappendixSameKontoinhaber");
		$gui->insertSpaceAbove("bemerkung");
		$gui->insertSpaceAbove("KappendixKreditkarte");
		
		$gui->setLabel("KappendixEinzugsermaechtigung","Einzugserm.?");
		$gui->setType("KappendixEinzugsermaechtigung","checkbox");
		$gui->setLabel("KappendixKreditkarte","Kreditkarte");
		$gui->setType("KappendixKreditkarte","select");
		$gui->setOptions("KappendixKreditkarte", array("-","visa", "mastercard", "americanExpress"), array("bitte auswählen","Visa", "MasterCard", "American Express"));
		$gui->setLabel("KappendixKartennummer","Kartennummer");
		$gui->setLabel("KappendixKarteValidUntil","gültig bis");
		$gui->setLabel("KappendixEinzugsermaechtigungAltZBTB","ZahlBed.");

		$gui->setInputJSEvent("KappendixEinzugsermaechtigung", "onclick", "contentManager.toggleFormFields(!this.checked ? 'hide' : 'show', ['KappendixEinzugsermaechtigungAltZBTB']);");

		$tb = new Textbausteine();
		list($keys,$values) = $tb->getTBs("zahlungsbedingungen","R");
		array_unshift($keys, "0");
		array_unshift($values, "nicht ändern");
		$gui->setType("KappendixEinzugsermaechtigungAltZBTB","select");
		$gui->setOptions("KappendixEinzugsermaechtigungAltZBTB", $keys, $values);
		$gui->setFieldDescription("KappendixEinzugsermaechtigungAltZBTB", "Dieser Textbaustein wird verwendet, wenn eine Einzugsermächtigung erteilt wurde.");
		if($this->A->KappendixEinzugsermaechtigung === "0")
			$gui->setLineStyle("KappendixEinzugsermaechtigungAltZBTB", "display:none;");

		$gui->setType("KappendixSameKontoinhaber","checkbox");
		$gui->setLabel("KappendixSameKontoinhaber", "Inhaber?");
		$gui->setFieldDescription("KappendixSameKontoinhaber", "Kontoinhaber entspricht Adresse");
		if($this->A->KappendixSameKontoinhaber == 1)
			$gui->setLineStyle("KappendixKontoinhaber", "display:none;");
		$gui->setInputJSEvent("KappendixSameKontoinhaber", "onclick", "contentManager.toggleFormFields(this.checked ? 'hide' : 'show', ['KappendixKontoinhaber']);");
		#$gui->setFieldDescription("UStIdNr","TIN = Steuernummer");
		
		$grlbms = array("R","G","A","L");
		
		
		for($i=0;$i<count($grlbms);$i++){
			
			if(isset($bps["mode"]) AND $bps["mode"] == "short"){
				#if($grlbms[$i] != "R") {
					$gui->setType($grlbms[$i]."TextbausteinOben","hidden");
					$gui->setType($grlbms[$i]."TextbausteinUnten","hidden");
					$gui->setType($grlbms[$i]."Zahlungsbedingungen","hidden");
					
					continue;
				#}
			}
			
			$gui->insertSpaceAbove($grlbms[$i]."TextbausteinOben","Textbausteine ".Stammdaten::getLongType($grlbms[$i]));
			
			$tb = new Textbausteine();
			list($keys,$values) = $tb->getTBs("oben",$grlbms[$i]);
			$gui->setLabel($grlbms[$i]."TextbausteinOben","TB oben");
			$gui->setType($grlbms[$i]."TextbausteinOben","select");
			$gui->setOptions($grlbms[$i]."TextbausteinOben",$keys,$values);
			
			$tb = new Textbausteine();
			list($keys,$values) = $tb->getTBs("unten",$grlbms[$i]);
			$gui->setLabel($grlbms[$i]."TextbausteinUnten","TB unten");
			$gui->setType($grlbms[$i]."TextbausteinUnten","select");
			$gui->setOptions($grlbms[$i]."TextbausteinUnten",$keys,$values);
			
			$tb = new Textbausteine();
			list($keys,$values) = $tb->getTBs("zahlungsbedingungen",$grlbms[$i]);
			$gui->setLabel($grlbms[$i]."Zahlungsbedingungen","ZahlBed.");
			$gui->setType($grlbms[$i]."Zahlungsbedingungen","select");
			$gui->setOptions($grlbms[$i]."Zahlungsbedingungen",$keys,$values);
		}
		
		$gui->setShowAttributes($this->showAttributes);
		
		if(isset($bps["mode"]) AND $bps["mode"] == "short") {

			$gui->insertSpaceAbove("KappendixSameKontoinhaber", "Kontodaten", true);
			$gui->insertSpaceAbove("KappendixKreditkarte", "Kreditkartendaten und Bemerkung", true);
			$gui->setStandardSaveButton($this, "Adressen", "$('AdresseForm').currentSaveButton.click();");
			#$gui->setSaveButtonValues(get_parent_class($this), $this->ID, "Adressen", );#saveAdresseToo();
			$_SESSION["BPS"]->unregisterClass(get_class($this));
			
			$B = new Button("alle Kunden-\ndaten anzeigen","kunden");
			$B->onclick("new Ajax.Updater('contentLeft','./interface/loadFrame.php?bps=KundeGUI;AdresseID:{$this->A->AdresseID};action:Kappendix&p=Kunde');");
			$B->style("float:right;");
		} else $gui->setStandardSaveButton($this, "Adressen");
		#$gui->setSaveButtonValues(get_parent_class($this), $this->ID, "Adressen");
		
		$B2 = new Button("freie Kunden-\nnummern","empty");
		$B2->onclick("Popup.create('$this->ID', 'Kappendix', 'freie Kundennummern'); loadFrameV2('KappendixDetailsContent$this->ID','KundennummernBelegung');Popup.show('$this->ID', 'Kappendix');");
		
		$gui->customize($this->customizer);
		
		#<input type=\"button\" class=\"bigButton backgroundColor3\" value=\"freie\nKundennummern\" onclick=\"\" />
		return "<table><tr><td class=\"backgroundColor2\">".((isset($bps["mode"]) AND $bps["mode"] == "short") ? $B : "")."$B2</td></tr></table>".$gui->getEditHTML();

	}
}
?>