<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class KundeGUI extends Kunde implements iGUIHTML2 {
	
	function getHTML($id){
		
		$_SESSION["BPS"]->setActualClass(get_class($this));
		$bps = $_SESSION["BPS"]->getAllProperties();
		 
		$id = $bps["AdresseID"];
		$this->ID = $bps["AdresseID"];
		
		$Adresse = new Adresse($id);
		
		$mKApp = new mKappendixGUI();
		$mKApp->setAssocV3("AdresseID","=",$this->ID);
		$KApp = $mKApp->getNextEntry();
		if($bps["action"] == "Kappendix" AND $KApp == null){
			$K = new Kunden();
			$K->createKundeToAdresse($id,false);
			
			$mKApp = new mKappendixGUI();
			$mKApp->setAssocV3("AdresseID","=",$this->ID);
			$KApp = $mKApp->getNextEntry();
		}
		
		$html = "
	<div class=\"backgroundColor1 Tab\"><p>Kunde</p></div>
	<table>
		<colgroup>
			<col class=\"backgroundColor2\" style=\"width:120px;\" />
			<col class=\"backgroundColor3\" />
		</colgroup>
		<tr>
			<td colspan=\"2\">".$Adresse->getHTMLFormattedAddress()."</td>
		</tr>
		".(($KApp != null AND $bps["action"] == "Kundenpreise") ? "<tr>
			<td><label>Kundennummer:</label></td>
			<td>".$KApp->getA()->kundennummer."</td>
		</tr>" : "")."
		".($_SESSION["S"]->checkForPlugin("Objekte") ? "<tr>
			<td>
				<input type=\"button\" onclick=\"setHighLight($('ObjekteMenuEntry'));loadFrame('contentRight','Objekte','".$this->ID."');\" style=\"float:right;background-image:url(./images/navi/clear.png);\" class=\"backgroundColor2 bigButton\" value=\"Objekte\" />
				<input type=\"button\" onclick=\"setHighLight($('KundenMenuEntry'));loadFrame('contentRight','OGRLBMs','".$this->ID."');\" style=\"background-image:url(./images/navi/rechnung.png);\" class=\"backgroundColor2 bigButton\" value=\"Rechnungen\" />
			</td>
		</tr>
		<tr>
			<td>
				<input class=\"backgroundColor2 bigButton\" type=\"button\" onclick=\"createAbrufRechnung(".$this->ID.");\" style=\"background-image:url(./images/navi/rechnungNew.png);margin-top:15px;\" value=\"Abruf-Rechnung\" />
			</td>
		</tr>
		<tr>
			<td>
				<input type=\"button\" onclick=\"createMonatsRechnung(".$this->ID.");\" class=\"backgroundColor2 bigButton\" style=\"background-image:url(./images/navi/rechnungNew.png);margin-top:15px;\" value=\"Monatsrechnung\" /><br />
				<select class=\"backgroundColor2\" id=\"monthForRechnung\" style=\"width:150px;margin-top:3px;margin-bottom:15px;\">".Datum::getMonthOptions(Datum::getGerMonthArray())."</select>
			</td>
		</tr>" : "")."
	</table>";
		
		if(isset($bps["mode"]) AND $bps["mode"] == "short") {
			$_SESSION["BPS"]->registerClass("KappendixGUI");
			$_SESSION["BPS"]->setACProperty("mode","short");
			$html = "";
		}
		
		if($bps["action"] == "Kappendix"){
			return $html.$KApp->getGUIClass()->getHTML("","","","");
		}
		if($bps["action"] == "Kundenpreise"){
			if($KApp == null) {
				$html .= "
				<table>
					<tr>
						<td class=\"backgroundColor1\">Diesem Kunden wurde noch keine Kundennummer zugewiesen!</td>
					</tr>
				</table>";

				return $html;
			}
			
			
			$_SESSION["BPS"]->registerClass("KundenpreisGUI");
			$_SESSION["BPS"]->setACProperty("kundennummer",$KApp->getA()->kundennummer);
			
			$mKApp = new KundenpreiseGUI();
			$mKApp->setAssocV3("kundennummer","=",$KApp->getA()->kundennummer);
			#$KApp = $mKApp->getNextEntry();
			/*if($KApp == null) {
				$K = new Kunden();
				$K->createKundeToAdresse($id);
				
				$mKApp = new mKappendixGUI();
				$mKApp->setAssocV3("AdresseID","=",$this->ID);
				$KApp = $mKApp->getNextEntry();
			}*/
			return $html.$mKApp->getHTML(-1,"","","");
		}
	}
	
	public function deleteMe(){
		$A = new Adresse($this->ID);
		$A->deleteMe();
		
		$mKApp = new mKappendixGUI();
		$mKApp->addAssocV3("AdresseID","=",$this->ID);
		$mKApp->lCV3();
		$KApp = $mKApp->getNextEntry();
		
		$KApp->deleteMe();
	}

	public function createAbrufRechnung(){
		echo parent::createAbrufRechnung();
	}
	
	public function createMonatsRechnung($monat){
		echo parent::createMonatsRechnung($monat);
	}
}
?>