<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class KundenpreiseGUI extends Kundenpreise implements iGUIHTML2 {
	public function getHTML($id){
		$this->setFieldsV3(array("name","kundenPreis","isBrutto"));
		if($this->A == null) $this->lCV3($id);
		
		$gui = new HTMLGUI();
		$gui->setName("Kundenpreise");
		if($this->collector != null) $gui->setAttributes($this->collector);
		
		$_SESSION["BPS"]->registerClass("mArtikelGUI");
		
		#$gui->setIsDisplayMode(true);
		$gui->setMultiEditMode(array("kundenPreis"));
		$gui->setDeleteInDisplayMode(true);
		
		$gui->setCollectionOf($this->collectionOf);
		$gui->hideAttribute("isBrutto");
		$gui->setColWidth("kundenPreis","70px");
		
		$gui->addColStyle("kundenPreis","text-align:right;");
		
		$gui->hideAttribute("KundenpreisID");
		
		#$gui->setShowAttributes(array("name","kundenPreis"));
		
		$gui->addRowAfter("1","addPostenButton");

		$gui->setJSEvent("onDelete","function(){reloadLeftFrame();}");
		
		$gui->setParser("addPostenButton","KundenpreiseGUI::addPostenButton",array("","",""));
		
		$gui->setParser("name","KundenpreiseGUI::nameParser", array("\$isBrutto"));
		
		try {
			return $gui->getBrowserHTML($id);
		} catch (Exception $e){ }
	}	
	
	public static function nameParser($w, $l, $p){
		return $w.($p == "1" ? "<br /><small>Brutto-Artikel</small>" : "");
	}
	
	public static function addPostenButton($w,$t,$p){
		$s = HTMLGUI::getArrayFromParametersString($p);
		return "
		<input type=\"button\" value=\"Artikel\nhinzufügen\" class=\"bigButton backgroundColor2\" style=\"background-image:url(./images/navi/package.png);\" onclick=\"loadFrameV2('contentRight','mArtikel','mArtikelGUI;selectionMode:multiSelection,Kundenpreis,-2,makeKundenpreis,Adressen,contentLeft,Kunde,-2');\" />";
	}
}
?>
