<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class Stammdaten extends PersistentObject {

	function getA(){
		return $this->A;
	}
	
	public static function getLongType($of,$withS = false){
		$types = array();
		$types["R"] = "Rechnung";
		$types["G"] = "Gutschrift";
		$types["L"] = "Lieferschein";
		$types["M"] = "Mahnung";
		$types["A"] = "Angebot";
		
		$typesS = array();
		$typesS["R"] = "Rechnungs";
		$typesS["G"] = "Gutschrifts";
		$typesS["L"] = "Lieferschein";
		$typesS["M"] = "Mahnungs";
		$typesS["A"] = "Angebots";
		
		if(isset($typesS[$of]) OR isset($types[$of])) 
			if($withS) return $typesS[$of];
			else return $types[$of];
		elseif(isset($_SESSION["additionalTypes"][$of]) OR isset($_SESSION["additionalTypesWs"][$of]))
			if($withS) return $_SESSION["additionalTypesWs"][$of];
			else return $_SESSION["additionalTypes"][$of];
		else {
			echo "Type '$of' unknown!";
			exit();
		}
	}

	public function parseContent($string, $type){
		if($this->A == null) $this->loadMe();
		
		while(ereg("%%\(([A-Za-z0-9?/&\_:| \-]*)\)%%",$string,$regs)){
			$replaceWith = "";
			
			$types = array("G","R","L","A");
			$replaces = array("S" => array("Firmenname" => $this->A->firmaLang));
			
			$s = explode("|",$regs[1]);
			$s = array_map("trim",$s);
			
			for($i=0;$i<count($s);$i++){
				$e = explode(":",$s[$i]);
				$e = array_map("trim",$e);
				
				if(in_array($e[0],$types)){
					if($type == $e[0]){
						$replaceWith = $e[1];
						break;
					}
				} elseif(isset($replaces[$e[0]])){
					if(!isset($replaces[$e[0]][$e[1]])) {
						echo "Error: Did not recognize $e[1]\n";
						continue;
					}
					
					$replaceWith = $replaces[$e[0]][$e[1]];
					break;
				} else {
					echo "Error: Did not recognize $e[0]\n";
				}
			}
			
			$string = str_replace($regs[0],$replaceWith,$string);
		}
		return $string;
	}
	
	public function getParsedEmailContent($type){
		return $this->parseContent($this->A->emailContent, $type);
	}

	public static function getActiveStammdaten(){
		$msd = new mStammdaten();
		$msd->addAssocV3("aktiv","=","1");
		
		return $msd->getNextEntry();
	}
	
	function getPrefix($of){
		$ps = array("G","R","L","B","M","K","A");
		$var = "prefix".$of;
		if(in_array($of,$ps)) return $this->A->$var;
		else return "";
	}
}
?>
