<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class StammdatenGUI extends Stammdaten implements iGUIHTML2 {
	function getHTML($id){
		$this->loadMeOrEmpty();
		#if($this->A == null AND $id != -1) $this->loadMe();
		#if($id == -1) $this->A = new StammdatenAttributes();
		
		$FB = new FileBrowser();
		$FB->addDir("../open3A/Brief/");
		$FB->addDir("../specifics/");
		$a = $FB->getAsLabeledArray("iVorlage",".class.php",true);
		
		$FB2 = new FileBrowser();
		$FB2->addDir("../open3A/Auftraege/");
		$FB2->addDir("../specifics/");
		$FB2->setDefaultConstructorParameter("-1");
		$a2 = $FB2->getAsLabeledArray("iReNr",".class.php",true);
		
		if(in_array("AuftragGUI", $a2)) $a2[array_search("AuftragGUI", $a2)] = "Auftrag";

		$gui = new HTMLGUI();
		$gui->setObject($this);
		$gui->setName("Stammdaten");

		$gui->setShowAttributes(array(
			"template",
			"ownTemplate",
			"ownTemplatePrint",
			"ownTemplateEmail",
			"templateReNr",
			"firmaKurz",
			"firmaLang",
			"vorname",
			"nachname",
			"strasse",
			"nr",
			"land",
			"plz",
			"ort",
			"telefon",
			"mobil",
			"fax",
			"email",
			"internet",
			"inhaber",
			"geschaeftsfuehrer",
			"ustidnr",
			"amtsgericht",
			"handelsregister",
			"bank",
			"blz",
			"ktonr",
			"SWIFTBIC",
			"IBAN",
			"prefixG",
			"prefixR",
			"prefixL",
			"prefixB",
			"prefixM",
			"prefixO",
			"prefixA",
			"prefixK"));

		$gui->setType("aktiv","hidden");
		$gui->setLabel("firmaKurz","Firma kurz");
		$gui->setLabel("firmaLang","Firma lang");
		
		$gui->setType("ownTemplate","select");
		$gui->setOptions("ownTemplate",array_values($a), array_keys($a));
		$gui->setLabel("ownTemplate","Vorlage");
		$gui->setFieldDescription("ownTemplate","für PDF-Ausgabe und E-Mail");
		
		$gui->setType("ownTemplatePrint","select");
		$gui->setOptions("ownTemplatePrint",array_values($a), array_keys($a));
		$gui->setLabel("ownTemplatePrint","Vorlage");
		$gui->setFieldDescription("ownTemplatePrint","für direkt-Druck");
		
		if(!$_SESSION["S"]->checkForPlugin("mDrucker")) $gui->hideAttribute("ownTemplatePrint");
		
		$gui->setType("ownTemplateEmail","hidden");
		$gui->setLabel("geschaeftsfuehrer","Geschäftsführer");
		$gui->setFieldDescription("geschaeftsfuehrer","Bitte geben Sie einen Inhaber <b>oder</b> Geschäftsführer ein");
		
		$gui->setLabel("prefixG","Gutschrift");
		$gui->setLabelDescription("prefixG","Präfix");
		$gui->setFieldDescription("prefixG","standard: G");
		$gui->setLabel("prefixR","Rechnung");
		$gui->setLabelDescription("prefixR","Präfix");
		$gui->setFieldDescription("prefixR","standard: R");
		$gui->setLabel("prefixL","Lieferschein");
		$gui->setLabelDescription("prefixL","Präfix");
		$gui->setFieldDescription("prefixL","standard: L");
		$gui->setLabel("prefixK","Kunde");
		$gui->setLabelDescription("prefixK","Präfix");
		$gui->setFieldDescription("prefixK","standard: K");
		$gui->setLabel("prefixA","Angebot");
		$gui->setLabelDescription("prefixA","Präfix");
		$gui->setFieldDescription("prefixA","standard: A");
		$gui->setLabel("prefixM","Mahnung");
		$gui->setLabelDescription("prefixM","Präfix");
		$gui->setFieldDescription("prefixM","standard: M");
		
		$gui->setLabel("prefixB","Bestätigung");
		$gui->setLabelDescription("prefixB","Präfix");
		$gui->setFieldDescription("prefixB","standard: B");
		
		$gui->setLabel("ustidnr","USt-IdNr/St.Nr.");
		$gui->setLabel("bank","Name der Bank");
		$gui->setLabel("blz","Bankleitzahl");
		$gui->setLabel("ktonr","Kontonummer");
		$gui->setLabel("SWIFTBIC","SWIFT/BIC");
		$gui->setLabel("strasse","Straße");

		$gui->insertSpaceAbove("bank");
		$gui->insertSpaceAbove("inhaber");
		$gui->insertSpaceAbove("template","Vorlagen", true);
		$gui->insertSpaceAbove("firmaKurz","Firmendaten", true);
		$gui->insertSpaceAbove("telefon");
		$gui->insertSpaceAbove("ustidnr");
		$gui->insertSpaceAbove("prefixG", "Präfixe", true);
		
		#$gui->setType("emailContent","hidden");
		#$gui->hideAttribute("prefixM");
		$gui->hideAttribute("prefixO");

		$gui->setLineStyle("template","display:none;");

		$gui->setLabel("templateReNr","Nummern");
		$gui->setFieldDescription("templateReNr","Die Rechnungsnummern werden automatisch hochgezählt.");
		$gui->setType("templateReNr","select");
		$gui->setOptions("templateReNr",array_values($a2), array_keys($a2));
		$gui->addRowAfter("aktiv","Achtung");
		$gui->setParser("Achtung","StammdatenGUI::achtungParser");
		$gui->setStandardSaveButton($this);
		
		$table = new HTMLTable(1);
		if($this->ID != -1)
			if($this->A->aktiv == "0") $table->addRow(array("<span style=\"color:red;\">Diese Stammdaten sind nicht aktiv und werden nicht verwendet.</span><br /><br />Sie können diese Stammdaten aktivieren, indem Sie in der Liste auf der rechten Seite das Häkchen setzen.<br />Es kann immer nur ein Stammdatensatz aktiv sein."));
			else $table->addRow(array("<span style=\"color:green;\">Diese Stammdaten sind aktiv und werden verwendet.</span>"));
		
		return $table->getHTML().$gui->getEditHTML();
	}

	public static function achtungParser($w){
		return "Es darf immer nur ein Stammdaten-Satz als aktiv markiert sein.";
	}
	
	function getLetter(){
		if($this->A ==  null AND $this->ID != -1) $this->loadMe();
		
		$brief = new Brief();
		$brief->setStammdaten($this);
		
		$brief->generate(false);
	}
}
?>