<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class mStammdatenGUI extends mStammdaten implements iGUIHTML2 {
	public function getHTML($id){
		$gui = new HTMLGUI();
		$gui->VersionCheck("mStammdaten");

		#if($query != "") $this->makeSearch($query);
		if($this->A == null) $this->lCV3($id);
		
		$gui->setName("Stammdaten");
		if($this->collector != null) $gui->setAttributes($this->collector);
		
		$gui->setCollectionOf($this->collectionOf);
		$gui->setShowAttributes(array("aktiv","firmaKurz"));
		$gui->setParser("aktiv","mStammdatenGUI::aktivParser",array("\$aid"));
		$gui->setColWidth("aktiv","20px");
		
		$gui->setParser("firmaKurz","mStammdatenGUI::firmaParser",array("\$sc->vorname","\$sc->nachname","\$aid")); # only works because \$sc->vorname is eval'd while $sc is set in HTMLGUI.class.php
		
		try {
			return $gui->getBrowserHTML($id);
		} catch (Exception $e){ }
	}
	
	public static function firmaParser($w, $a, $p){
		$s = HTMLGUI::getArrayFromParametersString($p);
		return ($w != "" ? "<img style=\"float:right;\" title=\"leeren Brief anzeigen\" src=\"./images/i2/pdf.gif\" onclick=\"document.open('./interface/rme.php?bps=mGRLBMGUI;type:R&class=Stammdaten&amp;constructor=$s[2]&amp;method=getLetter&amp;parameters=','Druckansicht','height=650,width=875,left=20,top=20');\" />".$w : "<img style=\"float:right;\" title=\"leeren Brief anzeigen\" src=\"./images/i2/pdf.gif\" onclick=\"document.open('./interface/rme.php?class=Stammdaten&amp;constructor=$s[2]&amp;method=getLetter&amp;parameters=','Druckansicht','height=650,width=875,left=20,top=20');\" />".$s[0]." ".$s[1]);
	}
	
	public static function aktivParser($w, $a, $p){
		return $w == 1 ? "<img src=\"./images/i2/ok.gif\" title=\"Stammdaten aktiv\" />" : "<img src=\"./images/i2/notok.gif\" title=\"Stammdaten aktivieren\" onclick=\"rme('mStammdaten','','activate','$p','reloadRightFrame();');\" class=\"mouseoverFade\" />";
	}
	
	public function activate($id){
		$this->addAssocV3("aktiv","=","1");
		while($t = $this->getNextEntry()){
			$t->changeA("aktiv","0");
			$t->saveMe();
		}
		
		$S = new Stammdaten($id);
		$S->changeA("aktiv","1");
		$S->saveMe();
	}
}
?>
