<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class TextbausteinGUI extends Textbaustein implements iGUIHTML2/*, iFPDF */{
	function getHTML($id){
		
		$this->loadMeOrEmpty();
		
		$gui = new HTMLGUI();
		$gui->setObject($this);
		$gui->setName("Textbaustein");
		
		$gui->setType("isRStandard","checkbox");
		$gui->setType("isGStandard","checkbox");
		$gui->setType("isLStandard","checkbox");
		$gui->setType("isAStandard","checkbox");
		$gui->setType("isKatDefault","checkbox");
		
		$gui->setLabel("isRStandard","Rechnung");
		$gui->setFieldDescription("isRStandard","Standard für Rechnungen?");
		
		$gui->setLabel("isAStandard","Angebot");
		$gui->setFieldDescription("isAStandard","Standard für Angebote?");
		
		$gui->setLabel("isGStandard","Gutschrift");
		$gui->setFieldDescription("isGStandard","Standard für Gutschriften?");
		
		$gui->setLabel("isLStandard","Lieferschein");
		$gui->setFieldDescription("isLStandard","Standard für Lieferscheine?");
		
		$gui->setLabel("isKatDefault","Standard");
		#if(isset($_SESSION["TBKategorien"][$this->A->KategorieID])) 
		$gui->setFieldDescription("isKatDefault","Soll dieser Textbaustein als Standard beim Typ '<span style=\"font-weight:bold;\" id=\"TBType\">".(isset($_SESSION["TBKategorien"][$this->A->KategorieID]) ? $_SESSION["TBKategorien"][$this->A->KategorieID] : "")."</span>' verwendet werden?");
		
		$gui->setLabel("label","Name");
		
		$gui->setType("text","TextEditor");
		
		$values = array();
		$keys = array();
		
		$keys[] = 0;
		$values[] = "bitte auswählen...";
		
		foreach($_SESSION["TBKategorien"] as $key => $value){
			$values[] = $value;
			$keys[] = $key;
		}
		
		$gui->setOptions("KategorieID", $keys, $values);
		$gui->setType("KategorieID","select");
		$gui->setLabel("KategorieID","Typ");

		$gui->setInputJSEvent("KategorieID","onchange","katChange();");
		
		if($this->A->KategorieID == 31 OR $this->A->KategorieID == 32 OR $this->A->KategorieID == 33 OR $this->A->KategorieID == 41 OR $this->A->KategorieID == 42){
			$gui->setLineStyle("isRStandard","display:none");
			$gui->setLineStyle("isLStandard","display:none");
			$gui->setLineStyle("isGStandard","display:none");
			$gui->setLineStyle("isAStandard","display:none");
		}
		if($this->A->KategorieID == 1 OR $this->A->KategorieID == 2 OR $this->A->KategorieID == 3){
			$gui->setLineStyle("isKatDefault","display:none");
		}
		if($this->A->KategorieID == 0){
			$gui->setLineStyle("isRStandard","display:none");
			$gui->setLineStyle("isLStandard","display:none");
			$gui->setLineStyle("isGStandard","display:none");
			$gui->setLineStyle("isAStandard","display:none");
			
			$gui->setLineStyle("isKatDefault","display:none");
		}
		$gui->setShowAttributes(array("label", "text", "KategorieID", "isRStandard", "isLStandard", "isGStandard", "isAStandard", "isKatDefault"));

		$gui->setStandardSaveButton($this);
		#$gui->setSaveButtonValues(get_parent_class($this), $this->ID, $_SESSION["CurrentAppPlugins"]->isCollectionOf(get_parent_class($this)));
		
		$html = "
			<script type=\"text/javascript\">new Draggable('TBVarsContainer',{handle:'TBVarsHandler', zindex: 2000});</script>
			<div 
				style=\"position:absolute;z-index:2000;margin-left:450px;width:200px;border-width:1px;border-style:solid;".(isset($_SESSION["TBVariables"][$this->A->KategorieID]) ? "" : "display:none;")."\"
				class=\"backgroundColor0 borderColor1\"
				id=\"TBVarsContainer\"
			>
			<div class=\"cMHeader backgroundColor1\" id=\"TBVarsHandler\">Variablen:</div>
			<div>
				<p><small>Sie können folgende Variablen in Ihrem Text verwenden (bitte beachen Sie Groß- und Kleinschreibung):</small></p>
				<p id=\"TBVars\">".(isset($_SESSION["TBVariables"][$this->A->KategorieID]) ? "{".implode("}<br />{",$_SESSION["TBVariables"][$this->A->KategorieID])."}" : "")."</p>
			</div>
			</div>";
		
		return $html.$gui->getEditHTML();
	}
	/*
	public function getFPDF(FPDF $fpdf){
		$this->loadMe();
			
		$fpdf->SetFont($fpdf->fontTextbausteine[0], $fpdf->fontTextbausteine[1], $fpdf->fontTextbausteine[2]);
		
		$fpdf->MultiCell(0 , 5 , utf8_decode($this->A->text),0,"L");
		$fpdf->ln();
	}*/
}
?>