<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class Textbausteine extends anyC {
	private $TBKategorien = array();
	function __construct() {
		$this->collectionOf = "Textbaustein";
	}
	
	public function getTBs($kategorie, $type, $standardOnly = false){
		if($type == "Kalk") return null;
		
		switch($kategorie){
			case "oben":
				$this->addAssocV3("KategorieID","=","2");
			break;
			case "unten":
				$this->addAssocV3("KategorieID","=","3");
			break;
			case "zahlungsbedingungen":
				$this->addAssocV3("KategorieID","=","1");
			break;
			
			case "mahnung1":
				$this->addAssocV3("KategorieID","=","31");
			break;
			case "mahnung2":
				$this->addAssocV3("KategorieID","=","32");
			break;
			case "mahnung3":
				$this->addAssocV3("KategorieID","=","33");
			break;
			
			case "emailBetreff":
				$this->addAssocV3("KategorieID","=","41");
			break;
			case "emailText":
				$this->addAssocV3("KategorieID","=","42");
			break;
		}
		
		if($type != "" AND $standardOnly) $this->addAssocV3("is".$type{0}."Standard","=","1");
		
		if($type != "") $this->addOrderV3("is".$type{0}."Standard","DESC");
		else $this->addOrderV3("isKatDefault","DESC");
		$this->addOrderV3("label","ASC");
		
		if($standardOnly AND $type == "") $this->addAssocV3("isKatDefault","=","1");
		
		#$this->loadCollectionV2();
		
		$keys = array();
		$values = array();
		$e = $this->getNextEntry();
		
		while($e != null){
			$ID = $e->getID();
			$A = $e->getA();
			$keys[] = $ID;
			$values[] = $A->label;
			$e = $this->getNextEntry();
		}
		
		$this->A = null;
		
		return array($keys,$values);
	}

	public function addTBKategorie($name,$key){
		if(!isset($_SESSION["TBKategorien"])) $_SESSION["TBKategorien"] = array();
		$_SESSION["TBKategorien"][$key] = $name;
	}
	
	public function addTBVariables($key,$name){
		if(!isset($_SESSION["TBVariables"])) $_SESSION["TBVariables"] = array();
		$_SESSION["TBVariables"][$key] = $name;
	}
}
?>
