<?php
/*
 *  This file is part of open3A.

 *  open3A is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  open3A is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class TextbausteineGUI extends Textbausteine implements iGUIHTML2 {
	function getHTML($id){
		$gui = new HTMLGUI();
		$gui->VersionCheck("Textbausteine");
		
		foreach($_SESSION["TBKategorien"] as $key => $value)
			$this->addAssocV3("KategorieID","=","$key","OR");
		
		$this->setOrderV3("KategorieID","ASC");
		if($this->A == null) $this->lCV3($id);
		
		$gui->setName("Textbausteine");
		if($this->collector != null) $gui->setAttributes($this->collector);
		
		$gui->setCollectionOf($this->collectionOf);
		
		$gui->setParser("isRStandard","TextbausteineGUI::isRStandardParser",array("\$sc->isLStandard","\$sc->isGStandard","\$sc->isAStandard","\$sc->isKatDefault"));
		#$gui->setParser("isLStandard","TextbausteineGUI::isLStandardParser");
		#$gui->setParser("isGStandard","TextbausteineGUI::isGStandardParser");
		#$gui->setParser("isAStandard","TextbausteineGUI::isAStandardParser");
		
		$gui->setShowAttributes(array("isRStandard", "label"));
		
		$gui->setColWidth("isRStandard","50px");
		#$gui->setColWidth("isLStandard","40px");
		#$gui->setColWidth("isGStandard","40px");
		#$gui->setColWidth("isAStandard","40px");
		
		/*$kat = new Kategorien();
		$kat->setAssociation("type","3");
		$kv = $kat->getArrayWithKeysAndValues();*/
		$gui->setDisplayGroup("KategorieID",$_SESSION["TBKategorien"]);

		/*$gui->setShowAttributes(array("aktiv","firmaKurz"));
		$gui->setParser("aktiv","mStammdatenGUI::aktivParser");
		$gui->setColWidth("aktiv","20px");
		
		$gui->setParser("firma","mStammdatenGUI::firmaParser",array("\$sc->vorname","\$sc->nachname")); # only works because \$sc->vorname is eval'd while $sc is set in HTMLGUI.class.php
		*/
		
		$html = "";
		if($id == -1) $html = "
		<div class=\"backgroundColor1 Tab\"><p>Erklärung</p></div>
		<table>
			<colgroup>
				<col style=\"width:30px;\" class=\"backgroundColor3\" />
				<col class=\"backgroundColor2\" />
			</colgroup>
			<tr>
				<td style=\"text-align:right;\">R:</td><td>Standard-Textbaustein für Rechnungen</td>
			</tr>
			<tr>
				<td style=\"text-align:right;\">L:</td>
				<td>Standard-Textbaustein für Lieferscheine</td>
			</tr>
			<tr>
				<td style=\"text-align:right;\">G:</td>
				<td>Standard-Textbaustein für Gutschriften</td>
			</tr>
			<tr>
				<td style=\"text-align:right;\">A:</td>
				<td>Standard-Textbaustein für Angebote</td>
			</tr>
			<tr>
				<td style=\"text-align:right;\">S:</td>
				<td>Standard-Textbaustein für diese Kategorie</td>
			</tr>
		</table>";
		
		try {
			return $gui->getBrowserHTML($id).$html;
		} catch (Exception $e){ }
	}		
	
	public function getTBVariables($KategorieID){
		echo isset($_SESSION["TBVariables"][$KategorieID]) ? implode(";",$_SESSION["TBVariables"][$KategorieID]) : "nil";
	}
	
	public static function isRStandardParser($w, $l, $p){
		$s = HTMLGUI::getArrayFromParametersString($p);
		$html = $w == 1 ? " R " : "";
		$html .= $s[0] == 1 ? " L " : "";
		$html .= $s[1] == 1 ? " G " : "";
		$html .= $s[2] == 1 ? " A " : "";
		$html .= $s[3] == 1 ? " S " : "";
		
		return $html;
	}

}
?>
