<?php
/*
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class InstallationGUI extends Installation implements iGUIHTML2 {
	public function getHTML($id){
		$this->loadMeOrEmpty();
		#if($this->A == null AND $id != -1) $this->loadMe();
		#if($id == -1) $this->A = new InstallationAttributes();
		
		$gui = new HTMLGUI();
		
		if(!$_SESSION["S"]->checkForPlugin("multiInstall")){
			$this->A->httpHost = "*";
			$gui->setType("httpHost","hidden");
		} else $gui->insertSpaceAbove("httpHost");
		
		$gui->setObject($this);
		$gui->setName("Installation");
		$gui->setType("password","password");
		
		$gui->setLabel("datab","Datenbank");
		$gui->setLabel("user","Benutzer");
		$gui->setLabel("password","Passwort");
		$gui->setLabel("httpHost","Domain");
		
		$gui->setFieldDescription("host","der Datenbank");
		$gui->setFieldDescription("httpHost","unter der phynx erreichbar ist oder * für alle Domains");
		#$this->loadGUITranslation($gui);
		$gui->translate($this->loadTranslation());
		$gui->setJSEvent("onSave","
				function() { 
					reloadRightFrame();
					$('contentLeft').update('');"."
				}");
		$gui->setStandardSaveButton($this);
		
		return $gui->getEditHTML();
	}

	public function reloadApplication(){
		session_destroy();
	}
}
?>