<?php
/*
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class mInstallationGUI extends mInstallation implements iGUIHTML2 {

	function updateAllTables(){
		parent::updateAllTables();
	}
	
	function getHTML($id){
		if($this->collector == null) $this->lCV3($id);
		$singularLanguageClass = $this->loadLanguageClass("Installation");
		$text = $singularLanguageClass != null ? $singularLanguageClass->getText() : "";
		
		$t = new HTMLTable(1);
		
		$g = "";
		$DBFilePath = realpath("../system/DBData/Installation.pfdb.php");
		$writable = new HTMLTable(1);
		$File = new File($DBFilePath);
		$File->loadMe();
		if(!$File->getA()->FileIsWritable){
			$writable->addRow("<img src=\"./images/navi/restrictions.png\" style=\"float:left;margin-right:10px;\"/>Die Datei ".$DBFilePath." ist nicht beschreibbar, Änderungen können nicht gespeichert werden.<br /><br />Machen Sie die Datei mit einem FTP-Programm beschreibbar. Klicken Sie dazu mit der rechten Maustaste auf die Datei auf dem Server, wählen Sie \"Eigenschaften\", und geben Sie den Modus 666 an, damit sie durch den Besitzer, die Gruppe und alle Anderen les- und schreibbar ist.");
			$g .= $writable->getHTML();
		}
		
		$gui = new HTMLGUI();
		$gui->setName("Datenbank-Zugangsdaten");
		if($this->collector != null) $gui->setAttributes($this->collector);
		
		$gui->setCollectionOf($this->collectionOf,"Datenbank-Zugangsdaten");
		$gui->hideAttribute("password");
		$gui->hideAttribute("httpHost");
		$gui->hideAttribute("InstallationID");

		if(strstr($_SERVER["SCRIPT_FILENAME"],"demo")) {
			$UA = $_SESSION["S"]->getCurrentUser()->getA();
			if($UA->name != "Installations-Benutzer"){
				$g = "In der Demo können keine Datenbank-Zugangsdaten geändert werden!";
				$gui->setIsDisplayMode(true);
			}
		}

		#try {
			$g .= $gui->getBrowserHTML($id);
		#} catch (Exception $e){
		#	$t->addRow(array("Etwas stimmt nicht, eine ".get_class($e)." wurde abgefangen!"));
		#	$t->addRow(array("<span style=\"font-size:8px;\">".nl2br(str_replace("#","\n#", $e->getTraceAsString()))."</span>"));
		#}
		try {
			$user = new User(1);
			$user->loadMe();
		}
		catch (DatabaseNotSelectedException $e) {
			$t->addRow(isset($text["noDatabase"]) ? $text["noDatabase"] : "Es wurde kein korrekter Datenbankname angegeben.<br /><br />Bitte geben Sie eine existierende Datenbank an, sie wird nicht automatisch erzeugt.");
			return $g.$t->getHTML();
		}
		catch (NoDBUserDataException $e) { 
			$t->addRow(isset($text["wrongData"]) ? $text["wrongData"] : "Die angegebenen Datenbank-Zugangsdaten sind nicht korrekt.<br /><br />Wenn sie korrekt sind, wird hier eine Liste der Plugins angezeigt.");
			return $g.$t->getHTML();
		}
		catch (DatabaseNotFoundException $e) {
			$t->addRow(isset($text["noDatabase"]) ? $text["noDatabase"] : "Es wurde kein korrekter Datenbankname angegeben.<br /><br />Bitte geben Sie eine existierende Datenbank an, sie wird nicht automatisch erzeugt.");
			return $g.$t->getHTML();
		}
		catch (TableDoesNotExistException $e) {}
		catch (StorageException $e) {}
		
		if($id == -1) {
			$BackupTab = new HTMLTable(1);

			$BackupButton = new Button("Backup-\nManager","disk");
			$BackupButton->style("float:right;");
			$BackupButton->onclick("contentManager.loadFrame('contentLeft','BackupManager');");

			$BackupTab->addRow($BackupButton);

			$g .= "
	<div style=\"height:30px;\"></div>
	$BackupTab
	<div class=\"Tab backgroundColor1\"><p>Plugins</p></div>
	<table>
		<colgroup>
			<col style=\"width:100px;\" class=\"backgroundColor3\" />
			<col class=\"backgroundColor2\" />
		</colgroup>
		<tr>
			<td colspan=\"3\" class=\"backgroundColor3\">
				<input
					type=\"button\"
					value=\"".(isset($text["neue Plugins laden"]) ? $text["neue Plugins laden"] : "neue Plugins\nladen")."\"
					style=\"float:right;background-image:url(./images/navi/refresh.png);\"
					class=\"bigButton backgroundColor2\"
					onclick=\"reloadApp();\"
				/>
				<input
					type=\"button\"
					value=\"".(isset($text["alle Tabellen aktualisieren"]) ? $text["alle Tabellen aktualisieren"] : "alle Tabellen\naktualisieren")."\"
					style=\"background-image:url(./images/navi/update.png);\"
					class=\"bigButton backgroundColor2\"
					onclick=\"rme('mInstallation','','updateAllTables','','$(\'contentLeft\').update(transport.responseText);');\"
				/>
			</td>
		</tr>
		<tr>
			<td style=\"background-color:white;\"></td>
		</tr>";

			$p = array_flip($_SESSION["CurrentAppPlugins"]->getAllPlugins());
			
			$showHelp = true;
			
			foreach($p as $key => $value){
				try {
					if(method_exists($_SESSION["CurrentAppPlugins"], "isPluginGeneric") AND $_SESSION["CurrentAppPlugins"]->isPluginGeneric($key)){
						$c = new mGenericGUI('', $key);
					} else {
						$c = new $key();
					}
				} catch (ClassNotFoundException $e){
					$key2 = $key."GUI";
					
					try {
						$c = new $key2();
					} catch (ClassNotFoundException $e2){
						continue;
					}
				}
				if($key == "CIs") continue;
				
				$e = explode(", ",$_SESSION["CurrentAppPlugins"]->getDepsOfPlugin($key));
				for($i=0;$i<count($e);$i++) 
					if($e[$i] != "none") 
						$e[$i] = (($p[$e[$i]] != -1) ? $p[$e[$i]] : $e[$i]);

				if($c->checkIfMyTableExists()) $showHelp = false;
						
				$g .= "
		<tr>
			<td style=\"font-weight:bold;text-align:right;\">".($value != -1 ? $value : $key )."</td>
			<td>".(!$c->checkIfMyTableExists() ? ($c->checkIfMyDBFileExists() ? "<input type=\"button\" value=\"".(isset($text["Tabelle anlegen"]) ? $text["Tabelle anlegen"] : "Tabelle anlegen")."\" onclick=\"installTable('$key');\" />" : "keine DB-Info-Datei" ) : ($c->checkIfMyDBFileExists() ? "<input type=\"button\" onclick=\"checkFields('$key');\" value=\"Tabellenupdate\" style=\"float:right;width:140px;\" />".(isset($text["Tabelle existiert"]) ? $text["Tabelle existiert"] : "Tabelle existiert") : (isset($text["keine DB-Info-Datei"]) ? $text["keine DB-Info-Datei"] : "keine DB-Info-Datei"))."")."</td>
		</tr>
		<!--<tr>
			<td style=\"background-color:white;\"></td>
			<td style=\"text-align:right;\">Abh. von:</td>
			<td colspan=\"2\">".($e[0] == "none" ? "-" : implode(", ",$e))."</td>
		</tr>
		<tr>
			<td style=\"background-color:white;\"></td>
		</tr>-->";
			}
			$g .= "
	</table>";
		}
		
		if($showHelp)			
			$help = "
	<script type=\"text/javascript\">
		rme('mInstallation','','getHelp','','if(checkResponse(transport)) { Popup.create(\'123\', \'Installation\', \'Hilfe\'); Popup.update(transport, \'123\', \'Installation\'); }');
	</script>";
		else $help = "";
		
		return $g.$help;
	}
	
	public function getHelp(){
		$DBFilePath = realpath("../system/DBData/Installation.pfdb.php");
		$File = new File($DBFilePath);
		$File->loadMe();
		
		
		$BH = new Button("Hilfe","hilfe");
		$BH->style("float: left; margin-right: 10px;");
		$BH->type("icon");
				
		echo "<p style=\"padding:5px;\">
		$BH
		<b>".$_SESSION["applications"]->getActiveApplication()." ist auf diesem Server noch nicht installiert.</b>
		</p>
		".(!$File->getA()->FileIsWritable ? "<p style=\"padding:5px;\">
		Bitte machen Sie die Datei Installation.pfdb.php beschreibbar, wie rechts oben angegeben.
		</p>" : "")."
		<p style=\"padding:5px;\">
		Tragen Sie die Datenbank-Zugangsdaten ein, die Sie von Ihrem Webspace-Provider erhalten.
		</p>
		<p style=\"padding:5px;\">
		Wenn die Zugangsdaten richtig sind, erscheinen weitere Zeilen. Klicken Sie für jedes Plugin auf \"Tabelle anlegen\".
		</p>
		<p style=\"padding:5px;\">
		Wenn Sie alle Tabellen angelegt haben, legen Sie im Benutzer-Reiter noch einen </b>Benutzer ohne Admin-Rechte</b> an und ändern Sie das Admin-Passwort.
		</p>";
	}
}
?>
