<?php
/*
 *  This file is part of phynx.

 *  phynx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.

 *  phynx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  2007, 2008, 2009, 2010, Rainer Furtmeier - Rainer@Furtmeier.de
 */
class mPatchGUI extends anyC implements iGUIHTML2 {
	function getHTML($id){
		$this->addOrderV3("PatchID");
		$this->lCV3($id);
		
		$gui = new HTMLGUI();
		$gui->setName("Updates");
		$gui->setAttributes($this->collector);
		$gui->setCollectionOf($this->collectionOf, "Update");
		
		$gui->setShowAttributes(array("PatchDescription","PatchExecuted"));
		
		$gui->setParser("PatchExecuted","Util::catchParser");
		$gui->setParser("PatchDescription","mPatchGUI::descriptionParser");
		
		#$gui->setIsDisplayMode(true);
		#$gui->setEditInDisplayMode(true,"contentLeft");
		#$gui->setDeleteInDisplayMode(false);
		
		if($id == -1) $html = "
		<table>
			<colgroup>
				<col class=\"backgroundColor3\" />
			</colgroup>
			<tr>
				<td>
					".($_SERVER["HTTP_HOST"] == "dev.furtmeier.lan" ? "<input
						style=\"float:right;\"
						onclick=\"windowWithRme('mPatch','','getXML','');\"
						type=\"button\"
						class=\"bigButton backgroundColor2\"
						value=\"XML\nerzeugen\"
					/>" : "")."
					<input
						style=\"background-image:url(./images/navi/refresh.png);\"
						onclick=\"rme('mPatch','','update','','if(transport.responseText != \'error\') reloadRightFrame(); else new Effect.BlindDown(\'errorMessage\');');\"
						type=\"button\"
						class=\"bigButton backgroundColor2\"
						value=\"Updates\naktualisieren\"
					/>
					<div id=\"errorMessage\" style=\"display:none;color:red;\">Es konnte keine Verbindung zum Updates-Server hergestellt werden.<br />Bitte stellen Sie folgende Voraussetzungen sicher:
					<ul>
						<li>Der Server mit Ihrer Installation kann eine Verbindung ins Internet aufbauen.</li>
						<li>Sie benutzen die aktuellste Version des Update-Plugins.</li>
					</ul></div>
				</td>
			</tr>
		</table>";
		else $html = "";
		try {
			return $html.$gui->getBrowserHTML($id);
		} catch (Exception $e){ }
		return $html;
	}
	
	public static function descriptionParser($w){
		return nl2br($w);
	}
	
	public function runUpdate($XML){
		$XML->lCV3();
		while($t = $XML->getNextEntry()) {
			$ac = new anyC();
			$ac->setCollectionOf("Patch");
			$ac->addAssocV3("PatchNummer","=",$t->getA()->PatchNummer);
			$P = $ac->getNextEntry();
			
			if($P == null) $t->newMe();
			elseif($P->getA()->PatchDate < $t->getA()->PatchDate) {
				$nP = new Patch($P->getID());
				$nP->setA($t->getA());
				$nP->saveMe();
			}
		}
		
	}
	
	public function localUpdate($xmlString){
		$XML = new XMLC();
		$XML->setXML($xmlString);
		$this->runUpdate($XML);
	}
	
	public function update(){
		$XML = new XMLC("http://www.open3a.de/updates.xml");
		$this->runUpdate($XML);
	}
	
	public function getXML(){
		#$this->addAssocV3("PatchNummer","<", "1000000");
		$this->lCV3();
		$XML = new XML();
		$XML->setCollection($this);
		$XML->setXMLHeader();
		echo $XML->getXML();
	}
}
?>